var GameData = function()
{
};

GameData.BuildTitle     = 'Solitaire Pro 3';
GameData.BuildString    = '01.04.2020';
GameData.BuildDebug     = false;
GameData.BuildVersion   = "1.0.0";

GameData.CreditsStaff   = 'Inlogic Games 2020';

GameData.ProfileName    = 'inl-sltr-pr3';

GameData.Reset = function()
{
    GameData.profile = {};

    GameData.profile.PlayerCoins = 0;
    GameData.profile.Draw1 = true;

    GameData.profile.CardFaces = [0, 50, 150, 300];
    GameData.profile.CardBacks = [0, 25, 50, 75, 100, 125, 150, 175, 200, 225, 250];

    GameData.profile.UsedCardFace = 0;
    GameData.profile.UsedCardBack = 0;

    GameData.profile.Achievements = [];
    for(var i = 0; i < Achievements.length; i++)
        GameData.profile.Achievements[i] = 0;

    GameData.profile.LasVegasScore = false;
    GameData.profile.RightHanded = true;

    GameData.profile.TotalWinsD1 = 0;
    GameData.profile.TotalGamesD1 = 0;
    GameData.profile.BestScoreD1 = 0;
    GameData.profile.LeastMovesD1 = 0;
    GameData.profile.BestTimeD1 = 0;
    GameData.profile.MostMovesD1 = 0;
    GameData.profile.undoCounterD1 = 0;
    GameData.profile.hintCounterD1 = 0;

    GameData.profile.TotalWinsD3 = 0;
    GameData.profile.TotalGamesD3 = 0;
    GameData.profile.BestScoreD3 = 0;
    GameData.profile.LeastMovesD3 = 0;
    GameData.profile.BestTimeD3 = 0;
    GameData.profile.MostMovesD3 = 0;
    GameData.profile.undoCounterD3 = 0;
    GameData.profile.hintCounterD3 = 0;

    GameData.profile.retryCards = null;

    GameData.profile.DailyBonusDate = DateToStr(new Date());
};

GameData.Load = function()
{
    GameData.Reset();

    var profile = null;

    try{
        profile = JSON.parse(localStorage.getItem(GameData.ProfileName));
        if(profile != null)
            GameData.profile = profile;
    }catch(e){
    }

    //PPS_USE-GRANDTECHNOLOGY
    /*
    var storedData = getPlayITsavedDataVar('slgrData');
    if (storedData != null) {
        GameData.profile = JSON.parse(storedData);
    }
    //PPS_USE-GRANDTECHNOLOGY
    */

};

GameData.Save = function()
{

    GameData.profile['msc'] = soundManager.musicPlaying;
    GameData.profile['snd'] = soundManager.soundPlaying;

    try{
        localStorage.setItem(GameData.ProfileName, JSON.stringify(GameData.profile));
    }catch(e){
    }

    //PPS_USE-GRANDTECHNOLOGY
    /*
    savePlayItData({'slgrData': JSON.stringify(GameData.profile)});
    //PPS_USE-GRANDTECHNOLOGY
    */
};

function getProfileVar(varName)
{
    if(GameData.profile == null)
        return null;

    if(GameData.profile.hasOwnProperty(varName))
        return GameData.profile[varName];

    return null;
}
