CoinParticles = function(grp)
{
    this.MAX_PARTICLES = 10;
    this.DURATION = ScenesTransitions.TRANSITION_LENGTH * 2;
    this.DELAY = ScenesTransitions.TRANSITION_LENGTH / 3;

    this.objCoinParticles = [];
    this._init();

    CoinParticles.instance = this;
},

CoinParticles.instance = null;

CoinParticles.prototype =
{
    constructor: CoinParticles,

    _init: function(grp) {
        for (var i = 0; i < 10; i++) {
            this.objCoinParticles[i] = game.add.sprite(-1000, -1000, 'pak1', 'mincaB');
            this.objCoinParticles[i].anchor.set(0.5);
            this.objCoinParticles[i].twnMove = null;
            this.objCoinParticles[i].twnScale = null;
        }
    },

    Reset: function()
    {
        for (var i = 0; i < this.objCoinParticles.length; i++){
            this.objCoinParticles[i].visible = false;

            if(this.objCoinParticles[i].twnMove != null)
                this.objCoinParticles[i].twnMove.stop();
            if(this.objCoinParticles[i].twnScale != null)
                this.objCoinParticles[i].twnScale.stop();
            game.tweens.removeFrom(this.objCoinParticles[i], true);
        }
    },

    AnimateCoins: function(value, srcSprite, dstSprite, txtSrc, txtDst, callbackOnComplete, params, scaleInit, scaleTo)
    {
        if(callbackOnComplete === undefined)
            callbackOnComplete = null;
        if(params === undefined)
            params = null;
        if(scaleInit === undefined)
            scaleInit = 0.7;
        if(scaleTo === undefined)
            scaleTo = 0.5;

        ScenesTransitions.transitionStarted();

        txtDst.val = parseInt(txtDst.text);

        var finalVal = txtDst.val + value;

        var cnt = value;
        var lastVal = 0;
        var divNum = Math.ceil(value / 10);
        if(divNum < 1) divNum = 1;

        if(value > 10){
            cnt = Math.floor(value / divNum);
            lastVal = value - (cnt * divNum);
        }

        CoinParticles.instance.Reset();

        var dx = srcSprite.width * (srcSprite.anchor.x - 0.5);

        for (var i = 0; i < cnt; i++) {
            var delta = divNum;
            if( i == cnt - 1) delta += lastVal;
            value -= delta;

            this.objCoinParticles[i].position.setTo(srcSprite.worldPosition.x - dx, srcSprite.worldPosition.y);
            this.objCoinParticles[i].scale.set(scaleInit);
            this.objCoinParticles[i].visible = true;

            var callback = function(){

            };
            gameState.MoveSpriteBezier(this.objCoinParticles[i], dstSprite.worldPosition.x, dstSprite.worldPosition.y, this.DURATION, i * this.DELAY, 1, callback, null);
            this.objCoinParticles[i].twnScale = game.add.tween(this.objCoinParticles[i].scale);
            this.objCoinParticles[i].twnScale.to( { x: scaleTo, y:scaleTo}, this.DURATION, "Linear", true, i * this.DELAY);
            this.objCoinParticles[i].twnScale.onStart.add(function(){
                soundManager.playSound('coins');
                this.txtObj.text = '' + this.val;
            }, {coinParticle: this.objCoinParticles[i], txtObj: txtSrc, val: value});
            this.objCoinParticles[i].twnScale.onComplete.add(function(){
                this.txtObj.val += this.inc;
                this.txtObj.text = '' + this.txtObj.val;
                this.coinParticle.visible = false;
                if(this.lastOne){
                    ScenesTransitions.transitionFinished();
                    this.txtObj.text = '' + this.finalVal;
                    if(callbackOnComplete != null)
                        callbackOnComplete(this.params);
                }
            }, {coinParticle: this.objCoinParticles[i], txtObj: txtDst, inc: delta, finalVal: finalVal, lastOne: (i == cnt - 1), callback:callbackOnComplete, params: params });
            //to: function (properties, duration, ease, autoStart, delay, repeat, yoyo)
        }
    }


}

