var SceneAbout = function () {
    SceneAbout.instance = this;

    this.create();
};

SceneAbout.instance = null;

SceneAbout.prototype = {

    create: function () {
        grpSceneAbout = game.add.group();
        grpSceneAbout.name = 'grpSceneAbout';

        imgAboutBG = game.make.sprite(game.width >> 1, game.height >> 1, 'bg');
        imgAboutBG.anchor.set(0.5);
        imgAboutBG.inputEnabled = true;
        grpSceneAbout.addChild(imgAboutBG);

        topBarAbout = gameState.CreateCaptionBar(grpSceneAbout, 'ABOUT');

        imgAboutAnchor = game.make.sprite(0, 0, 'pak1', 'blank');
        imgAboutAnchor.anchor.set(0);
        imgAboutBG.addChild(imgAboutAnchor);

        var exitBtn = game.make.sprite(0, 0, 'pak1', 'close');
        exitBtn.scale.set(0.9);
        exitBtn.anchor.setTo(1, 0);
        topBarAbout.itemAnchor.addChild(exitBtn);
        AddButtonEvents(exitBtn, function () {
            soundManager.playSound('menu-click1');
            SceneAbout.instance.HideAnimated();
        }, ButtonOnInputOver, ButtonOnInputOut);
        this.exitBtn = exitBtn;

        var contentGroup = game.make.group();
        this.contentGroup = contentGroup;
        grpSceneAbout.addChild(contentGroup);
        contentGroup.y = game.height * 0.55;

        var abt2_img = game.make.sprite(game.width / 2, 0, 'inlogic_logo');
        abt2_img.scale.set(game.width / 680 * 0.8);
        abt2_img.anchor.set(0.5);
        contentGroup.addChild(abt2_img);

        var prevRU = GAMEFONT === 'gamefont_RU';

        if (prevRU) GAMEFONT = 'gamefont_TA';

        // var abt1_txt = game.make.text(game.width / 2, abt2_img.y - abt2_img.height * 0.8, GameData.BuildTitle.toUpperCase(), { font: 43 + 'px gameFont', fill: '#B8B8B8' });
        var abt1_txt = gameState.CreateText(game.width / 2, abt2_img.y - abt2_img.height * 0.8, 'gamefont', GameData.BuildTitle.toUpperCase(), 43);
        abt1_txt.tint = '0xB8B8B8';
        abt1_txt.anchor.set(0.5);
        abt1_txt.scale.set(game.width / 680);
        contentGroup.addChild(abt1_txt);

        // var abt3_txt = game.make.text(game.width / 2, abt2_img.y + abt2_img.height * 0.8, 'v' + GameData.BuildVersion + '\n' + GameData.CreditsStaff, { font: 37 + 'px gameFont', fill: '#B8B8B8', align: 'center' });
        var abt3_txt = gameState.CreateText(game.width / 2, abt2_img.y + abt2_img.height * 0.8, 'gamefont', 'v' + GameData.BuildVersion + '\n' + GameData.CreditsStaff, 37);
        abt3_txt.tint = '0xB8B8B8';
        abt3_txt.align = 'center';
        abt3_txt.anchor.set(0.5);
        abt3_txt.scale.set(game.width / 680);
        contentGroup.addChild(abt3_txt);

        if (prevRU) GAMEFONT = 'gamefont_RU';

        grpSceneAbout.visible = false;

        this.onResolutionChange();
    },

    onResolutionChange: function () {
        imgAboutBG.width = game.width * 1.1;
        imgAboutBG.height = game.height * 1.1;
        imgAboutBG.position.setTo(game.width >> 1, game.height >> 1);//game.width >> 1, game.height >> 1);

        imgAboutAnchor.scale.setTo(1 / imgAboutBG.scale.x, 1 / imgAboutBG.scale.y);

        itemH = game.height / 10;

        topBarAbout.width = game.width * 1.1;
        topBarAbout.height = itemH;
        topBarAbout.itemAnchor.scale.setTo(1 / topBarAbout.scale.x, 1 / topBarAbout.scale.y);
        topBarAbout.y = topBarAbout.height / 2;
        topBarAbout.x = game.width >> 1;

        this.contentGroup.y = game.height * 0.55;

        this.exitBtn.position.set((game.width >> 1) - 12, -(this.exitBtn.height * 0.65))

    },

    updateTexts: function () {
        topBarAbout.txtCaption.text = STR(topBarAbout.STR);
    },

    ShowAnimated: function () {

        SceneAbout.instance.onResolutionChange();
        SceneAbout.instance.updateTexts();

        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
        ScenesTransitions.showSceneAlpha(grpSceneAbout, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
    },

    HideAnimated: function () {
        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
        ScenesTransitions.hideSceneAlpha(grpSceneAbout, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
    }
}