var SceneAchievements = function () {
    SceneAchievements.instance = this;

    this.create();
};

SceneAchievements.instance = null;

SceneAchievements.prototype = {

    create: function () {
        grpSceneAchievements = game.add.group();
        grpSceneAchievements.name = 'grpSceneAchievements';
        this.grpScene = grpSceneAchievements;

        imgAchievementsBG = grpSceneAchievements.create(game.width >> 1, game.height >> 1, 'bg');
        imgAchievementsBG.width = game.width * 1.1;
        imgAchievementsBG.height = game.height * 1.1;
        imgAchievementsBG.anchor.setTo(0.5);
        imgAchievementsBG.inputEnabled = true;

        AchievementsItems = [];

        var contentGroup = game.make.group();
        contentGroup.topY = 0;
        contentGroup.y = contentGroup.topY;
        this.contentGroup = contentGroup;
        grpSceneAchievements.addChild(contentGroup);

        for (var i = 0; i < Achievements.length; i++)
            AchievementsItems.push(this.CreateAchievementsItem(Achievements[i]));

        topBarAchievements = gameState.CreateCaptionBar(grpSceneAchievements, 'MENU_ACHIEVEMENTS');
        imgAchievementsCoinsHolder = gameState.CreateCoinsHolder(grpSceneAchievements, topBarAchievements);

        grpSceneAchievements.visible = false;

        game.input.onDown.add(this.instrClickDown, this);
        game.input.onUp.add(this.instrClickUp, this);
    },

    CreateAchievementsItem: function (achievement) {
        var AchievementsItemBG = this.contentGroup.create(game.width >> 1, game.height >> 1, 'pak1', 'podachieve');
        AchievementsItemBG.anchor.set(0.5);
        AchievementsItemBG.width = game.width;
        AchievementsItemBG.height = game.height / 8;
        //AchievementsItemBG.tint = 0x5BB2D1;
        AchievementsItemBG.inputEnabled = true;
        AchievementsItemBG.idx = AchievementsItems.length;
        AchievementsItemBG.achievement = achievement;

        var itemAnchor = this.contentGroup.create(0, 0, 'pak1', 'void');
        itemAnchor.anchor.set(0.5);
        AchievementsItemBG.addChild(itemAnchor);

        var txtTitle = gameState.CreateText(30, 0, 'gamefont', STR(achievement.title), 20);
        txtTitle.anchor.setTo(0, 0.5);
        txtTitle.tint = 0x000000;
        itemAnchor.addChild(txtTitle);

        var itemMarkDone = this.contentGroup.create(0, 0, 'pak1', 'markdone');
        itemMarkDone.anchor.setTo(0, 0.5);
        itemMarkDone.scale.set(0.5 * game.width / 680);
        itemAnchor.addChild(itemMarkDone);

        var txtDesc = gameState.CreateText(game.width * 0.04, 0, 'gamefont', STR(achievement.text), 27);
        txtDesc.anchor.setTo(0, 0.5);
        txtDesc.tint = 0xFFFFFF;
        itemAnchor.addChild(txtDesc);

        var txtReward = gameState.CreateText(game.width * 0.04, 0, 'gamefont', 'Reward', 17);
        txtReward.anchor.setTo(0.5);
        txtReward.tint = 0x000000;
        itemAnchor.addChild(txtReward);

        var txtCoins = gameState.CreateText(game.width * 0.04, 0, 'gamefont', '50', 27 * game.width / 680);
        txtCoins.anchor.setTo(1, 0.5);
        txtCoins.tint = 0xFFFFFF;
        itemAnchor.addChild(txtCoins);

        var itemCoin = this.contentGroup.create(0, game.width * 0.01, 'pak1', 'mincaB');
        itemCoin.anchor.setTo(0, 0.5);
        itemCoin.scale.set(game.width / 680 * 0.35);
        itemAnchor.addChild(itemCoin);

        var itemGlow = this.contentGroup.create(0, 0, 'pak1', 'glowpodachieve');
        itemGlow.anchor.setTo(0.5);
        itemGlow.scale.set(1.8 * game.width / 680);
        itemAnchor.addChild(itemGlow);

        var itemMedal = this.contentGroup.create(0, 0, 'pak1', 'kedsplnisachieve');
        itemMedal.anchor.setTo(0.5);
        itemMedal.scale.set(0.4);
        itemGlow.addChild(itemMedal);

        var itemBar = this.contentGroup.create(0, 10, 'pak1', 'achieve-bar');
        itemBar.anchor.setTo(0, 0.5);
        itemBar.scale.set(game.width / 680 * 1.1);
        itemAnchor.addChild(itemBar);

        var itemBarFull = this.contentGroup.create(0, 0, 'pak1', 'achieve-full');
        itemBarFull.anchor.setTo(0, 0.5);
        itemBarFull.WIDTH = itemBarFull.width;
        itemBarFull.width = itemBarFull.WIDTH;
        itemBar.addChild(itemBarFull);

        var itemBarStart = this.contentGroup.create(0, 0, 'pak1', 'achieve-start');
        itemBarStart.anchor.setTo(0, 0.5);
        itemBar.addChild(itemBarStart);

        var itemBarEnd = this.contentGroup.create(0, 0, 'pak1', 'achieve-end');
        itemBarEnd.anchor.setTo(0, 0.5);
        itemBar.addChild(itemBarEnd);

        var itemButtonClaim = grpSceneThemes.create(0, 0, 'pak1', 'smallbutton');
        itemButtonClaim.anchor.setTo(0.5);
        itemButtonClaim.scale.set(0.45 * game.width / 680);
        itemAnchor.addChild(itemButtonClaim);
        AddButtonEvents(itemButtonClaim, SceneAchievements.instance.ClaimAchievementPrize, ButtonOnInputOver, ButtonOnInputOut);

        var txtClaim = gameState.CreateText(0, 0, 'gamefont', 'Claim', 38);
        txtClaim.anchor.setTo(0.5, 0.65);
        txtClaim.tint = 0x000000;
        txtClaim.align = 'center';
        itemAnchor.addChild(txtClaim);

        AchievementsItemBG.itemAnchor = itemAnchor;
        AchievementsItemBG.txtTitle = txtTitle;
        AchievementsItemBG.itemMarkDone = itemMarkDone;
        AchievementsItemBG.txtReward = txtReward;
        AchievementsItemBG.txtDesc = txtDesc;
        AchievementsItemBG.itemBar = itemBar;
        AchievementsItemBG.itemBarFull = itemBarFull;
        AchievementsItemBG.itemBarStart = itemBarStart;
        AchievementsItemBG.itemBarEnd = itemBarEnd;
        AchievementsItemBG.itemCoin = itemCoin;
        AchievementsItemBG.itemGlow = itemGlow;
        AchievementsItemBG.itemButtonClaim = itemButtonClaim;
        AchievementsItemBG.txtCoins = txtCoins;
        AchievementsItemBG.txtClaim = txtClaim;

        return AchievementsItemBG;
    },

    ClaimAchievementPrize: function () {
        soundManager.playSound('claim');

        var imgAchievement = this.button.parent.parent;
        coinParticles.AnimateCoins(imgAchievement.achievement.price, imgAchievement.itemCoin, imgAchievementsCoinsHolder.itemCoin, imgAchievement.txtCoins, imgAchievementsCoinsHolder.txtPrice, function (item) {
            SceneAchievements.instance.UpdateAchievementsItem(item);
            SceneMenu.instance.UpdateAchievementsNotification();
        }, imgAchievement, 0.3 * game.width / 680, 0.5 * game.width / 680);
        GameData.profile.Achievements[imgAchievement.idx] = -1;
        GameData.profile.PlayerCoins += imgAchievement.achievement.price;
        GameData.Save();
    },

    onResolutionChange: function () {
        imgAchievementsCoinsHolder.txtPrice.text = '' + GameData.profile.PlayerCoins;

        imgAchievementsBG.position.setTo(game.width >> 1, game.height >> 1);
        imgAchievementsBG.width = game.width * 1.1;
        imgAchievementsBG.height = game.height * 1.1;

        var itemGap = game.width * 0.007;
        var itemH = game.height * 0.1;

        topBarAchievements.width = game.width * 1.1;
        topBarAchievements.height = itemH;

        itemH = game.height / 9;

        topBarAchievements.itemAnchor.scale.setTo(1 / topBarAchievements.scale.x, 1 / topBarAchievements.scale.y);
        topBarAchievements.y = topBarAchievements.height / 2;

        var posY = topBarAchievements.height + itemGap + itemH / 2;

        scrollAch = false;

        for (var i = 0; i < AchievementsItems.length; i++) {
            SceneAchievements.instance.UpdateAchievementsItem(AchievementsItems[i]);
            AchievementsItems[i].y = posY;
            posY += itemGap + itemH;

            if (AchievementsItems[i].itemGlow.visible) {
                AchievementsItems[i].txtTitle.tint = 0xB8B8B8;
            }

        }

        gameState.wheelScrolled = 0;
        this.contentGroup.totalHeight = AchievementsItems[AchievementsItems.length - 1].y + AchievementsItems[AchievementsItems.length - 1].height * 2;
        this.contentGroup.y = this.contentGroup.topY;

        if (scrollAch !== false) {
            this.contentGroup.y = - scrollAch.y + scrollAch.height / 2 + topBarAchievements.height;

            if (this.contentGroup.y > this.contentGroup.topY) {
                this.contentGroup.y = this.contentGroup.topY;
            } else if (this.contentGroup.y < 0 - this.contentGroup.totalHeight + game.height) {
                this.contentGroup.y = - this.contentGroup.totalHeight + game.height;
            }
        }

        // updateTextToWidth(imgAchievementsCoinsHolder.children[1], 40 * game.width / 680, 'gameFont', (imgAchievementsCoinsHolder.width - imgAchievementsCoinsHolder.children[0].width));
        SceneAchievements.instance.updateSceneElementsVisibility();
    },

    UpdateAchievementsItem: function (achievementItem) {
        var perc = GameData.profile.Achievements[achievementItem.idx] / achievementItem.achievement.count;
        if (perc > 1) perc = 1;
        if (perc === 1)
            scrollAch = achievementItem;

        achievementItem.itemBarFull.width = achievementItem.itemBarFull.WIDTH * perc;
        achievementItem.frameName = (perc < 0) ? 'podsplnenyachieve' : 'podachieve';

        var completed = (perc >= 1);

        achievementItem.width = game.width;
        achievementItem.height = itemH;
        achievementItem.itemAnchor.scale.setTo(1 / achievementItem.scale.x, 1 / achievementItem.scale.y);
        achievementItem.txtTitle.x = - game.width / 2 + game.width * 0.06;
        achievementItem.txtTitle.y = -itemH * 0.25;
        achievementItem.txtDesc.x = - game.width / 2 + game.width * 0.06;
        achievementItem.txtDesc.y = 5;//itemH * 0.1;
        achievementItem.txtReward.x = (game.width >> 1) / 7 * 5;
        achievementItem.txtReward.y = achievementItem.txtTitle.y;
        achievementItem.itemMarkDone.y = achievementItem.txtTitle.y;
        achievementItem.itemMarkDone.x = achievementItem.txtTitle.right + 7;

        achievementItem.itemBar.visible = (perc >= 0);
        achievementItem.txtReward.visible = ((perc >= 0) && (perc < 1));
        achievementItem.txtCoins.visible = (perc >= 0);
        achievementItem.itemCoin.visible = (perc >= 0);
        achievementItem.itemBar.visible = (perc >= 0);
        achievementItem.itemGlow.visible = (perc < 0);
        achievementItem.itemMarkDone.visible = (perc < 0);
        achievementItem.itemButtonClaim.visible = completed;
        achievementItem.txtClaim.visible = completed;

        achievementItem.itemBar.x = -game.width / 2 + game.width * 0.06;
        achievementItem.itemBar.y = itemH * 0.35;
        achievementItem.itemBarStart.x = 0;
        achievementItem.itemBarFull.x = achievementItem.itemBarStart.right - 1;
        achievementItem.itemBarEnd.x = achievementItem.itemBarFull.right - 1;

        achievementItem.itemBarStart.visible = (perc > 0);
        achievementItem.itemBarFull.visible = (perc > 0);
        achievementItem.itemBarEnd.visible = (perc > 0);

        achievementItem.txtCoins.x = achievementItem.txtReward.x;
        achievementItem.itemCoin.x = achievementItem.txtReward.x;
        achievementItem.itemGlow.x = achievementItem.itemCoin.x;
        achievementItem.itemButtonClaim.x = achievementItem.txtReward.x;

        achievementItem.txtCoins.text = '' + achievementItem.achievement.price;
        achievementItem.txtCoins.y = completed ? achievementItem.txtTitle.y : achievementItem.txtDesc.y;
        achievementItem.itemCoin.y = achievementItem.txtCoins.y + (achievementItem.itemCoin.height >> 3);
        achievementItem.itemButtonClaim.y = itemH * 0.22;

        achievementItem.txtClaim.position.setTo(achievementItem.itemButtonClaim.x, achievementItem.itemButtonClaim.y);
        achievementItem.txtClaim.text = STR('CLAIM');

        if (achievementItem.itemGlow.visible) {
            achievementItem.txtTitle.tint = 0xB8B8B8;
            achievementItem.txtTitle.y += itemH * 0.08;
            achievementItem.txtDesc.y += itemH * 0.08;
            achievementItem.itemMarkDone.y = achievementItem.txtTitle.y;
        }

        updateBitmapTextToWidth(achievementItem.txtTitle, 25 * game.width / 680, game.width * 0.7);
        updateBitmapTextToWidth(achievementItem.txtDesc, 25 * game.width / 680, game.width * 0.7);
        updateBitmapTextToWidth(achievementItem.txtReward, 25 * game.width / 680, game.width * 0.2);
        updateBitmapTextToWidth(achievementItem.txtClaim, 30 * game.width / 680, achievementItem.itemButtonClaim.width * 0.8);

    },

    update: function () {
        if (grpSceneAchievements.visible === false) return;

        if (this.contentMoveType !== null) {
            this.moveScreenContent();

        }

        if (gameState.wheelScrolled != 0) {
            if (gameState.wheelScrolled > 0 && gameState.wheelScrolled - 2 > 0) {
                gameState.wheelScrolled -= 2;
            } else if (gameState.wheelScrolled < 0 && gameState.wheelScrolled + 2 < 0) {
                gameState.wheelScrolled += 2;
            } else {
                gameState.wheelScrolled = 0;
            }

            this.moveScreenContent();
        }
    },

    moveScreenContent: function () {
        var dif = 0;
        var newY;

        if (this.contentMoveType === 0) {
            dif = (game.input.activePointer.y - this.initClickY) << 1;
            // dif = (game.input.activePointer.y - this.initClickY);
            newY = this.contentOriginY + dif;
        } else if (gameState.wheelScrolled !== 0) {
            dif = gameState.wheelScrolled;
            newY = this.contentGroup.y + dif;
            this.contentMoveType = null;
        }

        if (dif !== 0) {
            if (newY > this.contentGroup.topY) {
                this.contentGroup.y = this.contentGroup.topY;
            } else if (newY < 0 - this.contentGroup.totalHeight + game.height) {
                this.contentGroup.y = - this.contentGroup.totalHeight + game.height;
            } else {
                this.contentGroup.y = newY;
            }
        }

        SceneAchievements.instance.updateSceneElementsVisibility();
    },

    updateSceneElementsVisibility: function () {
        for (var i = 0; i < SceneAchievements.instance.contentGroup.length; i++) {
            var obj = SceneAchievements.instance.contentGroup.children[i];
            var bottom = obj.bottom + SceneAchievements.instance.contentGroup.y;
            var top = obj.top + SceneAchievements.instance.contentGroup.y;
            obj.visible = (bottom >= topBarAchievements.height) && (top <= game.height - imgMenuBar.height);
        }
    },

    instrClickDown: function (pointer) {
        if (grpSceneAchievements.visible === false) return;

        this.initClickY = pointer.y;

        this.contentOriginY = this.contentGroup.y;
        this.contentMoveType = 0;

    },

    instrClickUp: function (pointer) {
        if (grpSceneAchievements.visible === false) return;

        this.initClickY = null;
        this.contentMoveType = null;
    },

    updateTexts: function () {
        topBarAchievements.txtCaption.text = STR(topBarAchievements.STR);

        for (var i = 0; i < AchievementsItems.length; i++) {
            AchievementsItems[i].txtTitle.text = STR(AchievementsItems[i].achievement.title);
            AchievementsItems[i].txtDesc.text = STR(AchievementsItems[i].achievement.text);
            AchievementsItems[i].txtReward.text = STR('REWARD');

            AchievementsItems[i].itemMarkDone.y = AchievementsItems[i].txtTitle.y;
            AchievementsItems[i].itemMarkDone.x = AchievementsItems[i].txtTitle.right + 7;

            updateBitmapTextToWidth(AchievementsItems[i].txtTitle, 25 * game.width / 680, game.width * 0.7);
            updateBitmapTextToWidth(AchievementsItems[i].txtDesc, 25 * game.width / 680, game.width * 0.7);
            updateBitmapTextToWidth(AchievementsItems[i].txtReward, 25 * game.width / 680, game.width * 0.2);
            updateBitmapTextToWidth(AchievementsItems[i].txtClaim, 30 * game.width / 680, AchievementsItems[i].itemButtonClaim.width * 0.8);

        }
    },

    ShowAnimated: function () {
        grpSceneAchievements.position.setTo(0, 0);
        SceneAchievements.instance.onResolutionChange();

        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Quadratic.Out;
        ScenesTransitions.showSceneAlpha(grpSceneAchievements, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
    },

    HideAnimated: function () {
        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
        ScenesTransitions.hideSceneAlpha(grpSceneAchievements, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);

        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
    }
}

Achievements = [];

Achievements.push({
    title: 'ACHIEVEMENT_02_TIME2_TITLE_D1',
    text: 'ACHIEVEMENT_02_TIME2_TEXT',
    count: 1,
    price: 5,
    time: 3
});
ACHIEVEMENT_D1_TIME1 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_02_TIME2_TITLE_D3',
    text: 'ACHIEVEMENT_02_TIME2_TEXT_D3',
    count: 1,
    price: 5,
    time: 8
});
ACHIEVEMENT_D3_TIME1 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_01_TIME_TITLE_D1',
    text: 'ACHIEVEMENT_01_TIME_TEXT',
    count: 1,
    price: 15,
    time: 2
});
ACHIEVEMENT_D1_TIME2 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_01_TIME_TITLE_D3',
    text: 'ACHIEVEMENT_01_TIME_TEXT_D3',
    count: 1,
    price: 15,
    time: 6
});
ACHIEVEMENT_D3_TIME2 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_03_TIME3_TITLE_D1',
    text: 'ACHIEVEMENT_03_TIME3_TEXT',
    count: 1,
    price: 10,
    time: 5
});
ACHIEVEMENT_D1_TIME3 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_03_TIME3_TITLE_D3',
    text: 'ACHIEVEMENT_03_TIME3_TEXT',
    count: 1,
    price: 10,
    time: 6
});
ACHIEVEMENT_D3_TIME3 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_04_TIME4_TITLE_D1',
    text: 'ACHIEVEMENT_04_TIME4_TEXT',
    count: 1,
    price: 15,
    time: 7
});
ACHIEVEMENT_D1_TIME4 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_04_TIME4_TITLE_D3',
    text: 'ACHIEVEMENT_04_TIME4_TEXT',
    count: 1,
    price: 15,
    time: 8
});
ACHIEVEMENT_D3_TIME4 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_05_WIN1_TITLE_D1',
    text: 'ACHIEVEMENT_05_WIN1_TEXT',
    count: 1,
    price: 5
});
ACHIEVEMENT_WIN1_D1 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_05_WIN1_TITLE_D3',
    text: 'ACHIEVEMENT_05_WIN1_TEXT',
    count: 1,
    price: 5
});
ACHIEVEMENT_WIN1_D3 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_06_WIN2_TITLE_D1',
    text: 'ACHIEVEMENT_06_WIN2_TEXT',
    count: 3,
    price: 35
});
ACHIEVEMENT_WIN2_D1 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_06_WIN2_TITLE_D3',
    text: 'ACHIEVEMENT_06_WIN2_TEXT',
    count: 3,
    price: 35
});
ACHIEVEMENT_WIN2_D3 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_07_WIN3_TITLE_D1',
    text: 'ACHIEVEMENT_07_WIN3_TEXT',
    count: 100,
    price: 100
});
ACHIEVEMENT_WIN3_D1 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_07_WIN3_TITLE_D3',
    text: 'ACHIEVEMENT_07_WIN3_TEXT',
    count: 100,
    price: 200
});
ACHIEVEMENT_WIN3_D3 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_08_WIN4_TITLE_D1',
    text: 'ACHIEVEMENT_08_WIN4_TEXT',
    count: 1,
    price: 15
});
ACHIEVEMENT_BEATSCORE_D1 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_08_WIN4_TEXT_D3',
    text: 'ACHIEVEMENT_08_WIN4_TEXT',
    count: 1,
    price: 15
});
ACHIEVEMENT_BEATSCORE_D3 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_09_WIN5_TITLE_D1',
    text: 'ACHIEVEMENT_09_WIN5_TEXT',
    count: 25,
    price: 25
});
ACHIEVEMENT_NOVICE_D1 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_09_WIN5_TITLE_D3',
    text: 'ACHIEVEMENT_09_WIN5_TEXT',
    count: 25,
    price: 25
});
ACHIEVEMENT_NOVICE_D3 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_10_WIN7_TITLE_D1',
    text: 'ACHIEVEMENT_10_WIN7_TEXT',
    count: 50,
    price: 50
});
ACHIEVEMENT_EXPERT_D1 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_10_WIN7_TITLE_D3',
    text: 'ACHIEVEMENT_10_WIN7_TEXT',
    count: 50,
    price: 100
});
ACHIEVEMENT_EXPERT_D3 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_11_HELP_TITLE',
    text: 'ACHIEVEMENT_11_HELP_TEXT',
    count: 1,
    price: 5
});
ACHIEVEMENT_HINT1 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_12_HINT_TITLE',
    text: 'ACHIEVEMENT_12_HINT_TEXT',
    count: 25,
    price: 25
});
ACHIEVEMENT_HINT2 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_14_HINT3_TITLE',
    text: 'ACHIEVEMENT_14_HINT3_TEXT',
    count: 100,
    price: 50
});
ACHIEVEMENT_HINT3 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_15_UNDO_TITLE',
    text: 'ACHIEVEMENT_15_UNDO_TEXT',
    count: 1,
    price: 15
});
ACHIEVEMENT_UNDO1 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_16_UNDO2_TITLE',
    text: 'ACHIEVEMENT_16_UNDO2_TEXT',
    count: 25,
    price: 75
});
ACHIEVEMENT_UNDO2 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_19_MOVING_TITLE',
    text: 'ACHIEVEMENT_19_MOVING_TEXT',
    count: 250,
    price: 75
});
ACHIEVEMENT_CARDS1 = Achievements.length - 1;

Achievements.push({
    title: 'ACHIEVEMENT_20_MOVING2_TITLE',
    text: 'ACHIEVEMENT_20_MOVING2_TEXT',
    count: 1000,
    price: 150
});
ACHIEVEMENT_CARDS2 = Achievements.length - 1;

