
var SceneAutocomplete = function () {
    SceneAutocomplete.instance = this;

    this.create();
};

SceneAutocomplete.instance = null;

SceneAutocomplete.prototype = {

    create: function () {
        grpAutocomplete = game.add.group();
        grpAutocomplete.name = "grpAutocomplete";
        this.grpScene = grpAutocomplete;

        imgAutocompleteOverlay = game.add.sprite(game.width >> 1, game.height >> 1, 'pak1', 'blank');
        imgAutocompleteOverlay.anchor.setTo(0.5, 0.5);
        imgAutocompleteOverlay.tint = 0x354854;
        imgAutocompleteOverlay.alpha = 0.7;
        imgAutocompleteOverlay.inputEnabled = true;
        grpAutocomplete.addChild(imgAutocompleteOverlay);

        imgAutocompleteBar = game.add.sprite(game.width >> 1, 0, 'pak1', GetSelectedThemeAchievementBar());
        imgAutocompleteBar.anchor.setTo(0.5, 0.5);
        grpAutocomplete.addChild(imgAutocompleteBar);

        txtAutocompleteTitle = gameState.CreateText(0, -imgAutocompleteBar.height / 6, 'gamefont', STR('INGAME_AUTOCOMPLETE_QUESTION'), 35 * game.width / 680);
        txtAutocompleteTitle.anchor.setTo(0.5, 0.5);
        txtAutocompleteTitle.tint = 0x000000;
        grpAutocomplete.addChild(txtAutocompleteTitle);

        btnAutocomplete1 = (gameState.CreateImgButtonWithText(grpAutocomplete, 'smallbutton', STR('YES'), function () {
            soundManager.playSound('menu-click1');
            gameAutocomplete = true;
            if (scnGame.checkCardSlotsForAutoplace())
                ScenesTransitions.transitionStarted();
            ScenesTransitions.hideSceneAlpha(grpAutocomplete);
        }, 0x000000));
        grpAutocomplete.addChild(btnAutocomplete1);
        btnAutocomplete1.scale.set(0.8 * game.width / 680);
        btnAutocomplete1.str = 'YES';

        btnAutocomplete2 = (gameState.CreateImgButtonWithText(grpAutocomplete, 'smallbutton', STR('NO'), function () {
            soundManager.playSound('menu-click1');
            gameAutocomplete = false;
            ScenesTransitions.hideSceneAlpha(grpAutocomplete);
        }, 0x000000));
        grpAutocomplete.addChild(btnAutocomplete2);
        btnAutocomplete2.scale.set(0.8 * game.width / 680);
        btnAutocomplete2.str = 'NO';

        grpAutocomplete.visible = false;
    },

    onResolutionChange: function () {
        imgAutocompleteOverlay.width = game.width * 1.1;
        imgAutocompleteOverlay.height = game.height * 1.1;
        imgAutocompleteOverlay.position.setTo(game.width >> 1, game.height >> 1);

        var itemH = game.height / 8;

        imgAutocompleteBar.frameName = GetSelectedThemeAchievementBar();
        imgAutocompleteBar.width = game.width * 1.1;
        imgAutocompleteBar.height = itemH * 1.5;
        imgAutocompleteBar.position.setTo(game.width >> 1, game.height - ingameButtons[0].height * 2.5);

        txtAutocompleteTitle.position.setTo((game.width >> 1), imgAutocompleteBar.y - imgAutocompleteBar.height / 6);
        btnAutocomplete1.position.x = ((game.width >> 1) - btnAutocomplete1.width * 0.8);
        btnAutocomplete1.position.y = (imgAutocompleteBar.y + imgAutocompleteBar.height / 6);
        btnAutocomplete2.position.setTo((game.width >> 1) + btnAutocomplete1.width * 0.8, imgAutocompleteBar.y + imgAutocompleteBar.height / 6);
    },

    update: function () {
    },

    updateTexts: function () {
        txtAutocompleteTitle.text = STR('INGAME_AUTOCOMPLETE_QUESTION').toUpperCase();

        btnAutocomplete1.txtCaption.text = STR(btnAutocomplete1.str);
        btnAutocomplete2.txtCaption.text = STR(btnAutocomplete2.str);

        updateBitmapTextToWidth(btnAutocomplete1.txtCaption, 35, btnAutocomplete1.width * 0.9);
        updateBitmapTextToWidth(btnAutocomplete2.txtCaption, 35, btnAutocomplete2.width * 0.9);

    },

    ShowAnimated: function () {
    },

    HideAnimated: function () {
    }

}