var DURATION_ZOOM_IN = ScenesTransitions.TRANSITION_LENGTH * 0.6;
var DURATION_BOUNCE_OUT = DURATION_ZOOM_IN * 1.5;

var CARD_SLOT_HOLDER = -1979;
var CARDS_DSPY = 28;

var DOUBLECLICK_DELAY = 300;

var DURATION_AUTO_PLACEMENT_MOVE_MULT = 16;
var DURATION_CARD_FLIP = 100;

var gameRunning = false;
var gamePaused = false;

var SceneGame = function () {
    SceneGame.instance = this;

    this.create();
};

hintPressed = false;
moves = 0;
maxUndoCountD1 = 7;
maxUndoCountD3 = 10;
maxHintCountD1 = 3;
maxHintCountD3 = 5;
newHintMovesD1 = 5;
newHintMovesD3 = 3;
hintCounter = 0;
prevSlot = -1;
startTimer = false;
doubleHintPressed = false;

SceneGame.instance = null;

SceneGame.prototype = {

    create: function () {
        scnGame = this;

        grpSceneGame = game.add.group();
        grpSceneGame.name = 'grpSceneGame';

        imgGameBG = game.add.sprite(game.width >> 1, game.height >> 1, 'bg');
        imgGameBG.anchor.setTo(0.5);
        grpSceneGame.addChild(imgGameBG);

        //region TOPBAR

        imgGameTopBar = game.add.sprite(game.width >> 1, 0, 'pak1', GetSelectedThemeTopBar());
        imgGameTopBar.anchor.setTo(0.5);
        grpSceneGame.addChild(imgGameTopBar);

        imgGameTopBarAnchor = game.add.sprite(0, 0, 'pak1', 'void');
        imgGameTopBarAnchor.anchor.setTo(0.5, 0.5);
        imgGameTopBar.addChild(imgGameTopBarAnchor);

        txtGameTime = SceneGame.instance.CreateIngameTopBarCaption('Time');
        txtGameMoves = SceneGame.instance.CreateIngameTopBarCaption('Moves');
        txtGameScore = SceneGame.instance.CreateIngameTopBarCaption('Score');

        txtGameTimeVal = SceneGame.instance.CreateIngameTopBarValue('00:47');
        txtGameMovesVal = SceneGame.instance.CreateIngameTopBarValue('12');
        txtGameScoreVal = SceneGame.instance.CreateIngameTopBarValue('110');

        //endregion

        //region BOTTOM BUTTONS

        ingameButtons = [];
        ingameButtons.push(this.CreateIngameButton('ingamenav_1', function () {
            if (animatingFlip || animatingSlot) {
                return;
            }

            gameRunning = false;
            soundManager.playSound('menu-click1');
            SceneMenu.instance.onResolutionChange();
            ScenePause.instance.ShowAnimated();
            SceneMenu.instance.ShowAnimated();
            SceneMenu.instance.SelectMenuButtonAnimated(btnMenuButtons[0]);
        }));
        // ingameButtons.push(this.CreateIngameButton('ingamenav_2', scnGame.OnPressedIngameHint));
        ingameButtons.push(this.CreateIngameButton('ingamenav_3', scnGame.OnPressedIngameUndo));
        ingameButtons.push(this.CreateIngameButton('ingamenav_4', function () {
            scnGame.PauseGame();
            //scnGame.GameOver();

            //SceneAutocomplete.instance.onResolutionChange();
            //ScenesTransitions.showSceneAlpha(grpAutocomplete, 0, ScenesTransitions.TRANSITION_LENGTH);

            /*
            snd_counter = 0;
            a = 10;
            a.a = 10;
            var twn = game.add.tween(a).to( {a: 100}, 50, Phaser.Easing.Back.InOut, true, 10, 1000, true);
            twn.onRepeat.add(function(){
                snd_counter ++;
                LOG('snd_counter = ' + snd_counter);
                var b = snd_counter % 2;
                switch(b){
                    case 0:
                        //soundManager.playSound('card');
                        scnGame.GetNextCardFromPack();
                        return;
                    case 1:
                        //soundManager.playSound('nomove');
                        scnGame.OnPressedIngameHint();
                        return;
                }
            });
            */

        }));

        //endregion

        //region CARDS

        var leftPos = game.width / 2;
        var topPos = game.height / 10;

        cardHolder = [];
        grpColorSlots = [];
        maxCardOfColor = [];

        for (var i = 0; i < 4; i++) {
            cardHolder[i] = grpSceneGame.create(leftPos + i * 63, topPos, 'game', 'nenieso');
            cardHolder[i].anchor.set(0.5);

            grpColorSlots[i] = game.add.group();
            grpColorSlots[i].x = leftPos + i * 63;
            grpColorSlots[i].y = topPos;
            grpColorSlots[i].name = "grpColorSlots" + i;
            grpColorSlots[i].cardColour = i;
            grpSceneGame.add(grpColorSlots[i]);

            maxCardOfColor[i] = 0;
        }

        leftPos = game.width / 2 - 186;

        sprCardPack = grpSceneGame.create(leftPos, topPos, 'game', GetCardBackFrame());
        sprCardPack.anchor.set(0.5);
        sprCardPack.name = "sprCardPack";
        sprCardPack.inputEnabled = true;
        sprCardPack.events.onInputDown.add(this.GetNextCardFromPack, false);

        grpCardFromPack = game.add.group();
        //grpCardFromPack = grpSceneGame.create(0, 0, 'pak1', 'void');
        grpCardFromPack.name = 'grpCardFromPack';
        grpSceneGame.add(grpCardFromPack);

        topPos = 240;

        grpCardSlots = [];

        for (var i = 0; i < 7; i++) {
            grpCardSlots[i] = game.add.group();
            grpCardSlots[i].x = leftPos + i * 63;
            grpCardSlots[i].y = topPos;
            grpCardSlots[i].name = "grpCardSlots" + i;
            grpSceneGame.add(grpCardSlots[i]);
        }

        cardSlotMoving = game.add.group();
        cardSlotMoving.name = "cardSlotMoving";
        game.physics.arcade.enable(cardSlotMoving);
        animatingFlip = false;
        animatingSlot = false;
        grpSceneGame.add(cardSlotMoving);

        sprCardsFromPack = [];
        sprCardFromPack = null;
        sprTintedCard = null;

        //endregion

        gameRunning = false;
        grpSceneGame.visible = false;

        if (GameData.profile.savedGame != null) {
            scnGame.RestoreSavedGame();
            grpSceneGame.visible = true;
        }
    },

    CreateIngameTopBarCaption: function (str) {
        var txtIngameCaption = gameState.CreateText(0, 0, 'gamefont', str, 35);
        txtIngameCaption.anchor.setTo(0.5);
        txtIngameCaption.tint = 0x000000;
        imgGameTopBarAnchor.addChild(txtIngameCaption);

        return txtIngameCaption;
    },

    CreateIngameTopBarValue: function (str) {
        var txtIngameVal = gameState.CreateText(0, 0, 'gamefont', str, 25 * game.width / 680);
        txtIngameVal.anchor.setTo(0.5, 0.5);
        txtIngameVal.tint = 0x000000;
        imgGameTopBarAnchor.addChild(txtIngameVal);

        return txtIngameVal;
    },

    CreateIngameButton: function (icon, callback) {
        var ingameButton = grpSceneGame.create(0, 0, 'pak1', GetSelectedIngameButton());
        ingameButton.anchor.set(0.5);

        var imgIcon = grpSceneGame.create(0, 0, 'pak1', icon);
        imgIcon.anchor.set(0.5);
        imgIcon.scale.set(0.5);
        imgIcon.tint = 0x000000;
        ingameButton.addChild(imgIcon);

        ingameButton.imgIcon = imgIcon;

        createBtnOnUp(ingameButton, callback);
        return ingameButton;
    },

    onResolutionChange: function () {
        CARDS_DSPY = game.cache.getFrameByName('game', 'karty1_0').height * 0.23;

        // imgGameBG.loadTexture(GetSelectedBackground());

        var itemGap = 15;
        var itemH = game.height / 8;

        imgGameTopBar.frameName = GetSelectedThemeTopBar();
        imgGameTopBar.width = game.width * 1.1;
        imgGameTopBar.height = itemH;
        imgGameTopBar.position.setTo(game.width >> 1, itemH >> 1);

        imgGameTopBarAnchor.scale.setTo(1 / imgGameTopBar.scale.x, 1 / imgGameTopBar.scale.y);

        txtGameTime.x = -game.width * 0.35;
        txtGameTime.y = -itemH * 0.2;
        txtGameScore.x = game.width * 0.35;
        txtGameScore.y = -itemH * 0.2;
        txtGameMoves.y = -itemH * 0.2;

        txtGameTimeVal.x = -game.width * 0.35;
        txtGameTimeVal.y = 5;
        txtGameScoreVal.x = game.width * 0.35;
        txtGameScoreVal.y = 5;
        txtGameMovesVal.y = 5;

        imgGameBG.width = game.width * 1.1;
        imgGameBG.height = game.height * 1.1;
        imgGameBG.position.setTo(game.width >> 1, game.height >> 1);

        var btnW = game.width / 4.4;

        var posX = (game.width >> 1) - btnW * 1.5;
        for (var i = 0; i < ingameButtons.length; i++) {
            ingameButtons[i].frameName = GetSelectedIngameButton();
            ingameButtons[i].width = btnW * 0.8;
            ingameButtons[i].scale.y = ingameButtons[i].scale.x;
            ingameButtons[i].position.y = game.height - btnW * 0.6;
            posX += btnW;
        }

        ingameButtons[0].position.x = game.width >> 3;
        ingameButtons[1].position.x = game.width >> 1;
        ingameButtons[2].position.x = game.width - (game.width >> 3);


        //region CARDS

        var cardW = game.width / 7.5;
        for (var i = 0; i < 7; i++) {
            grpCardSlots[i].scale.set(game.width / 680 * 0.7);
            grpCardSlots[i].x = cardW * 0.75 + cardW * i;
        }

        sprCardPack.scale.set(game.width / 680 * 0.7);
        sprCardPack.x = GameData.profile.RightHanded ? grpCardSlots[0].x : grpCardSlots[6].x;
        sprCardPack.y = sprCardPack.height * 2;

        grpCardFromPack.scale.set(game.width / 680 * 0.7);
        grpCardFromPack.x = GameData.profile.RightHanded ? grpCardSlots[1].x : (GameData.profile.Draw1 ? grpCardSlots[5].x : grpCardSlots[4].x);
        grpCardFromPack.y = sprCardPack.height * 2;
        grpCardFromPack.X = grpCardFromPack.x;
        grpCardFromPack.Y = grpCardFromPack.y;

        for (var i = 0; i < 4; i++) {
            cardHolder[i].scale.set(game.width / 680 * 0.7);
            cardHolder[i].x = grpCardSlots[(GameData.profile.RightHanded ? 3 : 0) + i].x;
            cardHolder[i].y = sprCardPack.height * 2;

            grpColorSlots[i].scale.set(game.width / 680 * 0.7);
            grpColorSlots[i].x = grpCardSlots[(GameData.profile.RightHanded ? 3 : 0) + i].x;
            grpColorSlots[i].y = sprCardPack.height * 2;
        }

        for (var i = 0; i < 7; i++) {
            grpCardSlots[i].y = sprCardPack.height * 3.5;
        }

        cardSlotMoving.scale.set(game.width / 680 * 0.7);

        //enndregion

        scnGame.updateSlots();
    },

    update: function () {
        if (!gameRunning) {
            return;
        }

        if (startTimer) {
            gameTimer += game.time.physicsElapsedMS;
            GameData.profile.savedTime = gameTimer;

        }

        // scnGame.SetTimerText(txtGameTimeVal, gameTimer);
        txtGameTimeVal.text = millisecondsToTimeStr(gameTimer);

        if (!game.input.activePointer.leftButton.isDown && !game.input.pointer1.isDown) {
            return;
        }

        scnGame.updateMovingSlot();
    },

    onPause: function () {
        if (!grpSceneGame.visible) {
            return;
        }
        if (!gameRunning) {
            return;
        }
        if (ScenesTransitions.transitionActive) {
            return;
        }

        if (grpAutocomplete.visible || grpNoMoves.visible) {
            return;
        }

        if (grpSceneDialog.visible) {
            return;
        }

        if (grpSceneGameOver.visible) {
            return;
        }

        scnGame.PauseGame();
    },

    PauseGame: function () {
        //PPS_USE-GAME_DISTRIBUTION
        /*
        gdsdk.showBanner();
        //PPS_USE-GAME_DISTRIBUTION
        */

        //PPS_USE-DISTRIBUTE_GAMES
        /*
        if (typeof sdk !== 'undefined' && sdk.showBanner !== 'undefined') {
            sdk.showBanner();
        }
        //PPS_USE-DISTRIBUTE_GAMES
        // */
        GameData.Save();

        gameRunning = false;
        soundManager.playSound('menu-click1');
        SceneMenu.instance.onResolutionChange();
        ScenePause.instance.ShowAnimated();
        SceneMenu.instance.ShowAnimated();
    },

    SetTimerText: function (txtObj, time) {
        time = Math.floor(time / 10);
        hundreds = time % 100;
        time = (time - hundreds) / 100;
        secs = time % 60;
        time = (time - secs) / 60;

        //txtObj.text = ((time <= 9) ? "0" : "") + time + ":" + ((secs <= 9) ? "0" : "") + secs;
        txtObj.text = time + ":" + ((secs <= 9) ? "0" : "") + secs;
    },

    updateTexts: function () {
        txtGameTime.text = STR('TIME').toUpperCase();
        txtGameMoves.text = STR('MOVES').toUpperCase();
        txtGameScore.text = STR('SCORE').toUpperCase();

        updateBitmapTextToWidth(txtGameTime, 35, game.width * 0.3);
        updateBitmapTextToWidth(txtGameMoves, 30, game.width * 0.3);
        updateBitmapTextToWidth(txtGameScore, 30, game.width * 0.3);

        var fontSize = txtGameTime.fontSize;
        if (txtGameMoves.fontSize < fontSize) {
            fontSize = txtGameMoves.fontSize;
        }
        if (txtGameScore.fontSize < fontSize) {
            fontSize = txtGameScore.fontSize;
        }

        txtGameTime.fontSize = fontSize;
        txtGameMoves.fontSize = fontSize;
        txtGameScore.fontSize = fontSize;
    },

    //region GAME LOGIC

    GetNextCardFromPack: function (originated) {
        if (!startTimer) startTimer = true;

        if (GameData.profile.Draw1) {
            scnGame.GetNext1CardFromPack(originated);
            return;
        }

        scnGame.GetNext3CardsFromPack(originated);
    },

    GetNext1CardFromPack: function (auto) {
        if (animatingFlip || animatingSlot) {
            return;
        }

        if (cardSlotMoving.length > 0) {
            return;
        }

        LOG("GetNextCardFromPack() " + cardPackNumbers.length);

        if (auto == true) {
            var tmpW = Math.floor(game.width / 7.5);

            sprCardsFromPack = [];
            if (grpCardFromPack.children.length == 0) {
                return;
            }

            sprCardsFromPack.push(grpCardFromPack.children[grpCardFromPack.children.length - 1]);

            for (var i = 0; i < sprCardsFromPack.length; i++) {
                sprCardsFromPack[i].visible = true;

                var posTween = game.add.tween(sprCardsFromPack[i]);
                posTween.to({ x: i * tmpW / 2 }, DURATION_CARD_FLIP, "Linear", 0);
                posTween.start();

                if (i == sprCardsFromPack.length - 1) {
                    sprCardsFromPack[i].inputEnabled = true;
                    sprCardsFromPack[i].events.onInputDown.add(scnGame.cardStartDrag, this);
                    sprCardsFromPack[i].events.onInputUp.add(scnGame.cardStopDrag, this);
                    sprCardsFromPack[i].secondClick = false;
                }
            }
            soundManager.playSound('card');
            return;
        }

        if (cardPackNumbers.length == 0) {
            if (grpCardFromPack.length == 0) {
                return;
            }

            cardFrame = grpCardFromPack.children[grpCardFromPack.length - 1].cardFrame;

            if (GameData.profile.UsedCardFace === 3) {
                sprCardFromPack = grpSceneGame.create(grpCardFromPack.x, grpCardFromPack.y, 'game2', GetCardFrame(cardFrame));
            } else {
                sprCardFromPack = grpSceneGame.create(grpCardFromPack.x, grpCardFromPack.y, 'game', GetCardFrame(cardFrame));
            }

            sprCardFromPack.visible = false;
            sprCardFromPack.anchor.set(0.5);
            sprCardFromPack.cardFrame = cardFrame;
            sprCardFromPack.inputEnabled = true;
            sprCardFromPack.events.onInputDown.add(scnGame.cardStartDrag, this);
            sprCardFromPack.events.onInputUp.add(scnGame.cardStopDrag, this);
            sprCardFromPack.secondClick = false;
            sprCardFromPack.x = grpCardFromPack.x;
            sprCardFromPack.y = grpCardFromPack.y;
            sprCardFromPack.scale.set(game.width / 680 * 0.7);

            animatingFlip = true;
            var posTween = game.add.tween(sprCardFromPack);
            posTween.to({ x: sprCardPack.x + (grpCardFromPack.x - sprCardPack.x) / 2 }, DURATION_CARD_FLIP, "Linear", false);
            posTween.start();

            var flipTween = game.add.tween(sprCardFromPack.scale);
            flipTween.to({ x: 0.05 * game.width / 680 }, DURATION_CARD_FLIP, "Linear", false);
            posTween.onComplete.add(scnGame.onPackCardFlippedBack, { sprCard: sprCardFromPack, destX: sprCardPack.x });
            posTween.onStart.add(function () {
                this.sprCard.visible = true;
            }, { sprCard: sprCardFromPack });
            flipTween.start();

            while (grpCardFromPack.length > 0) {
                var card = grpCardFromPack.children[grpCardFromPack.length - 1];
                cardPackNumbers.push(card.cardFrame);
                grpCardFromPack.remove(card);
                card.kill();
            }

            wasteRecycles++;
            if (wasteRecycles > 1) {
                scnGame.IncScore(-100, false);
            }

            soundManager.playSound('card');
            return;
        }

        if ((cardPackNumbers.length == 0) && (grpCardFromPack.children.length > 0)) {
            cardFrame = grpCardFromPack.children[0].cardFrame;
            grpCardFromPack.remove(grpCardFromPack.children[0]);
        }

        if (cardPackNumbers.length > 0) {
            cardFrame = cardPackNumbers.pop();
        }

        // if (GameData.profile.UsedCardFace === 3) {
        // sprCardFromPack = grpSceneGame.create(0, 0, 'game2', GetCardBackFrame());
        // } else {
        sprCardFromPack = grpSceneGame.create(0, 0, 'game', GetCardBackFrame());
        // }

        sprCardFromPack.visible = false;
        sprCardFromPack.anchor.set(0.5);
        grpCardFromPack.addChild(sprCardFromPack);

        if ((cardPackNumbers.length == 0) && (grpCardFromPack.children.length == 1)) {
            sprCardPack.frameName = 'norecycle';
        }

        LOG("A: " + cardPackNumbers.length + " B: " + grpCardFromPack.children.length);

        sprCardFromPack.frameName = GetCardBackFrame();

        sprCardFromPack.cardFrame = cardFrame;
        sprCardFromPack.inputEnabled = true;
        sprCardFromPack.events.onInputDown.add(scnGame.cardStartDrag, this);
        sprCardFromPack.events.onInputUp.add(scnGame.cardStopDrag, this);
        sprCardFromPack.secondClick = false;
        sprCardFromPack.x = sprCardPack.x - grpCardFromPack.x + (sprCardFromPack.width / 2 * (GameData.profile.RightHanded ? -1 : 1));

        animatingFlip = true;
        var posTween = game.add.tween(sprCardFromPack);
        posTween.to({ x: sprCardFromPack.x / 2 }, DURATION_CARD_FLIP, "Linear", false);
        posTween.start();

        var flipTween = game.add.tween(sprCardFromPack.scale);
        flipTween.to({ x: 0.05 * game.width / 680 }, DURATION_CARD_FLIP, "Linear", false);
        posTween.onComplete.add(scnGame.onPackCardFlipped, { sprCard: sprCardFromPack, destX: 0 });
        posTween.onStart.add(function () {
            this.sprCard.visible = true;
        }, { sprCard: sprCardFromPack });
        flipTween.start();

        if (cardPackNumbers.length == 0) {
            sprCardPack.frameName = 'neniwaste';
            if (grpCardFromPack.length == 0) {
                sprCardPack.frameName = 'norecycle';
            }
        }
    },

    ReloadCardBacks: function () {
        if (scnGame.IsCardBack(sprCardPack)) {
            sprCardPack.frameName = GetCardBackFrame();
        }

        for (var i = 0; i < grpCardSlots.length; i++) {
            for (var j = 1; j < grpCardSlots[i].length; j++) {
                if (!scnGame.IsCardBack(grpCardSlots[i].children[j])) {
                    continue;
                }

                grpCardSlots[i].children[j].frameName = GetCardBackFrame();
            }
        }
    },

    ReloadCardFaces: function () {
        for (var i = 0; i < grpCardSlots.length; i++) {
            for (var j = 1; j < grpCardSlots[i].length; j++) {
                if (scnGame.IsCardBack(grpCardSlots[i].children[j])) {
                    continue;
                }

                if (GameData.profile.UsedCardFace === 3) {
                    grpCardSlots[i].children[j].loadTexture('game2');
                } else {
                    grpCardSlots[i].children[j].loadTexture('game');
                }
                grpCardSlots[i].children[j].frameName = GetCardFrame(grpCardSlots[i].children[j].cardFrame);
            }
        }

        for (var i = 0; i < grpColorSlots.length; i++) {
            for (var j = 0; j < grpColorSlots[i].length; j++) {
                if (GameData.profile.UsedCardFace === 3) {
                    grpColorSlots[i].children[j].loadTexture('game2');
                } else {
                    grpColorSlots[i].children[j].loadTexture('game');
                }
                grpColorSlots[i].children[j].frameName = GetCardFrame(grpColorSlots[i].children[j].cardFrame);
            }
        }

        for (var i = 0; i < grpCardFromPack.children.length; i++) {
            if (GameData.profile.UsedCardFace === 3) {
                grpCardFromPack.children[i].loadTexture('game2');
            } else {
                grpCardFromPack.children[i].loadTexture('game');
            }
            grpCardFromPack.children[i].frameName = GetCardFrame(grpCardFromPack.children[i].cardFrame);
        }
    },

    GetNext3CardsFromPack: function (auto) {
        if (animatingFlip || animatingSlot) {
            return;
        }

        if (cardSlotMoving.length > 0) {
            return;
        }

        if (auto == true) {
            sprCardsFromPack = [];
            for (var i = grpCardFromPack.children.length - 3; i <= grpCardFromPack.children.length - 1; i++) {
                if (i >= 0) {
                    sprCardsFromPack.push(grpCardFromPack.children[i]);
                }
            }

            scnGame.showAllCardsTakenFromPack();
            return;
        }

        for (var i = 0; i < grpCardFromPack.children.length; i++) {
            // grpCardFromPack.children[i].x = 0;
            grpCardFromPack.children[i].inputEnabled = false;
        }

        LOG("GetNextCardFromPack() " + cardPackNumbers.length);

        if (cardPackNumbers.length == 0) {
            if (grpCardFromPack.length == 0) {
                return;
            }

            cardFrame = grpCardFromPack.children[grpCardFromPack.length - 1].cardFrame;

            if (GameData.profile.UsedCardFace === 3) {
                sprCardFromPack = grpSceneGame.create(0, 0, 'game2', GetCardFrame(cardFrame));
            } else {
                sprCardFromPack = grpSceneGame.create(0, 0, 'game', GetCardFrame(cardFrame));
            }

            sprCardFromPack.visible = false;
            sprCardFromPack.anchor.set(0.5);
            sprCardFromPack.cardFrame = cardFrame;
            sprCardFromPack.inputEnabled = true;
            sprCardFromPack.events.onInputDown.add(scnGame.cardStartDrag, this);
            sprCardFromPack.events.onInputUp.add(scnGame.cardStopDrag, this);
            sprCardFromPack.secondClick = false;
            sprCardFromPack.x = grpCardFromPack.x;
            sprCardFromPack.y = grpCardFromPack.y;
            sprCardFromPack.scale.set(game.width / 680 * 0.7);

            for (var idx = grpCardFromPack.children.length - 1 - 3; idx <= grpCardFromPack.children.length - 1; idx++) {
                if (idx >= 0) {
                    var card = grpCardFromPack.getChildAt(idx);
                    card.anchor.set(0.5);
                    game.add.tween(card).to({ x: grpCardFromPack.getChildAt(0).position.x }, DURATION_CARD_FLIP * 1, Phaser.Easing.Linear.NONE, true, 0, 0);
                }
            }

            setTimeout(function () {
                animatingFlip = true;
                var posTween = game.add.tween(sprCardFromPack);
                posTween.to({ x: sprCardPack.x + (grpCardFromPack.x - sprCardPack.x) / 2 }, DURATION_CARD_FLIP * 1, "Linear", false);
                posTween.start();

                var flipTween = game.add.tween(sprCardFromPack.scale);
                flipTween.to({ x: 0 }, DURATION_CARD_FLIP * 1, "Linear", false);
                posTween.onComplete.add(scnGame.onPackCardFlippedBack, { sprCard: sprCardFromPack, destX: sprCardPack.x });
                posTween.onStart.add(function () {
                    this.sprCard.visible = true;
                }, { sprCard: sprCardFromPack });
                flipTween.start();

                while (grpCardFromPack.length > 0) {
                    var card = grpCardFromPack.children[grpCardFromPack.length - 1];
                    cardPackNumbers.push(card.cardFrame);
                    grpCardFromPack.remove(card);
                    card.kill();
                }

                wasteRecycles++;
                if (wasteRecycles > 3) {
                    scnGame.IncScore(-20, false);
                }
            }.bind(this, sprCardFromPack), DURATION_CARD_FLIP * 1);

            return;
        }

        if ((cardPackNumbers.length == 0) && (grpCardFromPack.children.length > 0)) {
            cardFrame = grpCardFromPack.children[0].cardFrame;
            grpCardFromPack.remove(grpCardFromPack.children[0]);
        }

        cardFrames = [];

        while ((cardFrames.length < 3) && (cardPackNumbers.length > 0))
            cardFrames.push(cardPackNumbers.pop());

        sprCardsFromPack = [];

        for (var idx = grpCardFromPack.children.length - 1 - 3; idx <= grpCardFromPack.children.length - 1; idx++) {
            if (idx >= 0) {
                var card = grpCardFromPack.getChildAt(idx);
                card.anchor.set(0.5);
                game.add.tween(card).to({ x: grpCardFromPack.getChildAt(0).position.x }, DURATION_CARD_FLIP * 1, Phaser.Easing.Linear.NONE, true, 0, 0);
            }
        }

        for (var i = 0; i < cardFrames.length; i++) {
            var sprCard;

            if (GameData.profile.UsedCardFace === 3) {
                sprCard = grpSceneGame.create(0, 0, 'game2', GetCardFrame(cardFrames[i]));
            } else {
                sprCard = grpSceneGame.create(0, 0, 'game', GetCardFrame(cardFrames[i]));
            }

            sprCardsFromPack.push(sprCard);
            sprCard.visible = false;
            sprCard.anchor.set(0.5);
            grpCardFromPack.addChild(sprCard);

            if ((cardPackNumbers.length == 0) && (grpCardFromPack.children.length == 1)) {
                sprCardPack.frameName = 'norecycle';
            }

            LOG("A: " + cardPackNumbers.length + " B: " + grpCardFromPack.children.length);

            sprCard.cardFrame = cardFrames[i];
            sprCard.x = sprCardPack.x - grpCardFromPack.x;

            if (i == cardFrames.length - 1) {
                var posTween = game.add.tween(sprCard);
                posTween.to({ x: sprCard.x / 2 }, DURATION_CARD_FLIP * 1, "Linear", false);
                posTween.start();

                sprCard.visible = true;

                animatingFlip = true;
                var flipTween = game.add.tween(sprCard.scale);
                flipTween.to({ x: 0 }, DURATION_CARD_FLIP * 1, "Linear", false);
                flipTween.start();

                // posTween.onStart.add(function () {
                //     this.sprCard.visible = true;
                // }, { sprCard: sprCard });

                sprCard.frameName = GetCardBackFrame();
                sprCard.inputEnabled = true;
                sprCard.events.onInputDown.add(scnGame.cardStartDrag, this);
                sprCard.events.onInputUp.add(scnGame.cardStopDrag, this);
                sprCard.secondClick = false;

                flipTween.onComplete.add(scnGame.onPackCardFlipped, { sprCard: sprCard, destX: 0 })

            } else {
                sprCard.x = 0;
                sprCard.visible = false;
            }

        }

        if (cardPackNumbers.length == 0) {
            sprCardPack.frameName = 'neniwaste';
            if (grpCardFromPack.length == 0) {
                sprCardPack.frameName = 'norecycle';
            }
        }
    },

    animateCardFlip: function (sprCard) {
        animatingFlip = true;
        sprCard.inputEnabled = false;
        var flipTween = game.add.tween(sprCard.scale);
        flipTween.to({ x: 0.05 * game.width / 680 }, DURATION_CARD_FLIP, "Linear", 0);
        flipTween.onComplete.add(scnGame.onCardFlipped, { sprCard: sprCard })
        flipTween.start();
    },

    onCardFlipped: function (sprCard) {
        animatingFlip = true;
        if (GameData.profile.UsedCardFace === 3) {
            this.sprCard.loadTexture('game2');
            this.sprCard.frameName = GetCardFrame(this.sprCard.cardFrame);
        } else {
            this.sprCard.loadTexture('game');
            this.sprCard.frameName = GetCardFrame(this.sprCard.cardFrame);
        }
        var flipTween = game.add.tween(this.sprCard.scale);
        flipTween.to({ x: 1 }, DURATION_CARD_FLIP, "Linear", 0);
        flipTween.onComplete.add(scnGame.onCardFlipFinished, { sprCard: this.sprCard })
        flipTween.start();
    },

    onPackCardFlipped: function (sprCard) {
        animatingFlip = true;
        if (GameData.profile.UsedCardFace === 3) {
            this.sprCard.loadTexture('game2');
            this.sprCard.frameName = GetCardFrame(this.sprCard.cardFrame);
        } else {
            this.sprCard.loadTexture('game');
            this.sprCard.frameName = GetCardFrame(this.sprCard.cardFrame);
        }

        var flipTween = game.add.tween(this.sprCard.scale);
        flipTween.to({ x: 1 }, DURATION_CARD_FLIP, "Linear", 0);
        flipTween.start();
        flipTween.onComplete.add(scnGame.onCardFlipFinished, { sprCard: this.sprCard })

        var posTween = game.add.tween(this.sprCard);
        posTween.to({ x: this.destX }, DURATION_CARD_FLIP, "Linear", 0);
        posTween.start();

        //scnGame.IncMoves(+1);

        soundManager.playSound('card');
    },

    onPackCardFlippedBack: function () {
        animatingFlip = true;
        this.sprCard.frameName = GetCardBackFrame();

        scnGame.createNextUndoRecord();

        var flipTween = game.add.tween(this.sprCard.scale);
        flipTween.to({ x: 1 * game.width / 680 }, DURATION_CARD_FLIP, "Linear", 0);
        flipTween.start();
        flipTween.onComplete.add(scnGame.onCardBackFlipFinished, { sprCard: this.sprCard })

        var posTween = game.add.tween(this.sprCard);
        posTween.to({ x: this.destX }, DURATION_CARD_FLIP, "Linear", 0);
        posTween.start();
    },

    onCardBackFlipFinished: function () {
        animatingFlip = false;

        this.sprCard.kill();
        sprCardPack.frameName = GetCardBackFrame();
    },

    onCardFlipFinished: function () {
        animatingFlip = false;

        this.sprCard.inputEnabled = true;

        scnGame.IncMoves(1);

        if (!GameData.profile.Draw1) {

            scnGame.showAllCardsTakenFromPack();
            // return;
        }

        /*
        if(!scnGame.autoplaceColorCard(this.sprCard))
            scnGame.checkCardSlotsForAutoplace();
        */

        scnGame.checkCardsForAutocomplete();

    },

    showAllCardsTakenFromPack: function () {
        animatingSlot = animatingSlot || (sprCardsFromPack.length > 0);
        for (var i = 0; i < sprCardsFromPack.length; i++) {
            sprCardsFromPack[i].visible = true;
            sprCardsFromPack[i].inputEnabled = false;

            var tmpW = sprCardsFromPack[i].width * 0.45;
            var destX = i * tmpW;
            var posTween = game.add.tween(sprCardsFromPack[i]);
            posTween.to({ x: destX }, DURATION_CARD_FLIP, "Linear", 0);

            if (i == sprCardsFromPack.length - 1) {
                posTween.onComplete.add(function () {
                    animatingSlot = false;
                });
                sprCardsFromPack[i].inputEnabled = true;
                sprCardsFromPack[i].events.onInputDown.add(scnGame.cardStartDrag, this);
                sprCardsFromPack[i].events.onInputUp.add(scnGame.cardStopDrag, this);
                sprCardsFromPack[i].secondClick = false;
            }

            posTween.start();
        }

    },

    checkCardsForAutocomplete: function () {
        if (gameAutocomplete != null) {
            return false;
        }

        LOG('checkCardsForAutocomplete')

        if (cardPackNumbers.length > 0) {
            return false;
        }

        if (grpCardFromPack.length > 0) {
            return false;
        }

        for (var i = 0; i < grpCardSlots.length; i++) {
            if (grpCardSlots[i].length == 1) {
                continue;
            }

            for (var j = 1; j < grpCardSlots[i].length; j++) {
                if (scnGame.IsCardBack(grpCardSlots[i].children[j])) {
                    return false;
                }
            }
        }

        soundManager.playSound('dialog');
        SceneAutocomplete.instance.onResolutionChange();
        ScenesTransitions.showSceneAlpha(grpAutocomplete, 0, ScenesTransitions.TRANSITION_LENGTH);

        return true;
    },

    checkCardSlotsForAutoplace: function () {
        for (var i = 0; i < grpCardSlots.length; i++) {
            if (grpCardSlots[i].length == 1) {
                continue;
            }

            if (scnGame.autoplaceColorCard(grpCardSlots[i].children[grpCardSlots[i].length - 1])) {
                return true;
            }
        }

        return false;
    },

    autoplaceColorCard: function (card) {
        if (scnGame.IsCardBack(card)) {
            return false;
        }

        if (cardSlotMoving.length > 0) {
            return false;
        }

        if (animatingFlip || animatingSlot) {
            return false;
        }

        var prevPos = card.worldPosition;
        var colour = Math.floor(card.cardFrame / 13);
        var sign = card.cardFrame % 13;

        if (!scnGame.allCardsSorted() && (sign > 1)) {
            return;
        }

        for (var i = 0; i < grpColorSlots.length; i++) {
            if ((grpColorSlots[i].length == 0) && (sign != 0)) {
                continue;
            }

            if ((grpColorSlots[i].length > 0) && (sign != 0)) {
                var ColorSlotColor = grpColorSlots[i].children[0].cardFrame / 13;

                if (ColorSlotColor != colour) {
                    continue;
                }

                var ColorSlotSign = grpColorSlots[i].children[grpColorSlots[i].length - 1].cardFrame % 13;

                if (sign - ColorSlotSign != 1) {
                    continue;
                }
            } else {
                if (grpColorSlots[i].length > 0) {
                    continue;
                }

            }

            LOG("[" + card.cardFrame + "] autoplaceColorCard");

            cardSlotFrom = card.parent;
            var ColorSlotColor = grpColorSlots[i].children[0].cardFrame / 13;
            if (grpColorSlots[i].length + 1 > maxCardOfColor[ColorSlotColor]) {
                scnGame.IncScore(+10, false);
            }

            scnGame.addOneCardToMovingSlot(cardSlotMoving, card);
            scnGame.placeMovingSlotToSlotAnimated(cardSlotMoving, grpColorSlots[i], 1.5);
            //scnGame.showNextCardFromSlot(grpCardSlots, parentSlot);
            return true;
        }

        return false;
    },

    allCardsSorted: function () {
        if ((cardPackNumbers.length > 0) || (grpCardFromPack.children.length > 0)) {
            return;
        }


        for (var i = 0; i < grpCardSlots.length; i++) {
            if (grpCardSlots[i].length < 2) {
                continue;
            }
            if (scnGame.IsCardBack(grpCardSlots[i].children[1]))
            //if(grpCardSlots[i].children[1].key == "cardBack")
            {
                return false;
            }
            var prevSign = grpCardSlots[i].children[1].cardFrame % 13;
            for (var j = 2; j < grpCardSlots[i].length; j++) {
                var sign = grpCardSlots[i].children[j].cardFrame % 13;
                if (prevSign - sign != 1) {
                    return false;
                }
                prevSign = sign;
            }
        }

        return true;
    },

    addOneCardToMovingSlot: function (movingSlot, card) {
        movingSlot.x = card.worldPosition.x;//card.parent.x;
        movingSlot.y = card.worldPosition.y;//card.parent.y + card.y;
        movingSlot.add(card);
        game.tweens.removeFrom(card, true);
        card.x = 0;
        card.y = 0;
    },

    placeMovingSlotToSlot: function (movingSlot, newSlot) {
        if (movingSlot == newSlot) {
            return;
        }

        //LOG("placeMovingSlotToSlot");

        while (movingSlot.length > 0) {
            cardToRemove = movingSlot.children[0];
            stopAllTweensOnObject(cardToRemove.position);
            game.tweens.removeFrom(cardToRemove, true);
            cardToRemove.secondClick = false;
            cardToRemove.x = scnGame.getXPositionInNewSlot(newSlot);
            cardToRemove.y = scnGame.getYPositionInNewSlot(newSlot);
            newSlot.add(cardToRemove);
        }

        if (scnGame.isColorSlot(newSlot)) {
            var ColorSlotColor = newSlot.children[0].cardFrame / 13;
            var maxCard = newSlot.length;
            if (maxCardOfColor[ColorSlotColor] < maxCard) {
                maxCardOfColor[ColorSlotColor] = maxCard;
            }
        }

        scnGame.compactCardSlot(newSlot);

        if (newSlot != cardSlotFrom) {
            if (!scnGame.showNextCardFromSlot(grpCardSlots, cardSlotFrom)) {
                if (scnGame.isColorSlot(cardSlotFrom)) {
                    scnGame.IncMoves(+1);
                    return;
                }
                scnGame.IncMoves(+1);
            }
        }

        if (grpCardFromPack.length > 0) {
            LOG('XPOS  : ' + grpCardFromPack.children[grpCardFromPack.length - 1].x);
        }


        if (scnGame.isCardSlot(newSlot) && (cardSlotFrom == grpCardFromPack)) {
            scnGame.IncScore(+5, true);
        }
        //waste to tableau +5

        soundManager.playSound('card');

        if (scnGame.checkCardsForAutocomplete()) {
            return;
        }

        if (gameAutocomplete) {
            scnGame.checkCardSlotsForAutoplace();
        }

        if (cardPackNumbers.length == 0) {
            sprCardPack.frameName = 'neniwaste';
            if (grpCardFromPack.length == 0) {
                sprCardPack.frameName = 'norecycle';
            }
        }

        scnGame.updateSlots();
        scnGame.testGameOver();
    },

    placeMovingSlotToSlotAnimated: function (movingSlot, newSlot, speedMul) {
        //LOG("placeMovingSlotToSlotAnimated");

        animationSpeedMul = speedMul || 1;

        //this.updateMovingSlot();
        animatingSlot = true;

        var destY = newSlot.y;
        if (!scnGame.isColorSlot(newSlot)) {
            destY = scnGame.getAbsoluteYPositionInNewSlot(newSlot);
        }

        for (var i = 0; i < movingSlot.length; i++) {
            movingSlot.children[i].inputEnabled = false;
        }

        var dist = Math.sqrt(Math.pow(movingSlot.x - newSlot.x, 2) + Math.pow(movingSlot.y - destY, 2));

        var posTween = game.add.tween(movingSlot);
        posTween.to({
            x: newSlot.x,
            y: destY
        }, Math.floor(dist * 10 / (DURATION_AUTO_PLACEMENT_MOVE_MULT * animationSpeedMul * game.width / 680)), "Linear", false);
        posTween.onComplete.add(scnGame.movingSlotHasMovedWithAnimation, { movingSlot: movingSlot, newSlot: newSlot });
        posTween.start();

        if (sprTintedCard != null) sprTintedCard.tint = 0xFFFFFF;

        if (!hintPressed) {
            incrementMovesCounter();
        } else {
            hintPressed = false;
        }
    },

    getYPositionInNewSlot: function (newSlot) {
        var destY = 0;

        if (newSlot.children.length > 0) {
            destY += newSlot.children[newSlot.children.length - 1].y;
            if (newSlot.children.length > 1) {
                destY += newSlot.children[newSlot.children.length - 1].y - newSlot.children[newSlot.children.length - 2].y;

                if (newSlot.children.length == 2) {
                    for (var i = 0; i < grpCardSlots.length; i++) {
                        if (newSlot == grpCardSlots[i]) {
                            destY += CARDS_DSPY;
                        }
                    }
                }
            }
        }

        return destY;
    },

    getXPositionInNewSlot: function (newSlot) {
        if (GameData.profile.Draw1) {
            return 0;
        }

        if (newSlot != grpCardFromPack) {
            return 0;
        }

        var destX = 0;
        var tmpW = 0;

        for (var i = 0; i < grpCardFromPack.children.length; i++) {
            tmpW = grpCardFromPack.children[i].width * 0.45;
            if (grpCardFromPack.children[i].x > destX) {
                destX = grpCardFromPack.children[i].x;
            }
        }

        if (sprCardsFromPack.length == 1) {
            return destX;
        }

        return destX + tmpW;
    },

    getAbsoluteYPositionInNewSlot: function (newSlot) {
        if (newSlot.children.length < 2) {
            return newSlot.children[newSlot.children.length - 1].worldPosition.y;
        }

        return newSlot.children[newSlot.children.length - 1].worldPosition.y + CARDS_DSPY;
    },

    movingSlotHasMovedWithAnimation: function () {
        //LOG("movingSlotHasMovedWithAnimation [" + this.movingSlot.children[0].x + ", " + this.movingSlot.children[0].y + "]")

        for (var i = 0; i < this.movingSlot.length; i++) {
            this.movingSlot.children[i].inputEnabled = true;
        }

        animatingSlot = false;
        scnGame.placeMovingSlotToSlot(this.movingSlot, this.newSlot);

        var colorSlotIdx = scnGame.getColorSlotIdx(this.newSlot);
        if (colorSlotIdx != -1) {
            soundManager.playSound('harph' + colorSlotIdx);
        }

        if (sprTintedCard != null) sprTintedCard.tint = 0xFFFFFF;

        if (cardPackNumbers.length == 0) {
            sprCardPack.frameName = 'neniwaste';
            if (grpCardFromPack.length == 0) {
                sprCardPack.frameName = 'norecycle';
            }
        }
    },

    slotContainsCard: function (slot, card) {
        for (var i = 0; i < slot.length; i++) {
            if (slot.children[i] == card) {
                return true;
            }
        }

        return false;
    },

    showNextCardFromSlot: function (cardSlots, slot) {
        if (slot == grpCardFromPack) {
            //skipUndoRecord = true;
            scnGame.GetNextCardFromPack(true);
        }

        slotIsCardSlot = false;

        for (var i = 0; i < cardSlots.length; i++) {
            if (slot == cardSlots[i]) {
                slotIsCardSlot = true;
            }
        }

        if (!slotIsCardSlot) {
            return false;
        }

        if (slot.length == 1) {
            return false;
        }

        LOG("showNextCardFromSlot");

        scnGame.compactCardSlot(slot);

        sprCard = slot.children[slot.length - 1];
        if (scnGame.IsCardBack(sprCard)) {
            scnGame.animateCardFlip(sprCard);
            scnGame.IncScore(+5, false);
            return true;
        }

        return false;
    },

    IncScore: function (inc, LV) {
        gameScore += inc;
        if (LV) {
            gameScoreLV += inc;
        }

        scnGame.UpdateScoreTxtControl();

        if ((GameData.profile.LasVegasScore && LV) || (!GameData.profile.LasVegasScore)) {
            SetPoingScaleTween(txtGameScoreVal);
        }
    },

    IncMoves: function (inc, skipCreateUndoRec) {

        if (skipCreateUndoRec === undefined) {
            skipCreateUndoRec = false;
        }

        gameMoves += inc;
        txtGameMovesVal.text = '' + gameMoves;
        SetPoingScaleTween(txtGameMovesVal);

        if (gameMoves === 1) {
            if (GameData.profile.Draw1) {
                GameData.profile.TotalGamesD1++;
            } else {
                GameData.profile.TotalGamesD3++;
            }

            GameData.Save();
        }

        if (!skipCreateUndoRec) {
            scnGame.createNextUndoRecord();
        }

        if (scnGame.UpdateAchievement(ACHIEVEMENT_CARDS1, inc)) {
            scnGame.ShowUnlockedAchievement(ACHIEVEMENT_CARDS1);
        }
        if (scnGame.UpdateAchievement(ACHIEVEMENT_CARDS2, inc)) {
            scnGame.ShowUnlockedAchievement(ACHIEVEMENT_CARDS2);
        }

        checkGameover();
    },

    compactCardSlot: function (cardSlot) {
        /*
        if(cardSlot == grpCardFromPack)
            return;

        for(var i = 0; i < 4; i++) {
            if (cardSlot == grpColorSlots[i])
                return;
        }

        var cntBacks = 0;
        var cntCards = 0;

        for(var i = 1; i < cardSlot.length; i++) {
            if (cardSlot.children[i].key == "cards")
                cntCards++;
            else
                cntBacks++;
        }


        var totalHeight = cardSlot.length * CARDS_DSPY;

        dspYBack = CARDS_DSPY;
        dspYCards = CARDS_DSPY;

        do{
            if(totalHeight > 560){
                dspYBack = dspYBack / 2;
                totalHeight = cntBacks * dspYBack + cntCards * dspYCards;
            }

            if(totalHeight > 560){
                dspYCards = dspYCards / 2;
                totalHeight = cntBacks * dspYBack + cntCards * dspYCards;
            }
        }while(totalHeight > 560);

        posY = 0;
        for(var i = 1; i < cardSlot.length; i++){
            var posTween = game.add.tween(cardSlot.children[i]);
            posTween.to( { y: posY}, 100, "Linear", true);
            posY += (cardSlot.children[i].key == "cards") ? dspYCards : dspYBack;
        }

        console.log("compactCardSlot [" + cardSlot.length + "] : " + posY);
        */
    },

    updateSlots: function () {
        CARDS_DSPY = Math.floor(CARDS_DSPY);

        for (var idx = 0; idx < grpCardSlots.length; idx++) {
            var slot = grpCardSlots[idx];
            if (slot.length === 0) continue;

            var slotTop = (slot.position.y - (slot.getChildAt(0).height * slot.scale.y * 0.5));
            var btnTop = (ingameButtons[0].position.y - (ingameButtons[0].height >> 1));
            var tmp = Math.floor(btnTop - slotTop);

            var cardOffset = Math.floor((slot.getChildAt(0).height * slot.scale.y) - CARDS_DSPY);
            var originalHeight = Math.floor(((slot.length - 1) * CARDS_DSPY)) + cardOffset;

            var newYoffset = CARDS_DSPY;

            if (tmp < originalHeight) {
                var newHeight = originalHeight - cardOffset;
                while (tmp < newHeight) {
                    newYoffset--;
                    newHeight -= (slot.length - 1);
                }
            }

            newYoffset = Math.floor(newYoffset);

            for (var cardIdx = 1; cardIdx < slot.length; cardIdx++) {
                var card = slot.getChildAt(cardIdx);
                card.y = (cardIdx - 1) * newYoffset;
            }
        }
    },

    testGameOver: function () {
        //LOG("testGameOver");

        for (var i = 0; i < grpColorSlots.length; i++) {
            if (grpColorSlots[i].children.length < 13) {
                return;
            }
        }

        scnGame.GameOver();
    },

    isColorSlot: function (slot) {
        for (var i = 0; i < grpColorSlots.length; i++) {
            if (grpColorSlots[i] == slot) {
                return true;
            }
        }

        return false;
    },

    getColorSlotIdx: function (slot) {
        for (var i = 0; i < grpColorSlots.length; i++) {
            if (grpColorSlots[i] == slot) {
                return i;
            }
        }

        return -1;
    },

    isCardSlot: function (slot) {
        for (var i = 0; i < grpCardSlots.length; i++) {
            if (grpCardSlots[i] == slot) {
                return true;
            }
        }

        return false;
    },

    createNextUndoRecord: function () {
        if (skipUndoRecord) {
            skipUndoRecord = false;
            return false;
        }

        undoRecord = {};

        recCardPackNumbers = [];
        d = "";
        for (var i = 0; i < cardPackNumbers.length; i++) {
            recCardPackNumbers[i] = cardPackNumbers[i];
            if (d.length > 0) d = d + " ,";
            d = d + cardPackNumbers[i];
        }
        d = "[ " + d + " ]";
        //console.log(d);

        undoRecord['cpn'] = recCardPackNumbers;

        recCardSlots = [];
        for (var i = 0; i < grpCardSlots.length; i++) {

            recCardSlot = [];
            for (var j = 1; j < grpCardSlots[i].length; j++) {
                recCardSlot[j - 1] = scnGame.GetUndoRecCF(grpCardSlots[i].children[j]);
            }
            recCardSlots[i] = recCardSlot;
        }

        undoRecord['cs'] = recCardSlots;

        recColorSlots = [];
        recColorSlotsMaxCard = [];
        for (var i = 0; i < grpColorSlots.length; i++) {
            recColorSlotsMaxCard[i] = maxCardOfColor[i];
            recCardSlot = [];
            for (var j = 0; j < grpColorSlots[i].length; j++) {
                recCardSlot[j] = scnGame.GetUndoRecCF(grpColorSlots[i].children[j]);
            }
            recColorSlots[i] = recCardSlot;
        }

        undoRecord['cls'] = recColorSlots;
        undoRecord['clsmc'] = recColorSlotsMaxCard;

        recCardsFromPack = [];
        for (var i = 0; i < grpCardFromPack.children.length; i++) {
            recCardsFromPack[i] = scnGame.GetUndoRecCF(grpCardFromPack.children[i]);
        }

        undoRecord['cfp'] = recCardsFromPack;
        undoRecord['scr'] = gameScore;
        undoRecord['scrlv'] = gameScoreLV;
        undoRecord['wrcs'] = wasteRecycles;
        undoRecord['cfp3'] = sprCardsFromPack.length;

        var t1 = JSON.stringify(undoRecords[undoRecords.length - 1]);
        var t2 = JSON.stringify(undoRecord);

        var retVal = false;
        if ((t1 != t2) || (undoRecords.length <= 1)) {
            var undoFull = false;

            if (GameData.profile.Draw1) {
                if (undoRecords.length === maxUndoCountD1) {
                    undoFull = true;
                }
            } else {
                if (undoRecords.length === maxUndoCountD3) {
                    undoFull = true;
                }
            }

            if (undoFull) {
                undoRecords.shift();
                undoRecords.push(undoRecord);
            } else {
                undoRecords.push(undoRecord);
            }

            retVal = true;
            LOG("createNextUndoRecord()\n" + t2);
            GameData.profile.savedTime = gameTimer;
            GameData.profile.savedMoved = gameMoves;
            GameData.profile.savedScore = gameScore;
            GameData.profile.savedScoreLV = gameScoreLV;
            GameData.profile.savedGame = LZString.compressToUTF16(JSON.stringify(undoRecords));
            GameData.profile.savedWasteRecycles = wasteRecycles;

            if (GameData.profile.retryCards === null) {
                GameData.profile.retryCards = undoRecord;
            }

            GameData.Save();
        } else {
            LOG("createNextUndoRecord() - skipped");
        }


        LOG('UNDORECORDS : ' + undoRecords.length)

        /*
        while(undoRecords.length > 3)
            undoRecords.splice(0, 1);
        */
        return retVal;
    },

    GetUndoRecCF: function (sprCard) {
        var cf = sprCard.cardFrame;
        if (cf == 0) cf = 100;
        if (scnGame.IsCardBack(sprCard)) cf = -cf;
        return cf;
    },

    GameOver: function () {
        SceneGameOver.instance.ShowAnimated();
        scnGame.UpdateAchievementsTime(gameTimer);
        scnGame.UpdateAchievementsWin();

        scnGame.onGameOver(GAME_OVER_WIN);
    },

    onGameStart: function () {
        //PPS_USE-SDK:iWIN
        /*
        iConsole.ads.show( {
            type: 'levelStarted',
            level: (GameData.profile.Draw1 ? 1 : 3)
        } ).result( function() {
        });
        //PPS_USE-SDK:iWIN
        */

        //PPS_USE-CLOUDGAMES
        /*
        cldapi_play();
        //PPS_USE-CLOUDGAMES
        */
    },

    ResetGame: function () {
        adinplay_onAdStarted = function () {
            game.paused = false;

            this.__ResetGame();
        }.bind(this);
        adinplay_onAdFinished = function () {
        };
        adinplay_playVideoAd();
    },

    __ResetGame: function () {
        //soundManager.playMusic(SOUND_GAME);
        startTimer = false;
        gameTimer = 0;
        gameMoves = 0;
        gameScore = 0;
        gameScoreLV = -52;
        wasteRecycles = 0;
        gameAutocomplete = null;

        skipUndoRecord = false;
        animatingFlip = false;
        animatingSlot = false;
        doubleHintPressed = false;

        GameData.profile.retryCards = null;
        undoRecords = [];
        //btnIngameUndo.frame = 1;

        cardPackNumbers = [];
        for (var i = 0; i < 52; i++) {
            cardPackNumbers[i] = i;
        }

        shuffleArray(cardPackNumbers);

        if (sprCardFromPack != null) sprCardFromPack.kill();
        sprCardPack.frameName = GetCardBackFrame();
        grpCardFromPack.removeAll(true);
        sprCardsFromPack = [];
        cardSlotFrom = null;

        for (var i = 0; i < 4; i++) {
            grpColorSlots[i].removeAll(true);
            maxCardOfColor[i] = 0;
        }

        for (var i = 0; i < 7; i++) {
            grpCardSlots[i].removeAll(true);

            sprCardSlotHolder = grpCardSlots[i].create(0, 0, 'game', 'nenieso');
            sprCardSlotHolder.anchor.set(0.5);
            sprCardSlotHolder.cardFrame = CARD_SLOT_HOLDER;
            sprCardSlotHolder.alpha = 0;

            for (var j = 0; j <= i; j++) {
                cardFrame = cardPackNumbers.pop();
                if (j == i) {
                    if (GameData.profile.UsedCardFace === 3) {
                        sprCard = grpSceneGame.create(0, j * CARDS_DSPY, 'game2', GetCardFrame(cardFrame));
                    } else {
                        sprCard = grpSceneGame.create(0, j * CARDS_DSPY, 'game', GetCardFrame(cardFrame));
                    }
                } else {
                    sprCard = grpSceneGame.create(0, j * CARDS_DSPY, 'game', GetCardBackFrame());
                }
                sprCard.cardFrame = cardFrame;
                grpCardSlots[i].add(sprCard);
                sprCard.anchor.set(0.5);
                game.physics.arcade.enable(sprCard);
                sprCard.inputEnabled = true;
                sprCard.events.onInputDown.add(scnGame.cardStartDrag, this);
                sprCard.events.onInputUp.add(scnGame.cardStopDrag, this);
                sprCard.secondClick = false;
            }
        }

        //Test konca balika
        //while(cardPackNumbers.length > 1)
        //    cardPackNumbers.pop();

        /*bestTime = GetStorageValue('sltr-best-', 0);

        sprIngameRecordStar.visible = false;
        txtIngameRecord.visible = false;
        if(bestTime != 0){
            sprIngameRecordStar.visible = true;
            txtIngameRecord.visible = true;
            this.SetTimerText(txtIngameRecord, bestTime);
        }*/

        txtGameTimeVal.text = '00:00';
        txtGameMovesVal.text = '' + gameMoves;
        scnGame.UpdateScoreTxtControl();
        scnGame.createNextUndoRecord();
        scnGame.onResolutionChange();

        // if (GameData.profile.Draw1) {
        //     GameData.profile.TotalGamesD1++;
        // } else {
        //     GameData.profile.TotalGamesD3++;
        // }

        GameData.Save();

        soundManager.playSound('redeal');
        gameRunning = true;

        moves = 0;
        hintCounter = 0;

        scnGame.onGameStart();
    },

    RestoreSavedGame: function () {
        gameTimer = GameData.profile.savedTime;
        gameMoves = GameData.profile.savedMoved;
        gameScore = GameData.profile.savedScore;
        gameScoreLV = GameData.profile.savedScoreLV;
        wasteRecycles = GameData.profile.savedWasteRecycles;
        gameAutocomplete = null;
        doubleHintPressed = false;

        skipUndoRecord = false;
        animatingFlip = false;
        animatingSlot = false;

        undoRecords = [];
        //btnIngameUndo.frame = 1;

        cardPackNumbers = [];
        for (var i = 0; i < 52; i++) {
            cardPackNumbers[i] = i;
        }
        shuffleArray(cardPackNumbers);

        if (sprCardFromPack != null) sprCardFromPack.kill();
        sprCardPack.frameName = GetCardBackFrame();
        grpCardFromPack.removeChildren();
        sprCardsFromPack = [];
        cardSlotFrom = null;

        for (var i = 0; i < 4; i++) {
            grpColorSlots[i].removeAll(true);
            maxCardOfColor[i] = 0;
        }

        for (var i = 0; i < 7; i++) {
            grpCardSlots[i].removeAll(true);

            sprCardSlotHolder = grpCardSlots[i].create(0, 0, 'game', 'nenieso');
            sprCardSlotHolder.anchor.set(0.5);
            sprCardSlotHolder.cardFrame = CARD_SLOT_HOLDER;
            sprCardSlotHolder.alpha = 0;

            for (var j = 0; j <= i; j++) {
                cardFrame = cardPackNumbers.pop();
                if (j == i) {
                    if (GameData.profile.UsedCardFace === 3) {
                        sprCard = grpSceneGame.create(0, j * CARDS_DSPY, 'game2', GetCardFrame(cardFrame));
                    } else {
                        sprCard = grpSceneGame.create(0, j * CARDS_DSPY, 'game', GetCardFrame(cardFrame));
                    }
                } else {
                    sprCard = grpSceneGame.create(0, j * CARDS_DSPY, 'game', GetCardBackFrame());
                }
                sprCard.cardFrame = cardFrame;
                grpCardSlots[i].add(sprCard);
                sprCard.anchor.set(0.5);
                game.physics.arcade.enable(sprCard);
                sprCard.inputEnabled = true;
                sprCard.events.onInputDown.add(scnGame.cardStartDrag, this);
                sprCard.events.onInputUp.add(scnGame.cardStopDrag, this);
                sprCard.secondClick = false;
            }
        }

        //Test konca balika
        //while(cardPackNumbers.length > 1)
        //    cardPackNumbers.pop();

        /*bestTime = GetStorageValue('sltr-best-', 0);

        sprIngameRecordStar.visible = false;
        txtIngameRecord.visible = false;
        if(bestTime != 0){
            sprIngameRecordStar.visible = true;
            txtIngameRecord.visible = true;
            this.SetTimerText(txtIngameRecord, bestTime);
        }*/

        txtGameTimeVal.text = millisecondsToTimeStr(gameTimer);
        txtGameMovesVal.text = '' + gameMoves;
        scnGame.UpdateScoreTxtControl();
        scnGame.onResolutionChange();

        undoRecords = JSON.parse(LZString.decompressFromUTF16(GameData.profile.savedGame));
        scnGame.ApplyUndoRecord(undoRecords[undoRecords.length - 1]);

        gameRunning = false;
    },

    cardStartDrag: function (card) {
        if (ScenesTransitions.transitionActive) {
            return;
        }

        if (!startTimer) startTimer = true;

        if (!card.secondClick) {

            if (card.parent == cardSlotMoving) {
                //scnGame.cardStopDrag(cardSlotMoving.children[0]);
                return;
            }

            if (animatingFlip || animatingSlot) {
                scnGame.cardStopDrag(cardSlotMoving.children[0]);
                return;
            }

            if (cardSlotMoving.length > 0) {
                scnGame.cardStopDrag(cardSlotMoving.children[0]);
                return;
            }

            LOG("[" + card.cardFrame + "] cardStartDrag {firstclick}");

            cardSlotFrom = card.parent;

            card.secondClick = true;

            touchDeltaX = card.worldPosition.x - game.input.x;
            touchDeltaY = card.worldPosition.y - game.input.y;

            //LOG("       touchDeltaY : " + touchDeltaY);

            scnGame.removeCardOrCardsFromSlot(card);
            scnGame.compactCardSlot(cardSlotFrom);
            game.world.bringToTop(cardSlotMoving);
            scnGame.updateMovingSlot();

            game.time.events.add(DOUBLECLICK_DELAY, function () {
                this.card.secondClick = false;
                doubleHintPressed = false;
                //LOG("   [" + card.cardFrame + "] {secondclick = false}");
            }, { card: card });

            return;
        }

        //LOG("[" + card.cardFrame + "] cardStartDrag {secondclick = true}");
        if (!scnGame.autoplaceCard(card)) {
            ShakeObject(card);
            soundManager.playSound('nomove');
        }
    },

    removeCardOrCardsFromSlot: function (card) {
        cardToRemove = null;

        var startToRemove = false;
        for (var i = 0; i < cardSlotFrom.length; i++) {
            cardToRemove = cardSlotFrom.children[i];
            if (scnGame.IsCardSprite(cardToRemove) && (cardToRemove.cardFrame == card.cardFrame)) {
                /*
                if (cardToRemove.frame != cardToRemove.cardFrame){
                    scnGame.RemoveLastUndoRecord();
                    //btnIngameUndo.frame = (undoRecords.length == 0) ? 1 : 0;
                    return;
                }
                */
                startToRemove = true;
            }
            if (startToRemove) {
                prevSlot = cardToRemove.parent.name;
                cardSlotMoving.add(cardToRemove);
                game.tweens.removeFrom(cardToRemove, true);
                cardToRemove.x = 0;
                cardToRemove.y = (cardSlotMoving.length - 1) * CARDS_DSPY;
                colour = Math.floor(cardToRemove.cardFrame / 13);
                sign = cardToRemove.cardFrame % 13;
                i--;
            }

        }
    },

    autoplaceCard: function (card, oldCardPosInSlot) {
        //LOG("[" + card.cardFrame + "] autoplaceCard");

        if (oldCardPosInSlot === undefined) {
            oldCardPosInSlot = -1;
        }

        //if(card.key == "cardBack")
        if (scnGame.IsCardBack(card)) {
            return false;
        }

        var prevPos = card.worldPosition;
        var colour = Math.floor(card.cardFrame / 13);
        var sign = card.cardFrame % 13;

        //K-s
        if (sign == 12) {
            if (cardSlotMoving.length == 1) {
                for (var i = 0; i < grpColorSlots.length; i++) {
                    if (grpColorSlots[i].length < 12) {
                        continue;
                    }
                    if (Math.floor(grpColorSlots[i].children[0].cardFrame / 13) != colour) {
                        continue;
                    }
                    scnGame.addOneCardToMovingSlot(cardSlotMoving, card);
                    scnGame.placeMovingSlotToSlotAnimated(cardSlotMoving, grpColorSlots[i]);
                    scnGame.IncScore(+10, false);
                    //this.showNextCardFromSlot(grpCardSlots, cardSlotFrom);
                    return true;
                }
            }

            for (var i = 0; i < grpCardSlots.length; i++) {
                if (grpCardSlots[i].length == 1) {
                    //moving to same slot is not an option...
                    if (cardSlotFrom == grpCardSlots[i]) {
                        continue;
                    }
                    //moving K from one empty slot to another is not an option...
                    if (oldCardPosInSlot == 1) {
                        continue;
                    }
                    scnGame.addOneCardToMovingSlot(cardSlotMoving, card);
                    scnGame.placeMovingSlotToSlotAnimated(cardSlotMoving, grpCardSlots[i]);
                    //this.showNextCardFromSlot(grpCardSlots, cardSlotFrom);
                    return true;
                }
            }
            return;
        }

        //A-s
        if ((sign == 0) && (cardSlotMoving.length == 1)) {
            for (var i = 0; i < grpColorSlots.length; i++) {
                if (grpColorSlots[i].length == 0) {
                    scnGame.addOneCardToMovingSlot(cardSlotMoving, card);
                    scnGame.placeMovingSlotToSlotAnimated(cardSlotMoving, grpColorSlots[i]);

                    if (!prevSlot.includes("grpColorSlots")) {
                        // console.log("TA NEOBSAHUJE ", grpColorSlots[i].name, grpColorSlots[i].name.includes("grpColorSlots"));

                        var newSlot = grpColorSlots[i];
                        if (scnGame.isColorSlot(newSlot)) {
                            var ColorSlotColor = card.cardFrame / 13;
                            if (maxCardOfColor[ColorSlotColor] < 1) {
                                scnGame.IncScore(+10, false);
                            }
                        }

                        // }else {
                        // console.log("TA OBSAHUJE", grpColorSlots[i].name, grpColorSlots[i].name.includes("grpColorSlots"));
                    }

                    //this.showNextCardFromSlot(grpCardSlots, cardSlotFrom);
                    return true;
                }
            }
            card.secondClick = false;
            return false;
        }

        if (cardSlotMoving.length == 1) {
            for (var i = 0; i < grpColorSlots.length; i++) {
                if (grpColorSlots[i].length == 0) {
                    continue;
                }
                var ColorSlotColor = grpColorSlots[i].children[0].cardFrame / 13;

                if (ColorSlotColor != colour) {
                    continue;
                }

                var ColorSlotSign = grpColorSlots[i].children[grpColorSlots[i].length - 1].cardFrame % 13;

                if (sign - ColorSlotSign != 1) {
                    continue;
                }

                scnGame.addOneCardToMovingSlot(cardSlotMoving, card);
                scnGame.placeMovingSlotToSlotAnimated(cardSlotMoving, grpColorSlots[i]);
                if (grpColorSlots[i].length + 1 > maxCardOfColor[ColorSlotColor]) {
                    scnGame.IncScore(+10, false);
                }
                //this.showNextCardFromSlot(grpCardSlots, cardSlotFrom);
                return true;
            }
        }

        for (var i = 0; i < grpCardSlots.length; i++) {
            if (grpCardSlots[i] == cardSlotFrom) {
                continue;
            }

            if (grpCardSlots[i].length == 1) {
                continue;
            }

            if (grpCardSlots[i].children[grpCardSlots[i].length - 1].key == "cardBack") {
                continue;
            }

            var ColorSlotColor = Math.floor(grpCardSlots[i].children[grpCardSlots[i].length - 1].cardFrame / 13);

            if (ColorSlotColor % 2 == colour % 2) {
                continue;
            }

            var ColorSlotSign = grpCardSlots[i].children[grpCardSlots[i].length - 1].cardFrame % 13;

            if (ColorSlotSign - sign != 1) {
                continue;
            }

            var OldAdjacentCard = cardSlotFrom.children[oldCardPosInSlot - 1];
            if (OldAdjacentCard !== undefined) {
                if (!scnGame.IsCardBack(OldAdjacentCard)) {
                    var OldAdjacentCardColor = Math.floor(OldAdjacentCard.cardFrame / 13);
                    var OldAdjacentCardSign = Math.floor(OldAdjacentCard.cardFrame % 13);

                    //moving cards between two same adjacent cards is not an option...
                    if ((ColorSlotColor % 2 == OldAdjacentCardColor % 2) && (OldAdjacentCardSign == ColorSlotSign)) {
                        continue;
                    }
                }
            }

            scnGame.addOneCardToMovingSlot(cardSlotMoving, card);
            scnGame.placeMovingSlotToSlotAnimated(cardSlotMoving, grpCardSlots[i]);
            //this.showNextCardFromSlot(grpCardSlots, cardSlotFrom);
            return true;
        }

        //btnIngameUndo.frame = (undoRecords.length == 0) ? 1 : 0;
        scnGame.placeMovingSlotToSlot(cardSlotMoving, cardSlotFrom);

        return false;
    },

    updateMovingSlot: function () {
        if (cardSlotMoving.length == 0) {
            return;
        }

        if (animatingFlip || animatingSlot) {
            return;
        }

        cardSlotMoving.x = game.input.x + touchDeltaX;
        cardSlotMoving.y = game.input.y + touchDeltaY;

        //LOG("updateMovingSlot");

        cardUnderMovingSlot = scnGame.getCardUnderMovingSlot(cardSlotMoving, grpCardSlots);

        if (cardUnderMovingSlot == null) {
            if (sprTintedCard != null) {
                sprTintedCard.tint = 0xFFFFFF;
            }
            return;
        }

        if (!scnGame.canCardBePlacedOnCardSlot(cardSlotMoving.children[0].cardFrame, cardUnderMovingSlot.cardFrame)) {
            cardUnderMovingSlot = null;
        }

        if (cardUnderMovingSlot != null) {
            colour = Math.floor(cardUnderMovingSlot.cardFrame / 13);
            sign = cardUnderMovingSlot.cardFrame % 13;
            //console.log("cardUnderMovingSlot : " + cardUnderMovingSlot + " " + colour + " : " + sign);
            sprNewTintedCard = cardUnderMovingSlot;
            if (sprTintedCard != sprNewTintedCard) {
                if (sprTintedCard != null) {
                    sprTintedCard.tint = 0xFFFFFF;
                }
                sprTintedCard = sprNewTintedCard;
            }
            sprTintedCard.tint = 0xBBBBBB;
        }

        if (cardSlotMoving.length > 1) {
            return;
        }

        colorSlotsUnderMovingSlot = scnGame.getColorSlotUnderMovingSlot();

        if (colorSlotsUnderMovingSlot != null) {
            //console.log("colorSlotsUnderMovingSlot : " + colorSlotsUnderMovingSlot);
        }
    },

    getCardSlotUnderMovingSlot: function (movingSlot, cardSlots) {
        cardToTest = movingSlot.children[0];

        for (var i = 0; i < cardSlots.length; i++) {
            if (scnGame.spritesOverlaps(cardToTest, cardSlots[i].children[cardSlots[i].length - 1])) {
                return cardSlots[i];
            }
        }

        return null;
    },

    getCardUnderMovingSlot: function (movingSlot, cardSlots) {
        cardToTest = movingSlot.children[0];

        for (var i = 0; i < cardSlots.length; i++) {
            if (scnGame.spritesOverlaps(cardToTest, cardSlots[i].children[cardSlots[i].length - 1])) {
                return cardSlots[i].children[cardSlots[i].length - 1];
            }
        }

        return null;
    },

    getColorSlotUnderMovingSlot: function () {
        cardToTest = cardSlotMoving.children[0];

        for (var i = 0; i < cardHolder.length; i++) {
            if (scnGame.spritesOverlaps(cardToTest, cardHolder[i])) {
                return grpColorSlots[i];
            }
        }

        return null;
    },

    getCardSlotByCard: function (card, cardSlots) {
        for (var i = 0; i < cardSlots.length; i++) {
            for (var j = 0; j < cardSlots[i].length; j++) {
                if (cardSlots[i].children[j] == card) {
                    return cardSlots[i];
                }
            }
        }

        return null;
    },

    spritesOverlaps: function (spr1, spr2) {
        deltaX = Math.abs(spr1.worldPosition.x - spr2.worldPosition.x);
        if (deltaX > spr1.width / 2) {
            return false;
        }

        deltaY = Math.abs(spr1.worldPosition.y - spr2.worldPosition.y);
        //LOG("deltaY : " + deltaY + "[" + spr1.height + "]");
        if (deltaY > spr1.height) {
            return false;
        }

        return true;
    },

    canCardBePlacedOnCardSlot: function (cardToPlace, cardInSlot) { //  check rule -1, color
        colour1 = Math.floor(cardToPlace / 13);
        sign1 = cardToPlace % 13;

        if ((sign1 == 12) && (cardInSlot == CARD_SLOT_HOLDER)) {
            return true;
        }

        colour2 = Math.floor(cardInSlot / 13);
        sign2 = cardInSlot % 13;

        if ((colour1 % 2) == (colour2 % 2)) {
            return false;
        }
        if (sign1 - sign2 != -1) {
            return false;
        }

        return true;
    },

    IsCardSprite: function (spr) {
        if (spr.frameName.indexOf('karty') != 0) {
            return false;
        }

        return true;
    },

    IsCardBack: function (spr) {
        if (spr.frameName.indexOf('rub') != 0) {
            return false;
        }

        return true;
    },

    cardStopDrag: function (card) {
        if (card === undefined) {
            return;
        }

        if (card.secondClick) {
            if (!doubleHintPressed) {
                // card.secondClick = false;
                // game.time.events.add(10, function () {
                //     scnGame.cardStopDrag(this.card);
                // }, { card: card });

                if (animatingFlip || animatingSlot) {
                    return;
                }
                
                doubleHintPressed = true;

                setTimeout(function (card) {
                    if (scnGame.autoplaceCard(card)) {
                        scnGame.UpdateAchievementsHint();
                        incrementHintCounter();
                    }
                }, 1, card);

                // setTimeout(function (card) {
                //     console.log("SECOND 1")
                //     doubleHintPressed = true;
                //     scnGame.cardStopDrag(card);
                //     // scnGame.OnPressedIngameHint();
                // }, 10, card)
            }

            return;
        }

        if (animatingFlip || animatingSlot) {
            return;
        }

        if (cardSlotMoving.length < 1) {
            return;
        }

        if (!scnGame.slotContainsCard(cardSlotMoving, card)) {
            return;
        }

        LOG("[" + card.cardFrame + "] cardStopDrag");

        cardUnderMovingSlot = scnGame.getCardUnderMovingSlot(cardSlotMoving, grpCardSlots);

        // if (doubleHintPressed) {
        //     console.log("SECOND 2")
        //     scnGame.UpdateAchievementsHint();
        //     console.log("HINT COUNTER MINUS");
        //     incrementHintCounter();
        // }

        if (cardUnderMovingSlot != null) {
            if (cardUnderMovingSlot.cardFrame == CARD_SLOT_HOLDER) {
                //placing Ks on empty card slots
                if (cardSlotMoving.children[0].cardFrame % 13 != 12) {
                    // console.log("HINT: NIE JE TO KRAL VRACIA SA KARTA");
                    //scnGame.RemoveLastUndoRecord();
                    //btnIngameUndo.frame = (undoRecords.length == 0) ? 1 : 0;
                    scnGame.placeMovingSlotToSlot(cardSlotMoving, cardSlotFrom);
                    return;
                }

                newSlot = scnGame.getCardSlotUnderMovingSlot(cardSlotMoving, grpCardSlots);

                scnGame.placeMovingSlotToSlot(cardSlotMoving, newSlot);
                if (newSlot != cardSlotFrom) {
                    scnGame.showNextCardFromSlot(grpCardSlots, cardSlotFrom);
                } else {
                    //scnGame.RemoveLastUndoRecord();
                    //btnIngameUndo.frame = (undoRecords.length == 0) ? 1 : 0;
                }
                if (sprTintedCard != null) sprTintedCard.tint = 0xFFFFFF;
                // console.log("HINT: JE TO KRAL UKLADA SA KARTA");
                if (!hintPressed) {
                    incrementMovesCounter();
                } else {
                    hintPressed = false;
                }

                return;
            }

            if (!scnGame.canCardBePlacedOnCardSlot(cardSlotMoving.children[0].cardFrame, cardUnderMovingSlot.cardFrame)) {
                // console.log("HINT: NEDA SA POLOZIT KARTA NO RULES");
                cardUnderMovingSlot = null;
            }

            if (cardUnderMovingSlot != null) {
                newSlot = scnGame.getCardSlotByCard(cardUnderMovingSlot, grpCardSlots);

                if (newSlot !== cardSlotFrom) {
                    scnGame.placeMovingSlotToSlot(cardSlotMoving, newSlot);

                    if (!hintPressed) {
                        incrementMovesCounter();
                    } else {
                        hintPressed = false;
                    }

                } else {
                    scnGame.placeMovingSlotToSlot(cardSlotMoving, cardSlotFrom);
                }

                //if (newSlot != cardSlotFrom)
                //   scnGame.showNextCardFromSlot(grpCardSlots, cardSlotFrom);

                if (sprTintedCard != null) sprTintedCard.tint = 0xFFFFFF;
                // console.log("HINT: ROVNAKY STLPEC");

                return;
            }
        }

        if (cardSlotMoving.length > 1) {
            //scnGame.RemoveLastUndoRecord();
            //btnIngameUndo.frame = (undoRecords.length == 0) ? 1 : 0;
            scnGame.placeMovingSlotToSlot(cardSlotMoving, cardSlotFrom);
            if (sprTintedCard != null) sprTintedCard.tint = 0xFFFFFF;
            // console.log("HINT: z kopky sa vracia viac ako 1 karta");
            return;
        }

        colorSlotsUnderMovingSlot = scnGame.getColorSlotUnderMovingSlot();

        if (!scnGame.canCardBePlacedOnColorSlot(cardSlotMoving.children[0].cardFrame, colorSlotsUnderMovingSlot)) {
            // console.log("HINT: NEPASUJE RULE ASI HORNY PACK");
            colorSlotsUnderMovingSlot = null;
        }

        if (colorSlotsUnderMovingSlot != null) {
            var slotColor = Math.floor(cardSlotMoving.children[0].cardFrame / 13);
            if (colorSlotsUnderMovingSlot.length + 1 > maxCardOfColor[slotColor]) {
                scnGame.IncScore(+10, false);
            }
            scnGame.placeMovingSlotToSlot(cardSlotMoving, colorSlotsUnderMovingSlot);
            // console.log("HINT: DAVA SA KARTA DO KOPKY");
            if (!hintPressed) {
                incrementMovesCounter();
            } else {
                hintPressed = false;
            }

            //scnGame.showNextCardFromSlot(grpCardSlots, cardSlotFrom);
        } else {
            //scnGame.RemoveLastUndoRecord();
            //btnIngameUndo.frame = (undoRecords.length == 0) ? 1 : 0;
            scnGame.placeMovingSlotToSlot(cardSlotMoving, cardSlotFrom);
        }

        if (sprTintedCard != null) sprTintedCard.tint = 0xFFFFFF;
    },

    RemoveLastUndoRecord: function () {
        if (undoRecords.length <= 1) {
            return;
        }

        undoRecords.pop();
    },

    canCardBePlacedOnColorSlot: function (cardToPlace, colorSlot) {
        if (colorSlot == null) {
            return false;
        }

        colour1 = Math.floor(cardToPlace / 13);
        sign1 = cardToPlace % 13;

        if (colorSlot.children.length == 0) {
            return (sign1 == 0);
        }

        cardFrame = colorSlot.children[colorSlot.children.length - 1].cardFrame;
        colour2 = Math.floor(cardFrame / 13);
        sign2 = cardFrame % 13;

        if (colour1 != colour2) {
            return false;
        }
        if (sign1 - sign2 != 1) {
            return false;
        }

        return true;

    },

    //endregion

    //region BOTTOM BUTTONS

    OnPressedIngameHint: function () {
        if (animatingFlip || animatingSlot) {
            return;
        }

        if (hintCounter > 0) {
            soundManager.playSound('menu-click1');

            touchDeltaX = 0;
            touchDeltaY = 0;

            if (grpCardFromPack.children.length > 0) {
                cardSlotFrom = grpCardFromPack;
                var sprCard = grpCardFromPack.children[grpCardFromPack.children.length - 1];
                scnGame.removeCardOrCardsFromSlot(sprCard);
                hintPressed = true;

                if (scnGame.autoplaceCard(sprCard)) {
                    scnGame.UpdateAchievementsHint();
                    hintCounter--;
                    // console.log("HINT COUNRTE MINUS");
                    incrementHintCounter();
                    return;
                }

                scnGame.placeMovingSlotToSlot(cardSlotMoving, cardSlotFrom);
            }

            for (var i = 0; i < grpCardSlots.length; i++) {
                cardSlotFrom = grpCardSlots[i];
                for (var j = 1; j < grpCardSlots[i].length; j++) {
                    if (scnGame.IsCardBack(grpCardSlots[i].children[j])) {
                        continue;
                    }

                    var card = grpCardSlots[i].children[j];
                    scnGame.removeCardOrCardsFromSlot(card);
                    hintPressed = true;

                    if (scnGame.autoplaceCard(card, j)) {
                        scnGame.UpdateAchievementsHint();
                        hintCounter--;
                        // console.log("HINT COUNRTE MINUS");
                        incrementHintCounter();
                        return;
                    }

                    scnGame.placeMovingSlotToSlot(cardSlotMoving, cardSlotFrom);
                }
            }
        }

        /*
        for(var i = 0; i < grpColorSlots.length; i++) {
            cardSlotFrom = grpColorSlots[i];
            for (var j = 0; j < grpColorSlots[i].length; j++) {
                if (scnGame.IsCardBack(grpColorSlots[i].children[j]))
                    continue;

                if (scnGame.autoplaceCard(grpColorSlots[i].children[j])) {
                    scnGame.UpdateAchievementsHint();
                    return;
                }
            }
        }
        */

        ShakeObject(ingameButtons[1]);
        soundManager.playSound('nomove');

        scnGame.updateSlots();
    },

    OnPressedIngameUndo: function () {
        LOG("OnPressedIngameUndo()");

        if (animatingFlip || animatingSlot) {
            return;
        }

        if (moves > 0) moves--;


        soundManager.playSound('menu-click1');
        if (undoRecords.length <= 1) {
            ShakeObject(ingameButtons[1]);
            soundManager.playSound('nomove');
            return;
        }

        incrementUndoCounter();

        undoRecord = undoRecords.pop();
        scnGame.UpdateAchievementsUndo();
        undoRecord = undoRecords[undoRecords.length - 1];

        soundManager.playSound('undo');
        scnGame.ApplyUndoRecord(undoRecord);
        scnGame.IncMoves(+1, true);
        scnGame.updateSlots();
    },

    DebugApplyUndoRecord: function (undoRecord) {
        undoRecords = [];
        undoRecords.push(undoRecord);
        scnGame.ApplyUndoRecord(undoRecord);
    },

    RetryGame: function () {
        if (GameData.profile.retryCards === null) {
            return;
        }

        undoRecord = GameData.profile.retryCards;
        GameData.profile.retryCards = null;

        startTimer = false;
        gameTimer = 0;
        gameMoves = 0;
        gameScore = 0;
        gameScoreLV = -52;
        wasteRecycles = 0;
        gameAutocomplete = null;

        scnGame.ApplyUndoRecord(undoRecord);
        undoRecords = [];

        scnGame.createNextUndoRecord();
        scnGame.onResolutionChange();

        txtGameTimeVal.text = '00:00';
        txtGameMovesVal.text = '' + gameMoves;
        scnGame.UpdateScoreTxtControl();

        skipUndoRecord = false;
        animatingFlip = false;
        animatingSlot = false;
        cardSlotFrom = null;

        // if (GameData.profile.Draw1) {
        //     GameData.profile.TotalGamesD1++;
        // } else {
        //     GameData.profile.TotalGamesD3++;
        // }

        GameData.Save();

        soundManager.playSound('redeal');
        gameRunning = true;

        scnGame.onGameStart();
    },

    ApplyUndoRecord: function (undoRecord) {
        // game.time.desiredFps = SAVED_FPS;

        recCardPackNumbers = undoRecord['cpn'];
        recCardSlots = undoRecord['cs'];
        recColorSlots = undoRecord['cls'];
        recCardsFromPack = undoRecord['cfp'];
        gameScore = undoRecord['scr'];
        gameScoreLV = undoRecord['scrlv'];
        wasteRecycles = undoRecord['wrcs'];

        scnGame.UpdateScoreTxtControl();

        cardPackNumbers = [];
        for (var i = 0; i < recCardPackNumbers.length; i++) {
            cardPackNumbers[i] = recCardPackNumbers[i];
        }

        grpCardFromPack.removeChildren();

        for (var i = 0; i < 4; i++) {
            grpColorSlots[i].removeAll(true);
            maxCardOfColor[i] = undoRecord['clsmc'][i];
            for (var j = 0; j < recColorSlots[i].length; j++) {
                cardFrame = recColorSlots[i][j];
                if (GameData.profile.UsedCardFace === 3) {
                    sprCard = grpSceneGame.create(0, 0, 'game2', GetCardFrame(cardFrame));
                } else {
                    sprCard = grpSceneGame.create(0, 0, 'game', GetCardFrame(cardFrame));
                }
                sprCard.cardFrame = cardFrame;
                if (sprCard.cardFrame == 100) sprCard.cardFrame = 0;
                sprCard.anchor.set(0.5);
                game.physics.arcade.enable(sprCard);
                sprCard.inputEnabled = true;
                sprCard.events.onInputDown.add(scnGame.cardStartDrag, this);
                sprCard.events.onInputUp.add(scnGame.cardStopDrag, this);
                sprCard.secondClick = false;

                grpColorSlots[i].add(sprCard);
            }
        }

        for (var i = 0; i < 7; i++) {
            grpCardSlots[i].removeAll(true);

            sprCardSlotHolder = grpCardSlots[i].create(0, 0, 'game', 'nenieso');
            sprCardSlotHolder.anchor.set(0.5);
            sprCardSlotHolder.cardFrame = CARD_SLOT_HOLDER;
            sprCardSlotHolder.alpha = 0;

            for (var j = 0; j < recCardSlots[i].length; j++) {
                cardFrame = recCardSlots[i][j];
                if (cardFrame >= 0) {
                    if (GameData.profile.UsedCardFace === 3) {
                        sprCard = grpSceneGame.create(0, (j) * CARDS_DSPY, 'game2', GetCardFrame(cardFrame));
                    } else {
                        sprCard = grpSceneGame.create(0, (j) * CARDS_DSPY, 'game', GetCardFrame(cardFrame));
                    }
                } else {
                    sprCard = grpSceneGame.create(0, (j) * CARDS_DSPY, 'game', GetCardBackFrame());
                }
                sprCard.cardFrame = Math.abs(cardFrame);
                if (sprCard.cardFrame == 100) sprCard.cardFrame = 0;
                sprCard.anchor.set(0.5);
                game.physics.arcade.enable(sprCard);
                sprCard.inputEnabled = true;
                sprCard.events.onInputDown.add(scnGame.cardStartDrag, this);
                sprCard.events.onInputUp.add(scnGame.cardStopDrag, this);
                sprCard.secondClick = false;

                grpCardSlots[i].add(sprCard);
            }

            scnGame.compactCardSlot(grpCardSlots[i]);
        }

        grpCardFromPack.removeAll(true);
        for (var i = 0; i < recCardsFromPack.length; i++) {
            cardFrame = recCardsFromPack[i];
            if (GameData.profile.UsedCardFace === 3) {
                sprCard = grpSceneGame.create(0, 0, 'game2', GetCardFrame(cardFrame));
            } else {
                sprCard = grpSceneGame.create(0, 0, 'game', GetCardFrame(cardFrame));
            }

            sprCard.cardFrame = cardFrame;
            if (sprCard.cardFrame == 100) sprCard.cardFrame = 0;
            sprCard.anchor.set(0.5);
            game.physics.arcade.enable(sprCard);

            if (i == recCardsFromPack.length - 1) {
                sprCard.inputEnabled = true;
                sprCard.events.onInputDown.add(scnGame.cardStartDrag, this);
                sprCard.events.onInputUp.add(scnGame.cardStopDrag, this);
                sprCard.secondClick = false;
                sprCard.inputEnabled = true;
            }

            grpCardFromPack.addChild(sprCard);
        }

        sprCardsFromPack = [];

        var tmp3 = undoRecord['cfp3'];

        var idx = grpCardFromPack.children.length - 1;
        if (grpCardFromPack.children.length >= tmp3) {
            for (var i = tmp3 - 1; i >= 0; i--) {
                sprCardsFromPack[i] = grpCardFromPack.children[idx];
                idx--;
            }
        }

        scnGame.showAllCardsTakenFromPack();

        undoRecord['cfp'] = recCardsFromPack;
        undoRecord['scr'] = gameScore;
        undoRecord['scrlv'] = gameScoreLV;
        undoRecord['wrcs'] = wasteRecycles;

        sprCardPack.frameName = GetCardBackFrame();
        if (cardPackNumbers.length == 0) {
            sprCardPack.frameName = 'neniwaste';
            if (grpCardFromPack.length == 0) {
                sprCardPack.frameName = 'norecycle';
            }
        }

        scnGame.onResolutionChange();
    },

    UpdateScoreTxtControl: function () {
        if (GameData.profile.LasVegasScore) {
            txtGameScoreVal.text = gameScoreLV + '$';
        } else {
            txtGameScoreVal.text = '' + gameScore;
        }
    },

    //endregion

    //region HINTS

    UpdateAchievement: function (achievementIdx, inc, time) {
        if (GameData.profile.Achievements[achievementIdx] < 0) {
            return false;
        }

        if (time === undefined) {
            time = null;
        }

        if (time != null) {
            if (time < 0) {
                if (Math.abs(time) > Achievements[achievementIdx].time) {
                    return false;
                }
            } else {
                if (Math.abs(time) < Achievements[achievementIdx].time) {
                    return false;
                }
            }
        }

        retVal = false;

        GameData.profile.Achievements[achievementIdx]++;
        if (GameData.profile.Achievements[achievementIdx] == Achievements[achievementIdx].count) {
            retVal = true;
        }

        if (GameData.profile.Achievements[achievementIdx] >= Achievements[achievementIdx].count) {
            GameData.profile.Achievements[achievementIdx] = Achievements[achievementIdx].count;
        }

        GameData.Save();

        SceneMenu.instance.UpdateAchievementsNotification();

        return retVal;
    },

    ResetAchievement: function (achievementIdx) {
        if (GameData.profile.Achievements[achievementIdx] < 0) {
            return false;
        }

        GameData.profile.Achievements[achievementIdx] = 0;
        GameData.Save();
        SceneMenu.instance.UpdateAchievementsNotification();
    },

    ShowUnlockedAchievement: function (achievementIdx) {
        soundManager.playSound('achieve');

        txtAchievementPopupTitle.STR = Achievements[achievementIdx].title;
        txtAchievementPopupTitle.text = STR(txtAchievementPopupTitle.STR);

        SceneAchievementPopup.instance.onResolutionChange();

        ScenesTransitions.showSceneAlpha(grpAchievementPopup, 0, ScenesTransitions.TRANSITION_LENGTH, function () {
            ScenesTransitions.hideSceneAlpha(grpAchievementPopup, 2000);
        });
    },

    UpdateAchievementsTime: function (time) {
        var timeInMins = (time / 1000 / 60);

        if (GameData.profile.Draw1) {
            if (scnGame.UpdateAchievement(ACHIEVEMENT_D1_TIME1, 1, -timeInMins)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_D1_TIME1);
            }
            if (scnGame.UpdateAchievement(ACHIEVEMENT_D1_TIME2, 1, -timeInMins)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_D1_TIME2);
            }
            if (scnGame.UpdateAchievement(ACHIEVEMENT_D1_TIME3, 1, timeInMins)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_D1_TIME3);
            }
            if (scnGame.UpdateAchievement(ACHIEVEMENT_D1_TIME4, 1, timeInMins)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_D1_TIME4);
            }
        } else {
            if (scnGame.UpdateAchievement(ACHIEVEMENT_D3_TIME1, 1, -timeInMins)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_D3_TIME1);
            }
            if (scnGame.UpdateAchievement(ACHIEVEMENT_D3_TIME2, 1, -timeInMins)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_D3_TIME2);
            }
            if (scnGame.UpdateAchievement(ACHIEVEMENT_D3_TIME3, 1, timeInMins)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_D3_TIME3);
            }
            if (scnGame.UpdateAchievement(ACHIEVEMENT_D3_TIME4, 1, timeInMins)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_D3_TIME4);
            }
        }
    },

    UpdateAchievementsWin: function () {
        if (GameData.profile.Draw1) {
            if (scnGame.UpdateAchievement(ACHIEVEMENT_WIN1_D1, 1)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_WIN1_D1);
            }
            if (scnGame.UpdateAchievement(ACHIEVEMENT_WIN2_D1, 1)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_WIN2_D1);
            }
            if (scnGame.UpdateAchievement(ACHIEVEMENT_WIN3_D1, 1)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_WIN3_D1);
            }

            if (scnGame.UpdateAchievement(ACHIEVEMENT_NOVICE_D1, 1)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_NOVICE_D1);
            }
            if (scnGame.UpdateAchievement(ACHIEVEMENT_EXPERT_D1, 1)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_EXPERT_D1);
            }
        } else {
            if (scnGame.UpdateAchievement(ACHIEVEMENT_WIN1_D3, 1)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_WIN1_D3);
            }
            if (scnGame.UpdateAchievement(ACHIEVEMENT_WIN2_D3, 1)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_WIN2_D3);
            }
            if (scnGame.UpdateAchievement(ACHIEVEMENT_WIN3_D3, 1)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_WIN3_D3);
            }

            if (scnGame.UpdateAchievement(ACHIEVEMENT_NOVICE_D3, 1)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_NOVICE_D3);
            }
            if (scnGame.UpdateAchievement(ACHIEVEMENT_EXPERT_D3, 1)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_EXPERT_D3);
            }
        }
    },

    ResetAchievementsWinOnRestart: function () {
        if (GameData.profile.Draw1) {
            scnGame.ResetAchievement(ACHIEVEMENT_WIN2_D1);
        } else {
            scnGame.ResetAchievement(ACHIEVEMENT_WIN2_D3);
        }
    },

    UpdateAchievementsUndo: function () {
        if (scnGame.UpdateAchievement(ACHIEVEMENT_UNDO1, 1)) {
            scnGame.ShowUnlockedAchievement(ACHIEVEMENT_UNDO1);
        }

        if (scnGame.UpdateAchievement(ACHIEVEMENT_UNDO2, 1)) {
            scnGame.ShowUnlockedAchievement(ACHIEVEMENT_UNDO2);
        }
    },

    UpdateAchievementsBestScore: function () {
        if (GameData.profile.Draw1) {
            if (GameData.profile.BestScoreD1 == 0) {
                return;
            }
            if (GameData.profile.BestScoreD1 >= gameScore) {
                return;
            }

            if (scnGame.UpdateAchievement(ACHIEVEMENT_BEATSCORE_D1, 1)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_BEATSCORE_D1);
            }
        } else {
            if (GameData.profile.BestScoreD3 == 0) {
                return;
            }
            if (GameData.profile.BestScoreD3 >= gameScore) {
                return;
            }

            if (scnGame.UpdateAchievement(ACHIEVEMENT_BEATSCORE_D3, 1)) {
                scnGame.ShowUnlockedAchievement(ACHIEVEMENT_BEATSCORE_D3);
            }
        }

    },

    UpdateAchievementsHint: function () {
        if (scnGame.UpdateAchievement(ACHIEVEMENT_HINT1, 1)) {
            scnGame.ShowUnlockedAchievement(ACHIEVEMENT_HINT1);
        }
        if (scnGame.UpdateAchievement(ACHIEVEMENT_HINT2, 1)) {
            scnGame.ShowUnlockedAchievement(ACHIEVEMENT_HINT2);
        }
        if (scnGame.UpdateAchievement(ACHIEVEMENT_HINT3, 1)) {
            scnGame.ShowUnlockedAchievement(ACHIEVEMENT_HINT3);
        }
    },

    //endregion

    //region SHOW & HIDE

    ShowAnimated: function () {
        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Quadratic.Out;
        ScenesTransitions.showSceneAlpha(grpSceneGame, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
    },

    HideAnimated: function () {

    },

    //endregion

    onGameOver: function (lvlEndType) {
        // gameTimer, gameScore
        // console.log('onGameOver', lvlEndType, gameTimer, gameScore);

        //-RPLC:ONGAMEOVER-//

        //PPS_USE-CLOUDGAMES
        /*
        cldapi_gameOver();
        //PPS_USE-CLOUDGAMES
        */

        if (lvlEndType === GAME_OVER_WIN) {
            //-RPLC:ONGAMEOVER_BYGAME-//

            //PPS_USE-INLOGICleaderboard
            /*
            if(typeof INLOGIC_LEADERBOARD !== "undefined") {INLOGIC_LEADERBOARD.saveScore(gameScore, 2);}
            //PPS_USE-INLOGICleaderboard
            */

            //PPS_USE-MOOSITE
            /*
            miniplaySend2API('score', gameScore);
            //PPS_USE-MOOSITE
            */

            //PPS_USE-SDK:iWIN
            /*
            iConsole.game.postHighScore( {score: gameScore} ).result();
            //PPS_USE-SDK:iWIN
            */
        }

        //PPS_USE-SPILGAMES
        /*
        GameAPI.GameBreak.request(pauseGame, resumeGame);
        //PPS_USE-SPILGAMES
        */

        this.showAdvert();

        //PPS_USE-YANDEX
        /*
        showYandexAd();
        //PPS_USE-YANDEX
        */
    },

    showAdvert: function () {
        //PPS_USE-GAME_DISTRIBUTION
        /*
        gdsdk.showBanner();
        //PPS_USE-GAME_DISTRIBUTION
        */

        //PPS_USE-DISTRIBUTE_GAMES
        /*
        if (typeof sdk !== 'undefined' && sdk.showBanner !== 'undefined') {
            sdk.showBanner();
        }
        //PPS_USE-DISTRIBUTE_GAMES
        // */

        //PPS_USE-INLOGICcampaigns
        /*
        if (typeof showCampaign != "undefined") {
            var campaignShowed = showCampaign();

            if (campaignShowed) return;
        }
        //PPS_USE-INLOGICcampaigns
        */

        //PPS_USE-WildTangent
        /*
        game.time.events.add(100, function () {
            window.parent.postMessage( "event=pause_ready", "*" );
        });
        //PPS_USE-WildTangent
        */
    }
};

var GAME_OVER_WIN = 1;
var GAME_OVER_BY_USER = 2;

function GetSelectedBackground() {
    return 'bg';
};

function GetSelectedThemeTopBar() {
    return 'hornybar';
};

function GetSelectedThemeAchievementBar() {
    return 'achievebar_3';
};

function GetSelectedThemeAchievementFntColor() {
    switch (GameData.profile.UsedBackground) {
        case 0:
            return 0x3EA393;
        case 1:
            return 0x397294;
        case 2:
            return 0x246D26;
        case 3:
            return 0xE58975;
        case 4:
            return 0x293A56;

    }

    return 0xFFFFFF;
};

function GetSelectedThemeTopBarFontCol() {
    switch (GameData.profile.UsedBackground) {
        case 0:
        case 1:
        case 4:
            return 0x66aecb;
        case 2:
            return 0x4a9b43;
        case 3:
            return 0xf9e0b2;
    }

    return 0xFFFFFF;
};

function GetCardBackFrame() {
    return 'rub' + (GameData.profile.UsedCardBack + 1);
};

function GetCardFrame(cardIdx) {
    if (cardIdx == 100) {
        cardIdx = 0;
    }

    return 'karty' + (GameData.profile.UsedCardFace + 1) + '_' + cardIdx;
};

function GetSelectedIngameButton() {
    return 'button';
};

function incrementMovesCounter() {
    // moves++;

    if (GameData.profile.Draw1) {
        if (hintCounter < maxHintCountD1) moves++;

        if (moves === newHintMovesD1) {
            moves = 0;
            if (hintCounter < maxHintCountD1) {
                hintCounter++;
            }
        }
    } else {
        if (hintCounter < maxHintCountD3) moves++;

        if (moves === newHintMovesD3) {
            moves = 0;
            if (hintCounter < maxHintCountD3) {
                hintCounter++;
            }
        }
    }

    GameData.Save();
}

function incrementHintCounter() {
    if (GameData.profile.Draw1) {
        GameData.profile.hintCounterD1++;
    } else {
        GameData.profile.hintCounterD3++;
    }
    GameData.Save();
    doubleHintPressed = false;
}

function incrementUndoCounter() {
    if (GameData.profile.Draw1) {
        GameData.profile.undoCounterD1++;
    } else {
        GameData.profile.undoCounterD3++;
    }
    GameData.Save();
}

function checkGameover() {
    var availableMoves = 0;

    var lastCards = [];
    for (var colorIdx = 0; colorIdx < grpColorSlots.length; colorIdx++) {
        var col = grpColorSlots[colorIdx];

        if (col.length > 0) {
            var name = col.children[col.length - 1].frameName;
            lastCards.push(parseInt(name.split("_")[1].split(".")[0]));
        } else {
            lastCards.push(-1);
        }
    }

    // console.log("MID COL LAST CARD", grpCardSlots.length);
    var lastCardsMid = [];
    for (var colIdx = 0; colIdx < grpCardSlots.length; colIdx++) {
        var col = grpCardSlots[colIdx];

        if (col.children.length > 1) {
            var lastCard = parseInt(col.children[col.length - 1].frameName.split("_")[1].split(".")[0]);
            lastCardsMid.push(lastCard);
        } else {
            lastCardsMid.push(-1);
        }
    }

    // console.log(lastCards);
    // console.log(lastCardsMid);

    if (GameData.profile.Draw1) {
        // console.log("---- LAVY HORNY PACK", cardPackNumbers.length);
        for (var idx = 0; idx < cardPackNumbers.length; idx++) {
            var key = parseInt(cardPackNumbers[idx]);
            // ak pasuje dole
            if (isAce(key)) {
                // console.log("JE TAM ASO", key);
                availableMoves++;
            } else if (checkCardToPack(key, lastCards)) {
                // console.log("JE TAM KARTA DO KOPKY", key);
                availableMoves++;
            } else {
                for (var midIdxCol = 0; midIdxCol < lastCardsMid.length; midIdxCol++) {
                    if (lastCardsMid[midIdxCol] === -1) {
                        if (isKing(key)) {
                            // console.log("JE TO KRAL PRAZDNY STLPEC -> DOLE", key, midIdxCol);
                            availableMoves++;
                        }
                    } else if (checkRuleColor(lastCardsMid[midIdxCol], key)) {
                        // console.log("JE TAM KARTA -> DOLE ", key, lastCardsMid[midIdxCol]);
                        availableMoves++;
                    }
                }
            }
        }

        // console.log("---- PRAVY HORNY PACK", grpCardFromPack.children.length);
        for (var colIdx = 0; colIdx < grpCardFromPack.children.length; colIdx++) {
            var card = grpCardFromPack.children[colIdx];
            var key = parseInt(card.frameName.split("_")[1].split(".")[0]);
            // console.log("PACK:", card.frameName, key);

            if (isAce(key)) {
                // console.log("JE TAM ASO", key);
                availableMoves++;
            } else if (checkCardToPack(key, lastCards)) {
                // console.log("JE TAM KARTA DO KOPKY", key);
                availableMoves++;
            } else {
                for (var midIdxCol = 0; midIdxCol < lastCardsMid.length; midIdxCol++) {
                    if (lastCardsMid[midIdxCol] === -1) {
                        if (isKing(key)) {
                            // console.log("JE TO KRAL -> DOLE", key, midIdxCol);
                            availableMoves++;
                        }
                    } else if (checkRuleColor(lastCardsMid[midIdxCol], key)) {
                        // console.log("JE TAM KARTA -> DOLE", key, lastCardsMid[midIdxCol]);
                        availableMoves++;
                    }
                }
            }
        }
    } else {
        // console.log("---- LAVY HORNY PACK", cardPackNumbers.length);

        var offset = (cardPackNumbers.length - 1) % 3;
        for (var idx = cardPackNumbers.length - 1; idx >= 0; idx--) {
            var key = parseInt(cardPackNumbers[idx]);

            if ((cardPackNumbers.length - 1 - idx) % 3 === 2 || idx === 0) {
                // ak pasuje dole
                if (isAce(key)) {
                    // console.log("JE TAM ASO", key);
                    availableMoves++;
                } else if (checkCardToPack(key, lastCards)) {
                    // console.log("JE TAM KARTA DO KOPKY", key);
                    availableMoves++;
                } else {
                    for (var midIdxCol = 0; midIdxCol < lastCardsMid.length; midIdxCol++) {
                        if (lastCardsMid[midIdxCol] === -1) {
                            if (isKing(key)) {
                                // console.log("JE TO KRAL PRAZDNY STLPEC -> DOLE", key, midIdxCol);
                                availableMoves++;
                            }
                        } else if (checkRuleColor(lastCardsMid[midIdxCol], key)) {
                            // console.log("JE TAM KARTA -> DOLE ", key, lastCardsMid[midIdxCol]);
                            availableMoves++;
                        }
                    }
                }
            }
        }

        // console.log("---- PRAVY HORNY PACK", grpCardFromPack.children.length);
        for (var colIdx = 0; colIdx < grpCardFromPack.children.length; colIdx++) {

            var card = grpCardFromPack.children[colIdx];
            var key = parseInt(card.frameName.split("_")[1].split(".")[0]);
            // console.log("PACK:", card.frameName, key);


            if (colIdx % 3 === 2 || colIdx === grpCardFromPack.children.length - 1) {
                if (isAce(key)) {
                    // console.log("JE TAM ASO", key);
                    availableMoves++;
                } else if (checkCardToPack(key, lastCards)) {
                    // console.log("JE TAM KARTA DO KOPKY", key);
                    availableMoves++;
                } else {
                    for (var midIdxCol = 0; midIdxCol < lastCardsMid.length; midIdxCol++) {
                        if (lastCardsMid[midIdxCol] === -1) {
                            if (isKing(key)) {
                                // console.log("JE TO KRAL -> DOLE", key, midIdxCol);
                                availableMoves++;
                            }
                        } else if (checkRuleColor(lastCardsMid[midIdxCol], key)) {
                            // console.log("JE TAM KARTA -> DOLE", key, lastCardsMid[midIdxCol]);
                            availableMoves++;
                        }
                    }
                }
            }
        }
    }


    // console.log("---- COLOR PACK -> DOLE");
    for (var topIdx = 0; topIdx < lastCards.length; topIdx++) {
        if (lastCards[topIdx] === -1) continue;

        for (var midIdx = 0; midIdx < lastCardsMid.length; midIdx++) {
            if (lastCardsMid[midIdx] === -1) continue;

            if (checkRuleColor(lastCardsMid[midIdx], lastCards[topIdx])) {
                // console.log("DA SA DAT DOLE", lastCards[topIdx], lastCardsMid[midIdx]);
                availableMoves++;
            }
        }
    }

    // console.log("---- DOLE STLPCE", grpCardSlots.length);
    for (var midColIdx = 0; midColIdx < grpCardSlots.length; midColIdx++) {
        var col = grpCardSlots[midColIdx];
        // console.log("STLPEC 0-6", midColIdx)

        for (var idxCard = 0; idxCard < col.children.length; idxCard++) {
            var card = col.children[idxCard];

            if (card.frameName === "nenieso" || card.frameName.indexOf("rub") > -1) {
                continue;
            } else {
                var key = parseInt(card.frameName.split("_")[1].split(".")[0]);
                // console.log(card.frameName, key);

                if (idxCard > 1 && isKing(key)) {
                    if (checkCardToPack(key, lastCards)) {
                        // console.log("KRAL SA DA DAT HORE", key, lastCards);
                        availableMoves++;
                    } else {
                        for (var idx = 0; idx < lastCardsMid.length; idx++) {
                            if (lastCardsMid[idx] === -1) {
                                // console.log("KRAL -> PRAZDNY STLPEC", key, lastCardsMid[idx]);
                                availableMoves++;
                            }
                        }
                    }
                } else {
                    if (idxCard < col.children.length) {// TODO  otestovat
                        if (idxCard === col.children.length - 1 && (checkCardToPack(key, lastCards) || isAce(key))) {
                            // console.log("TA DAVAJ HET  HORE POSLEDNA KARTA V STLPCI", key, col.children[idxCard].frameName.split("_")[1].split(".")[0])
                            availableMoves++;
                        } else {
                            for (var midIdx = 0; midIdx < lastCardsMid.length; midIdx++) {
                                if (lastCardsMid[midIdx] === -1) continue;
                                if (midIdx === midColIdx) continue;

                                if (checkRuleColor(lastCardsMid[midIdx], key)) {
                                    if (idxCard > 0) {
                                        var prevCard = col.children[idxCard - 1];

                                        if (prevCard.frameName.indexOf("rub") > -1) {
                                            // console.log("TA DAVAJ DO INEHO STLPCA A OSLOBOD KARTU :D ", key, prevCard.frameName);
                                            availableMoves++;
                                        } else if (idxCard > 1) {
                                            var prevKey = parseInt(prevCard.frameName.split("_")[1].split(".")[0]);
                                            if (checkCardToPack(prevKey, lastCards)) {
                                                // console.log("DA SA DAT DO INEHO STLPCA", key, lastCardsMid[midIdx], prevKey);
                                                availableMoves++;
                                            }
                                        } else {
                                            // console.log("VYPRAZDNI STLPEC", key, lastCardsMid[midIdx]);
                                            availableMoves++;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    if (availableMoves === 0) {
        for (var i = 0; i < grpColorSlots.length; i++) {
            if (grpColorSlots[i].children.length < 13) {
                soundManager.playSound('lose');
                GameData.profile.savedMoved = 0;
                GameData.Save();
                SceneNoMoves.instance.ShowAnimated();
                return;
            }
        }
    }
}

function isAce(value) {
    return value % 13 === 0;
}

function isKing(value) {
    return value % 13 === 12;
}

function checkCardToPack(value, colorCards) {
    for (var idx = 0; idx < colorCards.length; idx++) {
        if (parseInt(colorCards[idx]) === -1) continue;
        if (parseInt(colorCards[idx]) % 13 === 12) continue;
        if (parseInt(colorCards[idx]) + 1 === value) {
            return true;
        }
    }
    return false;
}

function isRed(value) {
    return Math.floor(value / 13) % 2 === 0;
}

function checkRuleColor(topValue, bottomValue) {
    return (topValue % 13 === (bottomValue % 13) + 1) && (isRed(topValue) !== isRed(bottomValue));
}

function removeColorSlots() {
    for (var slot = 0; slot < grpColorSlots.length; slot++) {
        grpColorSlots[slot].removeAll();
    }
}