var WRAP_CHARS = 36;

var SceneInstructions = function () {
    SceneInstructions.instance = this;

    this.create();
};

SceneInstructions.instance = null;

SceneInstructions.prototype = {

    create: function () {
        grpSceneInstructions = game.add.group();
        grpSceneInstructions.name = 'grpSceneInstructions';

        imgInstructionsBG = game.make.sprite(0, 0, 'bg');
        imgInstructionsBG.anchor.set(0);
        imgInstructionsBG.inputEnabled = true;
        grpSceneInstructions.addChild(imgInstructionsBG);

        topBarInst = gameState.CreateCaptionBar(grpSceneInstructions, 'INSTRUCTIONS_TITLE');

        imgInstructionsAnchor = game.make.sprite(0, 0, 'pak1', 'blank');
        imgInstructionsAnchor.anchor.set(0);
        imgInstructionsBG.addChild(imgInstructionsAnchor);

        var exitBtn = game.make.sprite(0, 0, 'pak1', 'close');
        exitBtn.scale.set(0.9);
        exitBtn.anchor.setTo(1, 0);
        topBarInst.itemAnchor.addChild(exitBtn);
        AddButtonEvents(exitBtn, function () {
            soundManager.playSound('menu-click1');
            SceneInstructions.instance.HideAnimated();
        }, ButtonOnInputOver, ButtonOnInputOut);
        this.exitBtn = exitBtn;

        var contentGroup = game.make.group();
        this.contentGroup = contentGroup;
        contentGroup.topY = game.width * 0.22;
        contentGroup.y = contentGroup.topY;
        imgInstructionsAnchor.addChild(contentGroup);

        var textsOffset = game.width * 0.1;

        var ins1_img = game.make.sprite(0, 0, 'instr', 'tutorial1');
        ins1_img.scale.set(game.width / 680);
        ins1_img.x = (game.width - ins1_img.width) / 2;
        ins1_img.paramsObj = { yOffsetFromPrevious: 0 };
        contentGroup.addChild(ins1_img);

        txtInstructionParagraphs = [];

        var ins2_text = this.CreateInsText({ yOffsetFromPrevious: textsOffset / 2, textID: 'INSTRUCTIONS_01a' });
        contentGroup.addChild(ins2_text);
        txtInstructionParagraphs.push(ins2_text);

        var ins3_text = this.CreateInsText({ yOffsetFromPrevious: textsOffset, textID: 'INSTRUCTIONS_02a' });
        contentGroup.addChild(ins3_text);
        txtInstructionParagraphs.push(ins3_text);

        var ins4_img = game.make.sprite(0, ins3_text.y + ins3_text.height + Math.floor(textsOffset * 0.7), 'instr', 'tutorial2');
        ins4_img.scale.set(game.width / 680);
        ins4_img.x = (game.width - ins4_img.width) / 2;
        ins4_img.paramsObj = { yOffsetFromPrevious: Math.floor(textsOffset * 0.7) };
        contentGroup.addChild(ins4_img);

        var ins5_text = this.CreateInsText({ yOffsetFromPrevious: Math.floor(textsOffset * 0.7), textID: 'INSTRUCTIONS_03a' });
        contentGroup.addChild(ins5_text);
        txtInstructionParagraphs.push(ins5_text);

        var ins6_text = this.CreateInsText({ yOffsetFromPrevious: textsOffset, textID: 'INSTRUCTIONS_04a' });
        contentGroup.addChild(ins6_text);
        txtInstructionParagraphs.push(ins6_text);

        var ins7_text = this.CreateInsText({ yOffsetFromPrevious: textsOffset, textID: 'INSTRUCTIONS_05a' });
        contentGroup.addChild(ins7_text);
        txtInstructionParagraphs.push(ins7_text);

        var ins8_text = this.CreateInsText({ yOffsetFromPrevious: textsOffset, textID: 'INSTRUCTIONS_06' });
        contentGroup.addChild(ins8_text);
        txtInstructionParagraphs.push(ins8_text);

        var ins9_text = this.CreateInsText({ yOffsetFromPrevious: textsOffset, textID: 'INSTRUCTIONS_07' });
        contentGroup.addChild(ins9_text);
        txtInstructionParagraphs.push(ins9_text);

        var ins10_text = this.CreateInsText({ yOffsetFromPrevious: textsOffset, textID: 'INSTRUCTIONS_08' });
        contentGroup.addChild(ins10_text);
        txtInstructionParagraphs.push(ins10_text);

        var ins11_text = this.CreateInsText({ yOffsetFromPrevious: textsOffset, textID: 'INSTRUCTIONS_09', fontSize: 32 });
        contentGroup.addChild(ins11_text);
        txtInstructionParagraphs.push(ins11_text);

        // table1
        ins12_table1 = game.make.sprite(0, ins11_text.y + ins11_text.height + Math.floor(textsOffset * 0.4), 'instr', 'tabulkastandart');
        var stlpec1_x = Math.floor(ins12_table1.width * 0.37);
        var stlpec2_x = Math.floor(ins12_table1.width * 0.86);

        ins12_table1.scale.set(game.width / 680);
        ins12_table1.x = (game.width - ins12_table1.width) / 2;
        ins12_table1.paramsObj = { yOffsetFromPrevious: Math.floor(textsOffset * 0.4) };
        contentGroup.addChild(ins12_table1);

        var riadok_init = 23;
        var riadok_offset = 45;
        var tab1_text_11 = this.CreateInsText({ x: stlpec1_x, y: riadok_init, textID: 'MOVES', align: 'center', fill: 0x000000, anchX: 0.5, anchY: 0.5, fontSize: 36, skipResMul: true });
        ins12_table1.addChild(tab1_text_11);
        txtInstructionParagraphs.push(tab1_text_11);

        tab1_text_12 = this.CreateInsText({ x: stlpec1_x, y: riadok_init + riadok_offset, textID: 'INSTRUCTIONS_NEW_GAME_START', align: 'center', anchX: 0.5, anchY: 0.5, fontSize: 30, skipResMul: true, skipResMul: true });
        ins12_table1.addChild(tab1_text_12);
        txtInstructionParagraphs.push(tab1_text_12);

        tab1_text_13 = this.CreateInsText({ x: stlpec1_x, y: riadok_init + riadok_offset * 2, textID: 'INSTRUCTIONS_WASTE_TO_THE_TABLEAU', align: 'center', anchX: 0.5, anchY: 0.5, fontSize: 30, skipResMul: true });
        ins12_table1.addChild(tab1_text_13);
        txtInstructionParagraphs.push(tab1_text_13);

        tab1_text_14 = this.CreateInsText({ x: stlpec1_x, y: riadok_init + riadok_offset * 3, textID: 'INSTRUCTIONS_WASTE_TO_FOUNDATION', align: 'center', anchX: 0.5, anchY: 0.5, fontSize: 30, skipResMul: true });
        ins12_table1.addChild(tab1_text_14);
        txtInstructionParagraphs.push(tab1_text_14);

        tab1_text_15 = this.CreateInsText({ x: stlpec1_x, y: riadok_init + riadok_offset * 4, textID: 'INSTRUCTIONS_TABLEAU_TO_THE_FOUNDATION', align: 'center', anchX: 0.5, anchY: 0.5, fontSize: 30, skipResMul: true });
        ins12_table1.addChild(tab1_text_15);
        txtInstructionParagraphs.push(tab1_text_15);

        tab1_text_16 = this.CreateInsText({ x: stlpec1_x, y: riadok_init + riadok_offset * 5, textID: 'INSTRUCTIONS_TURN_OVER_TABLEAU_CARD', align: 'center', anchX: 0.5, anchY: 0.5, fontSize: 30, skipResMul: true });
        ins12_table1.addChild(tab1_text_16);
        txtInstructionParagraphs.push(tab1_text_16);

        var tab1_text_21 = this.CreateInsText({ x: stlpec2_x, y: riadok_init, textID: 'POINTS', align: 'center', fill: 0x000000, anchX: 0.5, anchY: 0.5, fontSize: 36, skipResMul: true });
        ins12_table1.addChild(tab1_text_21);
        txtInstructionParagraphs.push(tab1_text_21);

        var tab1_text_22 = this.CreateInsText({ x: stlpec2_x, y: riadok_init + riadok_offset, textID: 'INSTRUCTIONS_0POINTS', align: 'center', anchX: 0.5, anchY: 0.5, fontSize: 30, skipResMul: true });
        ins12_table1.addChild(tab1_text_22);
        txtInstructionParagraphs.push(tab1_text_22);

        var tab1_text_23 = this.CreateInsText({ x: stlpec2_x, y: riadok_init + riadok_offset * 2, textID: 'INSTRUCTIONS_PLUS_5POINTS', align: 'center', anchX: 0.5, anchY: 0.5, fontSize: 30, skipResMul: true });
        ins12_table1.addChild(tab1_text_23);
        txtInstructionParagraphs.push(tab1_text_23);

        var tab1_text_24 = this.CreateInsText({ x: stlpec2_x, y: riadok_init + riadok_offset * 3, textID: 'INSTRUCTIONS_PLUS_10POINTS', align: 'center', anchX: 0.5, anchY: 0.5, fontSize: 30, skipResMul: true });
        ins12_table1.addChild(tab1_text_24);
        txtInstructionParagraphs.push(tab1_text_24);

        var tab1_text_25 = this.CreateInsText({ x: stlpec2_x, y: riadok_init + riadok_offset * 4, textID: 'INSTRUCTIONS_PLUS_10POINTS', align: 'center', anchX: 0.5, anchY: 0.5, fontSize: 30, skipResMul: true });
        ins12_table1.addChild(tab1_text_25);
        txtInstructionParagraphs.push(tab1_text_25);

        var tab1_text_26 = this.CreateInsText({ x: stlpec2_x, y: riadok_init + riadok_offset * 5, textID: 'INSTRUCTIONS_PLUS_5POINTS', align: 'center', anchX: 0.5, anchY: 0.5, fontSize: 30, skipResMul: true });
        ins12_table1.addChild(tab1_text_26);
        txtInstructionParagraphs.push(tab1_text_26);
        // table1

        var ins13_text = this.CreateInsText({ yOffsetFromPrevious: textsOffset, textID: 'INSTRUCTIONS_11' });
        contentGroup.addChild(ins13_text);
        txtInstructionParagraphs.push(ins13_text);
        /*
                var ins14_text = this.CreateInsText({yOffsetFromPrevious: textsOffset, textID: 'INSTRUCTIONS_12', fontSize: 36});
                contentGroup.addChild(ins14_text);
                txtInstructionParagraphs.push(ins14_text);
        
                // table2
                var ins15_table2 = game.make.sprite(0, ins14_text.y + ins14_text.height + Math.floor(textsOffset * 0.4), 'instr', 'tabulkalasvegas.png');
                ins15_table2.x = (game.width - ins15_table2.width)/2;
                ins15_table2.paramsObj = {yOffsetFromPrevious: Math.floor(textsOffset * 0.4)};
                contentGroup.addChild(ins15_table2);
        
                var tab2_text_11 = this.CreateInsText({x: stlpec1_x, y: riadok_init, textID: 'MOVES', align: 'center', fill: 0xffffff, anchX: 0.5, anchY: 0.5});
                ins15_table2.addChild(tab2_text_11);
                txtInstructionParagraphs.push(tab2_text_11);
        
                var tab2_text_12 = this.CreateInsText({x: stlpec1_x, y: riadok_init + riadok_offset, textID: 'INSTRUCTIONS_NEW_GAME_START', align: 'center', anchX: 0.5, anchY: 0.5, fontSize: 19});
                ins15_table2.addChild(tab2_text_12);
                txtInstructionParagraphs.push(tab2_text_12);
        
                var tab2_text_13 = this.CreateInsText({x: stlpec1_x, y: riadok_init + riadok_offset * 2, textID: 'INSTRUCTIONS_WASTE_TO_THE_TABLEAU', align: 'center', anchX: 0.5, anchY: 0.5, fontSize: 19});
                ins15_table2.addChild(tab2_text_13);
                txtInstructionParagraphs.push(tab2_text_13);
        
                var tab2_text_21 = this.CreateInsText({x: stlpec2_x, y: riadok_init, textID: 'POINTS', align: 'center', fill: 0xffffff, anchX: 0.5, anchY: 0.5});
                ins15_table2.addChild(tab2_text_21);
                txtInstructionParagraphs.push(tab2_text_21);
        
                var tab2_text_22 = this.CreateInsText({x: stlpec2_x, y: riadok_init + riadok_offset, textID: 'INSTRUCTIONS_MINUS_USD52', align: 'center', anchX: 0.5, anchY: 0.5, fontSize: 19});
                ins15_table2.addChild(tab2_text_22);
                txtInstructionParagraphs.push(tab2_text_22);
        
                var tab2_text_23 = this.CreateInsText({x: stlpec2_x, y: riadok_init + riadok_offset * 2, textID: 'INSTRUCTIONS_PLUS_USD5', align: 'center', anchX: 0.5, anchY: 0.5, fontSize: 19});
                ins15_table2.addChild(tab2_text_23);
                txtInstructionParagraphs.push(tab2_text_23);
                // table2
        
                var ins16_text = this.CreateInsText({yOffsetFromPrevious: textsOffset, textID: 'INSTRUCTIONS_14b'});
                contentGroup.addChild(ins16_text);
                txtInstructionParagraphs.push(ins16_text);
        
                var ins17_text = this.CreateInsText({yOffsetFromPrevious: textsOffset, textID: 'INSTRUCTIONS_13'});
                contentGroup.addChild(ins17_text);
                txtInstructionParagraphs.push(ins17_text);
                */
        grpSceneInstructions.visible = false;

        this.onResolutionChange();

        game.input.onDown.add(this.instrClickDown, this);
        game.input.onUp.add(this.instrClickUp, this);
    },

    CreateInsText: function (paramsObj) {
        function getVal(dict, key, defVal) {
            if (dict[key] != undefined) return dict[key];
            return defVal;
        }

        var skipResMul = getVal(paramsObj, 'skipResMul', false);
        var xPos = getVal(paramsObj, 'x', game.width * 0.06);
        var yPos = getVal(paramsObj, 'y', 0);
        var text = STR(getVal(paramsObj, 'textID', ""));
        var wrapWidth = getVal(paramsObj, 'wrapWidth', game.width * 0.84);
        var fontSize = getVal(paramsObj, 'fontSize', 30);
        var align = getVal(paramsObj, 'align', 'left');
        var fill = getVal(paramsObj, 'fill', 0xFFFFFF);
        var anchX = getVal(paramsObj, 'anchX', 0);
        var anchY = getVal(paramsObj, 'anchY', 0);

        // var txtt = game.make.text(xPos, yPos, text, {font: fontSize + 'px gameFont', fill: fill, align: align, wordWrap: true, wordWrapWidth: wrapWidth});
        // txtt.paramsObj = paramsObj;
        // txtt.anchor.set(anchX, anchY);

        if (!skipResMul)
            fontSize = fontSize * game.width / 680;

        var txtt = gameState.CreateText(xPos, yPos, 'gamefont', '', fontSize);
        // var txtt = gameState.CreateTextWithWordWrap(xPos, yPos, 'gamefont', '', fontSize, game.width * 0.9);
        txtt.text = wordwrap(text, WRAP_CHARS);
        txtt.paramsObj = paramsObj;
        txtt.anchor.setTo(anchX, anchY);
        txtt.tint = fill;

        return txtt;
    },

    onResolutionChange: function () {
        imgInstructionsBG.width = game.width * 1.1;
        imgInstructionsBG.height = game.height * 1.1;
        imgInstructionsBG.position.setTo(0, 0);//game.width >> 1, game.height >> 1);

        imgInstructionsAnchor.scale.setTo(1 / imgInstructionsBG.scale.x, 1 / imgInstructionsBG.scale.y);

        itemH = game.height / 10;

        topBarInst.width = game.width * 1.1;
        topBarInst.height = itemH;
        topBarInst.itemAnchor.scale.setTo(1 / topBarInst.scale.x, 1 / topBarInst.scale.y);
        topBarInst.y = topBarInst.height / 2;
        topBarInst.x = game.width >> 1;

        this.exitBtn.position.set((game.width >> 1) - 12, -(this.exitBtn.height * 0.65))

        SceneInstructions.instance.updateSceneElementsVisibility();

        // console.log(ins12_table1.children);
        // var array = ins12_table1.children.map(function (text) {
        //     return text.fontSize;
        // })

        // // var minFontSize = Math.min(array);
        // var minFontSize = Math.min.apply(Math, array);
        // console.log(array, minFontSize);
        // for (var idx = 0; idx < ins12_table1.children.length; idx++) {
        //     // if (idx === 0 || idx === 6) continue;
        //     ins12_table1.children[idx].fontSize = minFontSize;
        // }
    },

    updateTexts: function () {
        topBarInst.txtCaption.text = STR(topBarInst.STR);

        for (var i = 0; i < txtInstructionParagraphs.length; i++) {
            wrapChars = WRAP_CHARS;
            if (Languages.instance.language == "ru" || Languages.instance.language.substring(0, 2) === "ru")
                wrapChars = Math.floor(WRAP_CHARS * 0.93);
            txtInstructionParagraphs[i].text = wordwrap(STR(txtInstructionParagraphs[i].paramsObj['textID']), wrapChars);
            // txtInstructionParagraphs[i].text = STR(txtInstructionParagraphs[i].paramsObj['textID']);
        }

        for (var c = 0; c < this.contentGroup.children.length; c++) {
            var child = this.contentGroup.getChildAt(c);

            if (c === 0) {
                child.y = 0;
            } else {
                child.y = this.contentGroup.getChildAt(c - 1).y + this.contentGroup.getChildAt(c - 1).height + child.paramsObj['yOffsetFromPrevious'];
            }
        }

        var l = this.contentGroup.children.length;
        this.contentGroup.totalHeight = this.contentGroup.getChildAt(l - 1).y + this.contentGroup.getChildAt(l - 1).height + 100;

        updateBitmapTextToWidth(tab1_text_12, 30, ins12_table1.width * 0.68 / ins12_table1.scale.x);
        updateBitmapTextToWidth(tab1_text_13, 30, ins12_table1.width * 0.68 / ins12_table1.scale.x);
        updateBitmapTextToWidth(tab1_text_14, 30, ins12_table1.width * 0.68 / ins12_table1.scale.x);
        updateBitmapTextToWidth(tab1_text_15, 30, ins12_table1.width * 0.68 / ins12_table1.scale.x);
        updateBitmapTextToWidth(tab1_text_16, 30, ins12_table1.width * 0.68 / ins12_table1.scale.x);

        
        var array = ins12_table1.children.map(function (text) {
            return text.fontSize;
        })

        // var minFontSize = Math.min(array);
        var minFontSize = Math.min.apply(Math, array);
        for (var idx = 0; idx < ins12_table1.children.length; idx++) {
            if (idx === 0 || idx === 6) continue;
            ins12_table1.children[idx].fontSize = minFontSize;
        }
    },

    update: function () {
        if (grpSceneInstructions.visible === false) return;

        if (this.contentMoveType !== null) {
            this.moveScreenContent();

        }

        if (gameState.wheelScrolled != 0) {
            if (gameState.wheelScrolled > 0 && gameState.wheelScrolled - 2 > 0) {
                gameState.wheelScrolled -= 2;
            } else if (gameState.wheelScrolled < 0 && gameState.wheelScrolled + 2 < 0) {
                gameState.wheelScrolled += 2;
            } else {
                gameState.wheelScrolled = 0;
            }

            this.moveScreenContent();
        }
    },

    moveScreenContent: function () {
        var dif = 0;
        var newY;

        if (this.contentMoveType === 0) {
            dif = game.input.activePointer.y - this.initClickY;
            newY = this.contentOriginY + dif;
        } else if (gameState.wheelScrolled !== 0) {
            dif = gameState.wheelScrolled;
            newY = this.contentGroup.y + dif;
            this.contentMoveType = null;
        }

        if (dif !== 0) {
            if (newY > this.contentGroup.topY) {
                this.contentGroup.y = this.contentGroup.topY;
            } else if (newY < 0 - this.contentGroup.totalHeight + game.height) {
                this.contentGroup.y = - this.contentGroup.totalHeight + game.height;
            } else {
                this.contentGroup.y = newY;
            }
        }

        SceneInstructions.instance.updateSceneElementsVisibility();
    },

    updateSceneElementsVisibility: function () {
        var cnt = 0;
        for (var i = 0; i < SceneInstructions.instance.contentGroup.length; i++) {
            var obj = SceneInstructions.instance.contentGroup.children[i];
            var bottom = obj.bottom + SceneInstructions.instance.contentGroup.y;
            var top = obj.top + SceneInstructions.instance.contentGroup.y;
            obj.visible = (bottom >= topBarInst.height) && (top <= game.height);
            if (!obj.visible) cnt++;
        }
        //LOG(cnt + '/' + SceneInstructions.instance.contentGroup.length);
    },

    instrClickDown: function (pointer) {
        if (grpSceneInstructions.visible === false) return;

        this.initClickY = pointer.y;

        this.contentOriginY = this.contentGroup.y;
        this.contentMoveType = 0;

    },

    instrClickUp: function (pointer) {
        if (grpSceneInstructions.visible === false) return;

        this.initClickY = null;
        this.contentMoveType = null;
    },

    ShowAnimated: function () {
        this.contentGroup.y = this.contentGroup.topY;
        gameState.wheelScrolled = 0;

        SceneInstructions.instance.onResolutionChange();
        SceneInstructions.instance.updateTexts();

        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
        ScenesTransitions.showSceneAlpha(grpSceneInstructions, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
    },

    HideAnimated: function () {
        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
        ScenesTransitions.hideSceneAlpha(grpSceneInstructions, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
    }
}