var SceneNoMoves = function () {
    SceneNoMoves.instance = this;

    this.create();
};

SceneNoMoves.instance = null;

SceneNoMoves.prototype = {

    create: function () {
        grpNoMoves = game.add.group();
        grpNoMoves.name = "grpNoMoves";
        this.grpScene = grpNoMoves;

        imgNoMovesOverlay = game.add.sprite(game.width >> 1, game.height >> 1, 'pak1', 'blank');
        imgNoMovesOverlay.anchor.setTo(0.5, 0.5);
        imgNoMovesOverlay.tint = 0x354854;
        imgNoMovesOverlay.alpha = 0.7;
        imgNoMovesOverlay.inputEnabled = true;
        grpNoMoves.addChild(imgNoMovesOverlay);

        imgNoMovesBar = game.add.sprite(game.width >> 1, 0, 'pak1', GetSelectedThemeAchievementBar());
        imgNoMovesBar.anchor.setTo(0.5, 0.5);
        grpNoMoves.addChild(imgNoMovesBar);

        txtNoMovesTxt = gameState.CreateText(0, -imgNoMovesOverlay.height / 6, 'gamefont', STR('OUT_OF_MOVES'), 35 * game.width / 680);
        txtNoMovesTxt.anchor.setTo(0.5, 0.5);
        txtNoMovesTxt.tint = 0x000000;
        grpNoMoves.addChild(txtNoMovesTxt);

        btnNoMovesRetry = (gameState.CreateImgButtonWithText(grpNoMoves, 'smallbutton', 'Retry', function () {
            soundManager.playSound('menu-click1');
            coinParticles.Reset();
            SceneGame.instance.RetryGame();
            SceneNoMoves.instance.HideAnimated();
            // SceneGameOver.instance.HideAnimated();
        }, 0x000000));
        grpNoMoves.addChild(btnNoMovesRetry);
        btnNoMovesRetry.scale.set(0.8);

        btnNoMovesHome = (gameState.CreateImgButtonWithText(grpNoMoves, 'smallbutton', 'Home', function () {
            soundManager.playSound('menu-click1');
            GameData.profile.savedMoved = 0;
            GameData.Save();
            gameRunning = false;

            coinParticles.Reset();
            SceneGame.instance.HideAnimated();
            // SceneGameOver.instance.HideAnimated();
            SceneNoMoves.instance.HideAnimated();

            SceneMenu.instance.onResolutionChange();
            SceneMenu.instance.ShowAnimated();

            selectedMenuButton = null;
            SceneMenu.instance.SelectMenuButtonAnimated(btnMenuButtons[2]);

        }, 0x000000));
        grpNoMoves.addChild(btnNoMovesHome);
        btnNoMovesHome.scale.set(0.8);

        grpNoMoves.visible = false;
    },

    onResolutionChange: function () {
        txtNoMovesTxt.text = STR('OUT_OF_MOVES').toUpperCase();
        updateScaleByWidth(txtNoMovesTxt, game.width * 0.95);

        btnNoMovesRetry.txtCaption.text = STR('RETRY');
        btnNoMovesHome.txtCaption.text = STR('HOME');

        updateBitmapTextToWidth(btnNoMovesRetry.txtCaption, 35, btnNoMovesRetry.width * 0.8 / btnNoMovesRetry.scale.x);
        updateBitmapTextToWidth(btnNoMovesHome.txtCaption, 35, btnNoMovesHome.width * 0.8 / btnNoMovesHome.scale.x);


        imgNoMovesOverlay.width = game.width * 1.1;
        imgNoMovesOverlay.height = game.height * 1.1;
        imgNoMovesOverlay.position.setTo(game.width >> 1, game.height >> 1);

        var itemH = game.height / 8;

        imgNoMovesBar.frameName = GetSelectedThemeAchievementBar();
        imgNoMovesBar.width = game.width * 1.1;
        imgNoMovesBar.height = itemH * 1.5;
        imgNoMovesBar.position.setTo(game.width >> 1, game.height - ingameButtons[0].height * 2.5);

        txtNoMovesTxt.position.setTo((game.width >> 1), imgNoMovesBar.y - imgNoMovesBar.height / 6);
        btnNoMovesRetry.position.x = ((game.width >> 1) - btnNoMovesRetry.width * 0.8);
        btnNoMovesRetry.position.y = (imgNoMovesBar.y + imgNoMovesBar.height / 6);
        btnNoMovesHome.position.setTo((game.width >> 1) + btnNoMovesRetry.width * 0.8, imgNoMovesBar.y + imgNoMovesBar.height / 6);
    },

    update: function () {
    },

    updateTexts: function () {
        txtNoMovesTxt.text = STR('OUT_OF_MOVES').toUpperCase();

        btnNoMovesRetry.txtCaption.text = STR(btnNoMovesRetry.str);
        btnNoMovesHome.txtCaption.text = STR(btnNoMovesHome.str);

        updateBitmapTextToWidth(btnNoMovesRetry.txtCaption, 35, btnNoMovesRetry.width * 0.9);
        updateBitmapTextToWidth(btnNoMovesHome.txtCaption, 35, btnNoMovesHome.width * 0.9);

    },

    ShowAnimated: function () {
        this.onResolutionChange();
        grpNoMoves.visible = true;
    },

    HideAnimated: function () {
        grpNoMoves.visible = false;
    }
}