var ScenePlay = function () {
    ScenePlay.instance = this;

    this.create();
};

ScenePlay.instance = null;

ScenePlay.prototype = {

    create: function () {
        grpScenePlay = game.add.group();
        grpScenePlay.name = "grpScenePlay";
        this.grpScene = grpScenePlay;

        imgPlayBG = grpScenePlay.create(game.width >> 1, game.height >> 1, 'bg');
        imgPlayBG.width = game.width * 1.1;
        imgPlayBG.height = game.height * 1.1;
        imgPlayBG.anchor.setTo(0.5);

        imgPlayLogo = game.add.sprite((game.width >> 1), (game.height >> 1) * 0.3, 'pak1', 'logo');
        imgPlayLogo.anchor.set(0.5);
        imgPlayLogo.scale.set(game.width / 680);
        grpScenePlay.add(imgPlayLogo);

        btnPlayGlow1 = game.add.sprite((game.width >> 1), (game.height >> 1), 'pak1', 'play');
        btnPlayGlow1.blendMode = PIXI.blendModes.ADD;
        btnPlayGlow1.alpha = 0.7;
        btnPlayGlow1.anchor.set(0.5);
        btnPlayGlow1.scale.set(game.width / 680 * 0.6);
        grpScenePlay.add(btnPlayGlow1);

        btnPlayGlow2 = game.add.sprite((game.width >> 1), (game.height >> 1), 'pak1', 'play');
        btnPlayGlow2.blendMode = PIXI.blendModes.ADD;
        btnPlayGlow2.alpha = 0.7;
        btnPlayGlow2.anchor.set(0.5);
        btnPlayGlow2.scale.set(game.width / 680 * 0.6);
        grpScenePlay.add(btnPlayGlow2);

        btnPlayGlow1.twnScale = game.add.tween(btnPlayGlow1.scale)
            .to({ x: 0.9, y: 0.9 }, ScenesTransitions.TRANSITION_LENGTH * 6, Phaser.Easing.Linear.In, false, 0, -1);
        btnPlayGlow1.twnAlpha = game.add.tween(btnPlayGlow1)
            .to({ alpha: 0 }, ScenesTransitions.TRANSITION_LENGTH * 6, Phaser.Easing.Linear.In, false, 0, -1);

        btnPlayGlow2.twnScale = game.add.tween(btnPlayGlow2.scale).to({
            x: 0.9,
            y: 0.9
        }, ScenesTransitions.TRANSITION_LENGTH * 6, Phaser.Easing.Linear.In, false, ScenesTransitions.TRANSITION_LENGTH * 3, -1);
        btnPlayGlow2.twnAlpha = game.add.tween(btnPlayGlow2)
            .to({ alpha: 0 }, ScenesTransitions.TRANSITION_LENGTH * 6, Phaser.Easing.Linear.In, false, ScenesTransitions.TRANSITION_LENGTH * 3, -1);

        btnPlayPlay = game.add.sprite((game.width >> 1), (game.height >> 1), 'pak1', 'play');
        btnPlayPlay.anchor.set(0.5);
        btnPlayPlay.scale.set(game.width / 680 * 0.6);
        grpScenePlay.add(btnPlayPlay);
        AddButtonEvents(btnPlayPlay, ScenePlay.instance.OnPressedPlay, ButtonOnInputOver, ButtonOnInputOut);

        imgPlayDrawOff = game.add.sprite((game.width >> 1), (game.height >> 1) * 0.7, 'pak1', 'drawoff');
        imgPlayDrawOff.anchor.set(0.5);
        imgPlayDrawOff.scale.set(game.width / 680 * 0.6);
        grpScenePlay.add(imgPlayDrawOff);

        imgPlayDraw1 = game.add.sprite(0, 0, 'pak1', 'draw1');
        imgPlayDraw1.anchor.setTo(1, 0.5);
        imgPlayDrawOff.addChild(imgPlayDraw1);

        // imgPlayDraw1Icon = game.add.sprite(-(imgPlayDraw1.width >> 1), 0, 'pak1', 'card1');
        // imgPlayDraw1Icon.anchor.setTo(0.5);
        // imgPlayDraw1.addChild(imgPlayDraw1Icon);

        // imgPlayDrawOff.txtCaption1 = gameState.CreateText(-imgPlayDraw1.width * 0.35, 0, 'gamefont', 'DRAW1', 50);
        // imgPlayDrawOff.txtCaption1.anchor.setTo(0.5, 0.5);
        // imgPlayDrawOff.txtCaption1.tint = 0x000000;
        // imgPlayDrawOff.addChild(imgPlayDrawOff.txtCaption1);

        imgPlayDraw3 = game.add.sprite(0, 0, 'pak1', 'draw3');
        imgPlayDraw3.anchor.setTo(0, 0.5);
        imgPlayDrawOff.addChild(imgPlayDraw3);
        imgPlayDraw3.visible = false;

        // imgPlayDraw3Icon = game.add.sprite(imgPlayDraw3.width >> 1, 0, 'pak1', 'card3');
        // imgPlayDraw3Icon.anchor.setTo(0.5);
        // imgPlayDraw3.addChild(imgPlayDraw3Icon);

        // imgPlayDrawOff.txtCaption2 = gameState.CreateText(imgPlayDraw1.width * 0.35, 0, 'gamefont', 'DRAW3', 50);
        // imgPlayDrawOff.txtCaption2.anchor.setTo(0.5, 0.5);
        // imgPlayDrawOff.txtCaption2.tint = 0x000000;
        // imgPlayDrawOff.addChild(imgPlayDrawOff.txtCaption2);

        grpPlayLeftDraw = game.add.group();
        grpScenePlay.add(grpPlayLeftDraw);

        imgPlayDraw1Icon = game.add.sprite(0, 0, 'pak1', 'card1');
        imgPlayDraw1Icon.scale.setTo(0.6);
        imgPlayDraw1Icon.anchor.setTo(0, 0.5);
        grpPlayLeftDraw.addChild(imgPlayDraw1Icon);

        txtDraw1 = gameState.CreateText(imgPlayDraw1Icon.width * 1.1, -5, 'gamefont', STR('DRAW_1'), 50);
        txtDraw1.anchor.setTo(0, 0.5);
        txtDraw1.tint = 0x000000;
        grpPlayLeftDraw.addChild(txtDraw1);


        grpPlayRightDraw = game.add.group();
        grpScenePlay.add(grpPlayRightDraw);

        imgPlayDraw3Icon = game.add.sprite(0, 0, 'pak1', 'card3');
        imgPlayDraw3Icon.scale.setTo(0.6);
        imgPlayDraw3Icon.anchor.setTo(0.5);
        grpPlayRightDraw.addChild(imgPlayDraw3Icon);

        txtDraw3 = gameState.CreateText(imgPlayDraw1Icon.width * 1.1, -5, 'gamefont', STR('DRAW_3'), 50);
        txtDraw3.anchor.setTo(0, 0.5);
        txtDraw3.tint = 0x000000;
        grpPlayRightDraw.addChild(txtDraw3);


        btnPlayDraw = game.add.sprite(0, 0, 'pak1', 'void');
        btnPlayDraw.anchor.setTo(0.5, 0.5);
        btnPlayDraw.width = imgPlayDrawOff.width / imgPlayDrawOff.scale.x;
        btnPlayDraw.height = imgPlayDrawOff.height / imgPlayDrawOff.scale.y;
        imgPlayDrawOff.addChild(btnPlayDraw);
        AddButtonEvents(btnPlayDraw, ScenePlay.instance.OnPressedPlayDraw, ButtonOnInputOver, ButtonOnInputOut);

        btnPlayQuit = game.add.sprite(game.width >> 1, game.height >> 1, 'pak1', 'quit');
        btnPlayQuit.anchor.setTo(0.5, 0.5);
        btnPlayQuit.scale.set(game.width / 680 * 0.7);
        AddButtonEvents(btnPlayQuit, function () {
            soundManager.playSound('menu-click1');
            /*gameRunning = true;
             ScenePause.instance.HideAnimated();
             SceneMenu.instance.HideAnimated();*/
            SceneMenu.instance.QuitGame();
        }, ButtonOnInputOver, ButtonOnInputOut);
        grpScenePlay.addChild(btnPlayQuit);
        btnPlayQuit.visible = (game.device.cocoonJS);

        //PPS_USE-SPILGAMES
        /*
        var spilLogo = null;
        var logoData = spilApiInstance.Branding.getLogo();
        if (logoData.image) {
            spilLogo = game.add.image(0, 0, 'spilLogoImg');
            spilLogo.inputEnabled = true;
            spilLogo.events.onInputUp.add(function (btn) {logoData.action();btn.tint = 0xFFFFFF;}, this);
            spilLogo.events.onInputOver.add(function(btn) {btn.tint = 0x999999;}, this);
            spilLogo.events.onInputOut.add(function(btn) {btn.tint = 0xFFFFFF;}, this);
            spilLogo.x = 10 + (spilLogo.width >> 1);
            spilLogo.y = 10 + (spilLogo.height >> 1);
            spilLogo.anchor.setTo(0.5);
        }
        grpScenePlay.add(spilLogo);

        var btn = grpScenePause.create(game.width >> 1, game.height  * 0.83, 'pak1', 'gombik2');
        btn.anchor.set(0.5);
        btn.STR = 'MORE_GAMES';
        btn.inputEnabled = true;

        var txtCaption = gameState.CreateText(0, -5, 'gamefont', STR('MORE_GAMES'), 28 * game.width / 680);
        txtCaption.anchor.setTo(0.5, 0.5);
        txtCaption.tint = 0xffffff;
        txtCaption.align = 'center';
        btn.addChild(txtCaption);
        btn.txtCaption = txtCaption;

        btn.height = game.height / 10;
        btn.scale.x = btn.scale.y;
        btn.txtCaption.scale.setTo(1 / btn.scale.x, 1 / btn.scale.y);


        btn.events.onInputUp.add(function (btn) {
            soundManager.playSound('menu-click1');
            var buttonProperties = spilApiInstance.Branding.getLink('more_games');
            buttonProperties.action();
            btn.tint = 0xFFFFFF;
        }, this);
        btn.events.onInputOver.add(function (btn) {
            btn.tint = 0x999999;
        }, this);
        btn.events.onInputOut.add(function (btn) {
            btn.tint = 0xFFFFFF;
        }, this);
        grpScenePlay.add(btn);

        //PPS_USE-SPILGAMES
        */

        grpScenePlay.visible = false;
    },

    OnPressedPlayDraw: function () {
        soundManager.playSound('menu-click1');

        if (game.input.x < game.width >> 1) {
            imgPlayDraw1.visible = true;
            imgPlayDraw3.visible = false;

            grpPlayLeftDraw.children[0].tint = 0x000000;
            grpPlayLeftDraw.children[1].tint = 0x000000;
            grpPlayRightDraw.children[0].tint = 0xB8B8B8;
            grpPlayRightDraw.children[1].tint = 0xB8B8B8;
        } else {
            imgPlayDraw1.visible = false;
            imgPlayDraw3.visible = true;

            grpPlayRightDraw.children[0].tint = 0x000000;
            grpPlayRightDraw.children[1].tint = 0x000000;
            grpPlayLeftDraw.children[0].tint = 0xB8B8B8;
            grpPlayLeftDraw.children[1].tint = 0xB8B8B8;
        }

        GameData.profile.Draw1 = imgPlayDraw1.visible;
        GameData.Save();
    },

    OnPressedPlay: function () {
        SceneGame.instance.onResolutionChange();
        SceneGame.instance.ResetGame();

        ScenePlay.instance.HideAnimated();
        SceneMenu.instance.HideAnimated();
        SceneGame.instance.ShowAnimated();
    },

    onResolutionChange: function () {
        ScenePlay.instance.RestartGlowTweens();

        imgPlayDraw1.visible = GameData.profile.Draw1;
        imgPlayDraw3.visible = !GameData.profile.Draw1;

        imgPlayBG.position.setTo(game.width >> 1, game.height >> 1);
        imgPlayBG.width = game.width * 1.1;
        imgPlayBG.height = game.height * 1.1;

        imgPlayLogo.position.setTo((game.width >> 1), (game.height >> 1) * 0.4);
        btnPlayGlow1.position.setTo((game.width >> 1), (game.height >> 1));
        btnPlayGlow2.position.setTo((game.width >> 1), (game.height >> 1));
        btnPlayPlay.position.setTo((game.width >> 1), (game.height >> 1));
        imgPlayDrawOff.position.setTo((game.width >> 1), (game.height >> 1) * 1.45);

        grpPlayLeftDraw.position.set(imgPlayDrawOff.position.x - (imgPlayDraw1.width * 0.5), imgPlayDrawOff.position.y)
        // grpPlayLeftDraw.children[1].fontSize = pauseButtons[0].txtCaption.fontSize;
        updateScaleByWidth(grpPlayLeftDraw, imgPlayDraw1.width * 0.5);

        grpPlayRightDraw.position.set(imgPlayDrawOff.position.x + (imgPlayDraw3.width * 0.1), imgPlayDrawOff.position.y)
        // grpPlayRightDraw.children[1].fontSize = pauseButtons[0].txtCaption.fontSize;
        updateScaleByWidth(grpPlayRightDraw, imgPlayDraw3.width * 0.5);

        var scale = Math.min(grpPlayLeftDraw.scale.x, grpPlayRightDraw.scale.x, grpPlayLeftDraw.scale.y, grpPlayRightDraw.scale.y)
        grpPlayLeftDraw.scale.set(scale);
        grpPlayRightDraw.scale.set(scale);

        if (imgPlayDraw1.visible) {
            grpPlayLeftDraw.children[0].tint = 0x000000;
            grpPlayLeftDraw.children[1].tint = 0x000000;
            grpPlayRightDraw.children[0].tint = 0xB8B8B8;
            grpPlayRightDraw.children[1].tint = 0xB8B8B8;
        } else {
            grpPlayRightDraw.children[0].tint = 0x000000;
            grpPlayRightDraw.children[1].tint = 0x000000;
            grpPlayLeftDraw.children[0].tint = 0xB8B8B8;
            grpPlayLeftDraw.children[1].tint = 0xB8B8B8;
        }

        btnPlayQuit.position.setTo(game.width - btnPlayQuit.width * 0.8, btnPlayQuit.width * 0.8);
    },

    RestartGlowTweens: function () {
        btnPlayGlow1.twnAlpha.stop();
        btnPlayGlow1.twnScale.stop();
        btnPlayGlow2.twnAlpha.stop();
        btnPlayGlow2.twnScale.stop();

        game.tweens.removeFrom(btnPlayGlow1, true);
        game.tweens.removeFrom(btnPlayGlow2, true);

        btnPlayGlow1.alpha = 0.7;
        btnPlayGlow1.scale.set(game.width / 680 * 0.6);

        btnPlayGlow2.alpha = 0.7;
        btnPlayGlow2.scale.set(game.width / 680 * 0.6);

        btnPlayGlow1.twnScale = game.add.tween(btnPlayGlow1.scale).to({
            x: game.width / 680 * 0.9,
            y: game.width / 680 * 0.9
        }, ScenesTransitions.TRANSITION_LENGTH / 0.18, Phaser.Easing.Linear.In, true, 0, -1);
        btnPlayGlow1.twnAlpha = game.add.tween(btnPlayGlow1)
            .to({ alpha: 0 }, ScenesTransitions.TRANSITION_LENGTH / 0.18, Phaser.Easing.Linear.In, true, 0, -1);

        btnPlayGlow2.twnScale = game.add.tween(btnPlayGlow2.scale).to({
            x: game.width / 680 * 0.9,
            y: game.width / 680 * 0.9
        }, ScenesTransitions.TRANSITION_LENGTH / 0.18, Phaser.Easing.Linear.In, true, ScenesTransitions.TRANSITION_LENGTH / 0.36, -1);
        btnPlayGlow2.twnAlpha = game.add.tween(btnPlayGlow2)
            .to({ alpha: 0 }, ScenesTransitions.TRANSITION_LENGTH / 0.18, Phaser.Easing.Linear.In, true, ScenesTransitions.TRANSITION_LENGTH / 0.36, -1);

    },

    update: function () {
    },

    updateTexts: function () {
        // imgPlayDrawOff.txtCaption1.text = STR('DRAW_1');
        // imgPlayDrawOff.txtCaption2.text = STR('DRAW_3');
    },

    HideAnimated: function () {
        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
        ScenesTransitions.hideSceneAlpha(grpScenePlay, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
    }

}