var SceneStatistics = function () {
    SceneStatistics.instance = this;

    this.create();
};

SceneStatistics.instance = null;

SceneStatistics.prototype = {

    create: function () {
        grpSceneStatistics = game.add.group();
        grpSceneStatistics.name = 'grpSceneStatistics';
        this.grpScene = grpSceneStatistics;

        imgStatisticsBG = grpSceneStatistics.create(game.width >> 1, game.height >> 1, 'bg');
        imgStatisticsBG.width = game.width;
        imgStatisticsBG.height = game.height;
        imgStatisticsBG.anchor.setTo(0.5);
        imgStatisticsBG.inputEnabled = true;

        topBarStatistics = gameState.CreateCaptionBar(grpSceneStatistics, 'MENU_STATISTICS');
        imgStatisticsCoinsHolder = gameState.CreateCoinsHolder(grpSceneStatistics, topBarStatistics);

        statisticsItems = [];

        statisticsItems.push(this.CreateStatisticsItem(0, '', 'DRAW_1', 'DRAW_3'));
        statisticsItems.push(this.CreateStatisticsItem(1, 'STATS_TOTAL_WINS', '0', '0'));
        statisticsItems.push(this.CreateStatisticsItem(0, 'STATS_TOTAL_GAMES', '0', '0'));
        statisticsItems.push(this.CreateStatisticsItem(1, 'STATS_BEST_SCORE', '0', '0'));
        statisticsItems.push(this.CreateStatisticsItem(0, 'STATS_LEAST_MOVES', '0', '0'));
        statisticsItems.push(this.CreateStatisticsItem(1, 'STATS_BEST_TIME', '00:00', '00:00'));
        statisticsItems.push(this.CreateStatisticsItem(0, 'STATS_MOST_MOVES', '0', '0'));
        statisticsItems.push(this.CreateStatisticsItem(1, 'STATS_UNDO_MOVES', '0', '0'));
        statisticsItems.push(this.CreateStatisticsItem(0, 'STATS_HINT_MOVES', '0', '0'));

        grpSceneStatistics.visible = false;
    },

    CreateStatisticsItem: function (col, STR1, STR2, STR3) {
        var statisticsItemBG = grpSceneStatistics.create(game.width >> 1, game.height >> 1, 'pak1', 'blank');
        statisticsItemBG.anchor.set(0.5);
        statisticsItemBG.width = game.width;
        statisticsItemBG.height = game.height / 8;
        // statisticsItemBG.tint = (col == 0) ? 0x3e89a6 : 0x34829e;
        statisticsItemBG.tint = (col == 0) ? 0xFFFFFF : 0x5A8E4D;
        statisticsItemBG.frameName = (col == 0) ? 'void' : 'blank';
        statisticsItemBG.inputEnabled = true;
        statisticsItemBG.STR1 = STR1;
        statisticsItemBG.STR2 = STR2;
        statisticsItemBG.STR3 = STR3;
        //'#3e89a6', '#34829e';

        var itemAnchor = grpSceneStatistics.create(0, 0, 'pak1', 'void');
        itemAnchor.anchor.set(0.5);
        statisticsItemBG.addChild(itemAnchor);

        var txtCaption = gameState.CreateText(game.width * 0.44, 0, 'gamefont', (STR1.length > 0) ? STR(STR1) : '', 45 * game.width / 680);
        txtCaption.anchor.setTo(0, 0.5);
        txtCaption.tint = 0xffffff;
        itemAnchor.addChild(txtCaption);

        var txtCol1 = gameState.CreateText(game.width * 0.44, 0, 'gamefont', STR(STR2), 45 * game.width / 680);
        txtCol1.anchor.setTo(0.5, 0.5);
        txtCol1.tint = 0xffffff;
        itemAnchor.addChild(txtCol1);

        var txtCol2 = gameState.CreateText(game.width * 0.44, 0, 'gamefont', STR(STR3), 45 * game.width / 680);
        txtCol2.anchor.setTo(0.5, 0.5);
        txtCol2.tint = 0xffffff;
        itemAnchor.addChild(txtCol2);

        statisticsItemBG.itemAnchor = itemAnchor;
        statisticsItemBG.txtCaption = txtCaption;
        statisticsItemBG.txtCol1 = txtCol1;
        statisticsItemBG.txtCol2 = txtCol2;

        return statisticsItemBG;
    },

    onResolutionChange: function () {
        imgStatisticsCoinsHolder.txtPrice.text = '' + GameData.profile.PlayerCoins;

        imgStatisticsBG.position.setTo(game.width >> 1, game.height >> 1);
        imgStatisticsBG.width = game.width * 1.1;
        imgStatisticsBG.height = game.height * 1.1;

        var itemGap = 5;
        var itemH = game.height * 0.1;

        topBarStatistics.width = game.width * 1.1;
        topBarStatistics.height = itemH;

        itemH = game.height / 12;

        topBarStatistics.itemAnchor.scale.setTo(1 / topBarStatistics.scale.x, 1 / topBarStatistics.scale.y);
        topBarStatistics.y = topBarStatistics.height / 2;

        var posY = topBarStatistics.height + ((itemGap + itemH) >> 2);

        for (var i = 0; i < statisticsItems.length; i++) {
            statisticsItems[i].width = game.width;
            statisticsItems[i].height = itemH;
            statisticsItems[i].y = posY;
            statisticsItems[i].itemAnchor.scale.setTo(1 / statisticsItems[i].scale.x, 1 / statisticsItems[i].scale.y);
            statisticsItems[i].txtCaption.x = - game.width / 2 + 15;
            statisticsItems[i].txtCol1.x = game.width * 0.2
            statisticsItems[i].txtCol2.x = game.width * 0.4

            updateBitmapTextToWidth(statisticsItems[i].txtCaption, 35 * game.width / 680, game.width * 0.57);
            updateBitmapTextToWidth(statisticsItems[i].txtCol1, 35 * game.width / 680, game.width * 0.15);
            updateBitmapTextToWidth(statisticsItems[i].txtCol2, 35 * game.width / 680, game.width * 0.15);

            posY += itemGap + itemH;
        }

        statisticsItems[1].txtCol1.text = '' + GameData.profile.TotalWinsD1;
        statisticsItems[1].txtCol2.text = '' + GameData.profile.TotalWinsD3;
        statisticsItems[2].txtCol1.text = '' + GameData.profile.TotalGamesD1;
        statisticsItems[2].txtCol2.text = '' + GameData.profile.TotalGamesD3;
        statisticsItems[3].txtCol1.text = '' + GameData.profile.BestScoreD1;
        statisticsItems[3].txtCol2.text = '' + GameData.profile.BestScoreD3;
        statisticsItems[4].txtCol1.text = '' + GameData.profile.LeastMovesD1;
        statisticsItems[4].txtCol2.text = '' + GameData.profile.LeastMovesD3;
        statisticsItems[5].txtCol1.text = '' + millisecondsToTimeStr(GameData.profile.BestTimeD1);
        statisticsItems[5].txtCol2.text = '' + millisecondsToTimeStr(GameData.profile.BestTimeD3);
        statisticsItems[6].txtCol1.text = '' + GameData.profile.MostMovesD1;
        statisticsItems[6].txtCol2.text = '' + GameData.profile.MostMovesD3;

        statisticsItems[7].txtCol1.text = '' + GameData.profile.undoCounterD1;
        statisticsItems[7].txtCol2.text = '' + GameData.profile.undoCounterD3;
        statisticsItems[8].txtCol1.text = '' + GameData.profile.hintCounterD1;
        statisticsItems[8].txtCol2.text = '' + GameData.profile.hintCounterD3;

        // updateTextToWidth(imgStatisticsCoinsHolder.children[1], 40 * game.width / 680, 'gameFont', (imgStatisticsCoinsHolder.width - imgStatisticsCoinsHolder.children[0].width));
        // updateTextToWidth(statisticsItems[7].txtCaption, 100, 'gameFont', game.width * 0.4);
        // updateTextToWidth(statisticsItems[8].txtCaption, 45 * game.width / 680, 'gameFont', game.width * 0.4);
        // console.log("FONT SIZE", statisticsItems[7].txtCaption.fontSize, statisticsItems[7].txtCol1.fontSize, statisticsItems[7].txtCol2.fontSize);
        // console.log("FONT SIZE", statisticsItems[8].txtCaption.fontSize, statisticsItems[8].txtCol1.fontSize, statisticsItems[8].txtCol2.fontSize);
        // console.log(statisticsItems[7].txtCaption.width, game.width * 0.4);
   
    },

    update: function () {

    },

    updateTexts: function () {
        topBarStatistics.txtCaption.text = STR(topBarStatistics.STR);

        statisticsItems[0].txtCol1.text = STR(statisticsItems[0].STR2).toUpperCase();
        statisticsItems[0].txtCol2.text = STR(statisticsItems[0].STR3).toUpperCase();

        for (var i = 1; i < statisticsItems.length; i++)
            statisticsItems[i].txtCaption.text = STR(statisticsItems[i].STR1);
    },

    ShowAnimated: function () {
        grpSceneStatistics.position.setTo(0, 0);
        SceneStatistics.instance.onResolutionChange();

        ScenesTransitions.transitionStarted();
        SceneStatistics.instance.UpdateLanguageButtons();
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Quadratic.Out;
        ScenesTransitions.showSceneAlpha(grpSceneStatistics, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
    },

    HideAnimated: function () {
        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
        ScenesTransitions.hideSceneAlpha(grpSceneStatistics, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);

        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
    }

}


