var SceneThemes = function () {
    SceneThemes.instance = this;

    this.create();
};

SceneThemes.instance = null;

SceneThemes.prototype = {

    create: function () {
        grpSceneThemes = game.add.group();
        grpSceneThemes.name = 'grpSceneThemes';
        this.grpScene = grpSceneThemes;

        imgThemesBG = grpSceneThemes.create(game.width >> 1, game.height >> 1, 'bg');
        imgThemesBG.width = game.width * 1.1;
        imgThemesBG.height = game.height * 1.1;
        imgThemesBG.anchor.setTo(0.5);
        imgThemesBG.inputEnabled = true;

        themesItems = [];

        topBarThemes = gameState.CreateCaptionBar(grpSceneThemes, 'MENU_THEMES');
        imgThemesCoinsHolder = gameState.CreateCoinsHolder(grpSceneThemes, topBarThemes);

        themesItems.push(this.CreateThemesItem('THEMES_CARD_FACES', ['tk1', 'tk2', 'tk3', 'tk4'], 'pak1', ['sipka-lava', 'sipka-prava'], 'CardFaces', 'UsedCardFace'));
        // themesItems.push(this.CreateThemesItem('THEMES_BACKS', ['tb1.png', 'tb2.png', 'tb3.png', 'tb4.png', 'tb5.png', 'tb5.png', 'tb5.png', 'tb5.png', 'tb5.png', 'tb5.png', 'tb5.png'], ['sipka-lava', 'sipka-prava'], 'CardBacks', 'UsedCardBack'));
        themesItems.push(this.CreateThemesItem('THEMES_BACKS', ['rub1', 'rub2', 'rub3', 'rub4', 'rub5', 'rub6', 'rub7', 'rub8', 'rub9', 'rub10', 'rub11'], 'game', ['sipka-lava', 'sipka-prava'], 'CardBacks', 'UsedCardBack'));
        // themesItems.push(this.CreateThemesItem('THEMES_BACKGROUND', ['vyberbg1.png', 'vyberbg2.png', 'vyberbg3.png', 'vyberbg4.png', 'vyberbg5.png'], ['sipka-tm-lava', 'sipka-tm-prava'], 'Backgrounds', 'UsedBackground'));

        grpSceneThemes.visible = false;
    },

    CreateThemesItem: function (str, imgs, imgPack, arrows, profileItems, selectedProfileItem) {
        var themesItemBG = grpSceneThemes.create(game.width >> 1, game.height >> 1, 'pak1', 'blank');
        themesItemBG.anchor.set(0.5);
        themesItemBG.width = game.width;
        themesItemBG.height = (game.height / 8) * 1.2;
        themesItemBG.tint = 0x5A8E4D;
        themesItemBG.inputEnabled = true;
        themesItemBG.imgs = imgs;
        themesItemBG.activeImgIdx = 0;
        themesItemBG.profileItems = profileItems;
        themesItemBG.selectedProfileItem = selectedProfileItem;
        themesItemBG.STR = str;

        var itemAnchor = grpSceneThemes.create(0, 0, 'pak1', 'void');
        itemAnchor.anchor.set(0.5);
        themesItemBG.addChild(itemAnchor);

        var itemImg = grpSceneThemes.create(0, 0, imgPack, imgs[0]);
        itemImg.anchor.setTo(0.5, 0.5);
        itemImg.scale.set(0.7 * game.width / 680);
        itemAnchor.addChild(itemImg);

        // if (imgPack === 'game') {
        //     itemImg.scale.set(0.5);
        //
        //     var leftImg = game.add.sprite(-(itemImg.width * 0.8), itemImg.height >> 3, 'game', imgs[0]);
        //     leftImg.anchor.setTo(0.5, 0.5);
        //     leftImg.angle = -25;
        //     // leftImg.scale.set(0.7);
        //     itemImg.addChild(leftImg);
        //
        //     var rightImg = game.add.sprite(itemImg.width * 0.8, itemImg.height >> 3, 'game', imgs[0]);
        //     rightImg.anchor.setTo(0.5, 0.5);
        //     rightImg.angle = 25;
        //     // rightImg.scale.set(0.7);
        //     itemImg.addChild(rightImg);
        //
        // }

        var txtCaption = gameState.CreateText(30, 0, 'gamefont', STR(str), 30 * game.width / 680);
        txtCaption.anchor.setTo(0.5);
        txtCaption.tint = 0x000000;
        itemAnchor.addChild(txtCaption);

        var itemArrowLeft = grpSceneThemes.create(0, 0, 'pak1', arrows[0]);
        itemArrowLeft.anchor.setTo(0.5, 0.5);
        itemArrowLeft.scale.set(game.width / 680 * 0.5);
        itemAnchor.addChild(itemArrowLeft);
        AddButtonEvents(itemArrowLeft, SceneThemes.instance.PrevImg, ButtonOnInputOver, ButtonOnInputOut);

        var itemArrowRight = grpSceneThemes.create(0, 0, 'pak1', arrows[1]);
        itemArrowRight.anchor.setTo(0.5, 0.5);
        itemArrowRight.scale.set(game.width / 680 * 0.5);
        itemAnchor.addChild(itemArrowRight);
        AddButtonEvents(itemArrowRight, SceneThemes.instance.NextImg, ButtonOnInputOver, ButtonOnInputOut);

        var itemButtonUse = grpSceneThemes.create(0, 0, 'pak1', 'smallbutton');
        itemButtonUse.anchor.setTo(0.5, 0.5);
        itemButtonUse.scale.set(game.width / 680 * 0.7);
        itemAnchor.addChild(itemButtonUse);
        AddButtonEvents(itemButtonUse, SceneThemes.instance.UseSelectedItem, ButtonOnInputOver, ButtonOnInputOut);

        var txtUse = gameState.CreateText(0, -5, 'gamefont', 'Use', 38);
        txtUse.anchor.setTo(0.5);
        txtUse.tint = 0x000000;
        txtUse.align = 'center';
        itemButtonUse.addChild(txtUse);

        var itemCoin = grpSceneThemes.create(40, 0, 'pak1', 'mincaB');
        itemCoin.anchor.setTo(0.5, 0.5);
        itemCoin.scale.set(0.5);
        itemButtonUse.addChild(itemCoin);

        var txtPrice = gameState.CreateText(5, -5, 'gamefont', '250', 38);
        txtPrice.anchor.setTo(1, 0.5);
        txtPrice.tint = 0x000000;
        itemButtonUse.addChild(txtPrice);

        themesItemBG.itemAnchor = itemAnchor;
        themesItemBG.itemImg = itemImg;
        themesItemBG.txtCaption = txtCaption;
        themesItemBG.itemArrowLeft = itemArrowLeft;
        themesItemBG.itemArrowRight = itemArrowRight;
        themesItemBG.itemButtonUse = itemButtonUse;
        themesItemBG.txtUse = txtUse;
        themesItemBG.txtPrice = txtPrice;
        themesItemBG.itemCoin = itemCoin;

        return themesItemBG;
    },

    PrevImg: function () {
        soundManager.playSound('menu-click1');

        var duration = ScenesTransitions.TRANSITION_LENGTH / 2;
        var item = this.button.parent.parent;
        var itemImg = item.itemImg;

        ScenesTransitions.transitionStarted();

        var tweenAlpha = game.add.tween(itemImg).to({ alpha: 0 }, duration * 0.8, Phaser.Easing.Linear.In, true);
        var tweenPosition = game.add.tween(itemImg.position)
            .to({ x: -game.width >> 1 }, duration, Phaser.Easing.Linear.In, true);
        tweenPosition.onComplete.add(function () {
            this.item.activeImgIdx--;
            if (this.item.activeImgIdx < 0) {
                this.item.activeImgIdx += this.item.imgs.length;
            }

            this.itemImg.frameName = this.item.imgs[this.item.activeImgIdx];
            this.itemImg.position.x = game.width >> 1;

            // if (this.itemImg.children.length > 0) {
            //     this.itemImg.children[0].frameName = this.item.imgs[this.item.activeImgIdx];
            //     this.itemImg.children[1].frameName = this.item.imgs[this.item.activeImgIdx];
            // }

            var tweenAlpha = game.add.tween(itemImg).to({ alpha: 1 }, duration * 0.8, Phaser.Easing.Linear.In, true);
            var tweenPosition = game.add.tween(itemImg.position).to({ x: 0 }, duration, Phaser.Easing.Linear.In, true);

            tweenPosition.onComplete.add(function () {
                SceneThemes.instance.UpdateUseButton(this.item);
                ScenesTransitions.transitionFinished();
            }, { item: this.item });
        }, { item: item, itemImg: itemImg });

        SceneThemes.instance.UpdateUseButton(item);
    },

    NextImg: function () {
        soundManager.playSound('menu-click1');

        var duration = ScenesTransitions.TRANSITION_LENGTH / 2;
        var item = this.button.parent.parent;
        var itemImg = item.itemImg;

        ScenesTransitions.transitionStarted();

        var tweenAlpha = game.add.tween(itemImg).to({ alpha: 0 }, duration * 0.8, Phaser.Easing.Linear.In, true);
        var tweenPosition = game.add.tween(itemImg.position)
            .to({ x: game.width >> 1 }, duration, Phaser.Easing.Linear.In, true);
        tweenPosition.onComplete.add(function () {
            this.item.activeImgIdx++;
            if (this.item.activeImgIdx >= this.item.imgs.length) {
                this.item.activeImgIdx -= this.item.imgs.length;
            }

            this.itemImg.frameName = this.item.imgs[this.item.activeImgIdx];
            this.itemImg.position.x = -game.width >> 1;

            // if (this.itemImg.children.length > 0) {
            //     this.itemImg.children[0].frameName = this.item.imgs[this.item.activeImgIdx];
            //     this.itemImg.children[1].frameName = this.item.imgs[this.item.activeImgIdx];
            // }

            var tweenAlpha = game.add.tween(itemImg).to({ alpha: 1 }, duration * 0.8, Phaser.Easing.Linear.In, true);
            var tweenPosition = game.add.tween(itemImg.position).to({ x: 0 }, duration, Phaser.Easing.Linear.In, true);

            tweenPosition.onComplete.add(function () {
                SceneThemes.instance.UpdateUseButton(this.item);
                ScenesTransitions.transitionFinished();
            }, { item: this.item });

        }, { item: item, itemImg: itemImg });

    },

    UpdateUseButton: function (item) {
        // console.log(item);

        var owned = GameData.profile[item.profileItems][item.activeImgIdx] == 0;
        var used = item.activeImgIdx == GameData.profile[item.selectedProfileItem];
        item.txtUse.visible = owned;
        item.txtUse.text = used ? STR('THEMES_IN_USE') : STR('THEMES_USE');
        item.txtPrice.text = '' + GameData.profile[item.profileItems][item.activeImgIdx];
        item.txtPrice.visible = !owned;
        item.itemCoin.visible = !owned;

        updateBitmapTextToWidth(item.txtUse, 38, item.itemButtonUse.width * 0.9);
    },

    UseSelectedItem: function () {
        soundManager.playSound('menu-click1');

        var item = this.button.parent.parent;
        var price = GameData.profile[item.profileItems][item.activeImgIdx];

        if (price == 0) {
            GameData.profile[item.selectedProfileItem] = item.activeImgIdx;
            SceneThemes.instance.UpdateUseButton(item);
            SceneThemes.instance.UpdateSelectedItems(item.profileItems);
            return;
        }

        if (GameData.profile.PlayerCoins < price) {
            return;
        }

        GameData.profile[item.profileItems][item.activeImgIdx] = 0;
        GameData.profile.PlayerCoins -= price;
        GameData.profile[item.selectedProfileItem] = item.activeImgIdx;
        GameData.Save();

        imgThemesCoinsHolder.txtPrice.text = '' + GameData.profile.PlayerCoins;
        SceneThemes.instance.UpdateUseButton(item);
        SceneThemes.instance.UpdateSelectedItems(item.profileItems);
    },

    UpdateSelectedItems: function (items) {
        if (items == 'CardBacks') {
            SceneGameOver.instance.ReloadCardBacks();
            SceneGame.instance.ReloadCardBacks();
        }

        if (items == 'CardFaces') {
            SceneGameOver.instance.ReloadCardFaces();
            SceneGame.instance.ReloadCardFaces();
        }
    },

    onResolutionChange: function () {
        imgThemesCoinsHolder.txtPrice.text = '' + GameData.profile.PlayerCoins;

        imgThemesBG.position.setTo(game.width >> 1, game.height >> 1);
        imgThemesBG.width = game.width * 1.1;
        imgThemesBG.height = game.height * 1.1;

        var itemH = game.height * 0.1;
        var itemGap = itemH;

        topBarThemes.width = game.width * 1.1;
        topBarThemes.height = itemH;
        topBarThemes.itemAnchor.scale.setTo(1 / topBarThemes.scale.x, 1 / topBarThemes.scale.y);
        topBarThemes.y = topBarThemes.height / 2;
        topBarThemes.x = game.width >> 1;

        var idx = themesItems.length - 1;
        themesItems[idx].itemImg.width = game.width;
        themesItems[idx].itemImg.scale.y = themesItems[idx].itemImg.scale.x;
        while (themesItems[idx].itemImg.height > game.height * 0.25)
            themesItems[idx].itemImg.scale.y -= 0.05;
        itemH = themesItems[idx].itemImg.height;

        // var posY = topBarThemes.height + itemH / 2 + itemGap;
        var posY = ((game.height - itemGap - itemH) >> 1);

        for (var i = 0; i < themesItems.length; i++) {
            themesItems[i].width = game.width;
            themesItems[i].height = itemH * 1.2;

            if (i < themesItems.length) {
                themesItems[i].itemImg.height = itemH * 0.7;
                themesItems[i].itemImg.scale.x = themesItems[i].itemImg.scale.y;
            }

            themesItems[i].y = posY;
            themesItems[i].itemAnchor.scale.setTo(1 / themesItems[i].scale.x, 1 / themesItems[i].scale.y);
            themesItems[i].txtCaption.x = 0;//-game.width / 2 + 30;// + game.width * 0.44;
            themesItems[i].txtCaption.y = -themesItems[i].height * 0.4;// + game.width * 0.44;
            themesItems[i].itemArrowLeft.x = -themesItems[i].width / 8 * 3;
            themesItems[i].itemArrowRight.x = themesItems[i].width / 8 * 3;
            themesItems[i].itemButtonUse.x = themesItems[i].width / 8 * 3;
            themesItems[i].itemButtonUse.y = themesItems[i].height / 2 * 0.6;

            SceneThemes.instance.UpdateUseButton(themesItems[i]);

            posY += itemGap + itemH;
        }

        // updateTextToWidth(imgThemesCoinsHolder.children[1], 40 * game.width / 680, 'gameFont', (imgThemesCoinsHolder.width - imgThemesCoinsHolder.children[0].width));
    },

    update: function () {

    },

    updateTexts: function () {
        topBarThemes.txtCaption.text = STR(topBarThemes.STR);

        for (var i = 0; i < themesItems.length; i++) {
            themesItems[i].txtCaption.text = STR(themesItems[i].STR);
            //updateBitmapTextToWidth(themesItems[i].txtCaption, 35, game.width * 0.3);
        }
    },

    ShowAnimated: function () {
        grpSceneThemes.position.setTo(0, 0);
        SceneThemes.instance.onResolutionChange();

        ScenesTransitions.transitionStarted();
        SceneThemes.instance.UpdateLanguageButtons();
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Quadratic.Out;
        ScenesTransitions.showSceneAlpha(grpSceneThemes, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
    },

    HideAnimated: function () {
        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
        ScenesTransitions.hideSceneAlpha(grpSceneThemes, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);

        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
    }

}


