var DESIRED_FPS = 45;

var GameState = function (game) { };

var gameState = null;

var particles = null;
var textParticles = null;
var coinParticles = null;

GameState.prototype = {

    preload: function () {
        //-RPLC:GAMESTATE_PRELOAD-//
    },

    create: function () {
        /*
        this.game.scale.scaleMode = Phaser.ScaleManager.EXACT_FIT;
        this.game.scale.pageAlignHorizontally = true;
        this.game.scale.pageAlignVertically = true;
        this.game.stage.backgroundColor = 0x224d6c;
        this.game.scale.refresh();
        this.game.canvas.screencanvas = false;
        */

        //game.add.plugin(Phaser.Plugin.Debug);
        game.input.maxPointers = 1;
        game.stage.backgroundColor = 0x051A2E;
        game.renderer.renderSession.roundPixels = true;
        //this.game.plugins.add(Phaser.Plugin.Debug);

        // SAVED_FPS = game.time.desiredFps;
        //if(!Phaser.Device.desktop){
        //game.time.advancedTiming = true;
        // game.time.desiredFps = DESIRED_FPS;
        // ScenesTransitions.TRANSITION_LENGTH = ScenesTransitions.TRANSITION_LENGTH / (60 / game.time.desiredFps);
        //}

        //game.time.slowMotion = 5;
        gameState = this;

        GameData.Load();

        soundManager = new SoundManager(game);
        soundManager.create();

        scenes = [];

        game.cache.addBitmapFontFromAtlas('gamefont_TA', 'pak1', 'gamefont_TA', 'gamefont_TA_xml', 'xml', 0, 0);
        game.cache.getBitmapFont('gamefont_TA').font.lineHeight = Math.floor(0.8 * game.cache.getBitmapFont('gamefont_TA').font.lineHeight);
        game.cache.addBitmapFontFromAtlas('gamefont_RU', 'pak1', 'gamefont_RU', 'gamefont_RU_xml', 'xml', 0, 0);
        game.cache.getBitmapFont('gamefont_RU').font.lineHeight = Math.floor(0.8 * game.cache.getBitmapFont('gamefont_RU').font.lineHeight);


        GAMEFONT = 'gamefont_TA';
        if (Languages.instance.language == 'ru' || Languages.instance.language.substring(0, 2) === "ru")
            GAMEFONT = 'gamefont_RU';

        scenes.push(new SceneGame());
        scenes.push(new ScenePlay());
        scenes.push(new ScenePause());
        scenes.push(new SceneOverlay());
        scenes.push(new SceneOptions());
        scenes.push(new SceneThemes());
        scenes.push(new SceneAchievements());
        scenes.push(new SceneStatistics());
        scenes.push(new SceneMenu());
        scenes.push(new SceneInstructions());
        scenes.push(new SceneAbout());
        scenes.push(new SceneDialog());
        scenes.push(new SceneGameOver());
        scenes.push(new SceneAchievementPopup());
        scenes.push(new SceneAutocomplete());
        scenes.push(new SceneNoMoves());

        //if(particles != null)
        //particles.Destroy();
        //particles = new Particles(grpSceneGame);

        if (coinParticles != null)
            coinParticles.Destroy();
        coinParticles = new CoinParticles(grpSceneGame);

        //we nneed this for bezier spline calculations
        tmpLine = new Phaser.Line(0, 0, 0, 0);
        tmpLineNormal1 = new Phaser.Line(0, 0, 0, 0);
        tmpLineNormal2 = new Phaser.Line(0, 0, 0, 0);
        tmpCircle1 = new Phaser.Circle(0, 0, 10);
        tmpCircle2 = new Phaser.Circle(0, 0, 10);

        /*
                if(textParticles != null)
                    textParticles.Destroy();
                textParticles = new TextParticles(grpSceneGame);
        */
        gameState.updateTexts();

        grpPrevLangScene = grpSceneGame;
        this.game.stage.backgroundColor = 0x000000;
        SceneMenu.instance.ShowAnimated(100);

        soundManager.playMusic('music_menu');

        game.onPause.add(this.onGamePause, this);
        game.onResume.add(this.onGameResume, this);


        //------------------------------------------------

        game.input.mouse.mouseWheelCallback = this.mouseWheelScrolled;
        game.input.mouse.callbackContext = this;

        /*     Cocoon.App.exitCallback(function(){
     
                 switch (this.game.state.current) {
     
                     case 'Tutorial':*/

        //PPS_USE-DEMO_VERSION
        /*
        var demoText = game.add.text(55, 57, "DEMO", {font:'40px "Arial Black"', fill:'#ffffff'});
        demoText.angle = 315;
        demoText.anchor.set(0.5);

        var demoText2 = game.add.text(game.width - 55, 57, "DEMO", {font:'40px "Arial Black"', fill:'#ffffff'});
        demoText2.angle = 45;
        demoText2.anchor.set(0.5);
        //PPS_USE-DEMO_VERSION
        */


        //PPS_USE-GAMETROVE
        /*
        var exitBtn = game.add.sprite(game.width - 50,43,'btnQuit');
        exitBtn.scale.set(0.7);
        exitBtn.anchor.set(0.5);
        AddButtonEvents(exitBtn, function () {window.history.back();}, ButtonOnInputOver, ButtonOnInputOut );
        // PPS_USE-GAMETROVE
        */

    },

    update: function () {
        // game.time.desiredFps = DESIRED_FPS;

        //console.log('!!![' + game.canvas.style.width + ', ' + game.canvas.style.height + '] [' + game.canvas.width + ', ' + game.canvas.height + ']');

        //LOG(JSON.stringify(game.canvas.style));

        //this.game.scale.resetCanvas(1200, 2400);
        //game.canvas.style.width = '680px';
        //game.canvas.style.width = '1200px';
        //game.canvas.style.cssText = "cocoonjs-scale: ScaleAspectFit";

        scenes.forEach(function (scene) {
            if (typeof scene.update === 'function')
                scene.update();
        });
    },

    mouseWheelScrolled: function () {
        if (game.input.mouse.wheelDelta === Phaser.Mouse.WHEEL_UP) {
            if (this.wheelScrolled > 0) {
                if (this.wheelScrolled < 50) this.wheelScrolled += 7;
            } else {
                this.wheelScrolled = 7;
            }
        } else {
            if (this.wheelScrolled < 0) {
                if (this.wheelScrolled > - 50) this.wheelScrolled -= 7;
            } else {
                this.wheelScrolled = - 7;
            }
        }
    },

    updateTexts: function () {
        scenes.forEach(function (scene) {
            if (typeof scene.updateTexts === 'function')
                scene.updateTexts();
        });
    },

    onResolutionChange: function () {
        scenes.forEach(function (scene) {
            if (typeof scene.onResolutionChange === 'function')
                scene.onResolutionChange();
        });
    },

    onGamePause: function () {
        if (game.device.desktop && game.device.chrome) {
            game.input.mspointer.stop();
        }

        scenes.forEach(function (scene) {
            if (typeof scene.onPause === 'function')
                scene.onPause();
        });
    },

    onGameResume: function () {
        if (game.device.desktop && game.device.chrome) {
            game.input.mspointer.stop();
        }

        scenes.forEach(function (scene) {
            if (typeof scene.onResume === 'function')
                scene.onResume();
        });
    },

    render: function () {
        if (typeof renderFunction === "function") {
            renderFunction();
        }
    },

    CreateCaptionBar: function (group, str) {
        var barBG = group.create(game.width >> 1, 0, 'pak1', 'hornybar');
        barBG.anchor.set(0.5);
        barBG.width = game.width * 1.1;
        barBG.STR = str;

        var itemAnchor = group.create(0, 0, 'pak1', 'void');
        itemAnchor.anchor.set(0.5);
        barBG.addChild(itemAnchor);
        barBG.itemAnchor = itemAnchor;

        if (STR.length > 0) {
            var txtCaption = gameState.CreateText(0, -game.width * 0.01, 'gamefont', STR(str), 40 * game.width / 680);
            // var txtCaption = game.add.text(0, -game.width * 0.01, STR(str), {font: 40 * game.width / 680 + 'px gamefont', fill: '#000000'});
            txtCaption.anchor.setTo(.5, 0.5);
            txtCaption.tint = 0x000000;
            itemAnchor.addChild(txtCaption);
            barBG.txtCaption = txtCaption;
        }

        return barBG;
    },

    CreateImgButtonWithText: function (group, img, str, callback, fontColor) {
        if (fontColor === undefined)
            fontColor = 0xffffff;

        var optionsButton = group.create(game.width >> 1, game.height >> 1, 'pak1', img);
        optionsButton.anchor.set(0.5);
        optionsButton.STR = str;

        var txtCaption = gameState.CreateText(0, -5, 'gamefont', STR(str), 28 * game.width / 680);
        // var txtCaption = game.add.text(0, -5, STR(str), {font: (28 * game.width / 680) + 'px gamefont', fill: 0xFFFFFF});
        txtCaption.anchor.setTo(0.5, 0.5);
        txtCaption.tint = fontColor;
        txtCaption.align = 'center';
        optionsButton.addChild(txtCaption);

        AddButtonEvents(optionsButton, callback, ButtonOnInputOver, ButtonOnInputOut);

        optionsButton.txtCaption = txtCaption;

        return optionsButton;
    },

    CreateCoinsHolder: function (group, topBar) {
        var imgCoinsBG = group.create(- (game.width >> 1) * 0.75, -10, 'pak1', 'podmince');
        imgCoinsBG.anchor.set(0.5);
        imgCoinsBG.scale.set(game.width / 680 * 0.8);
        topBar.itemAnchor.addChild(imgCoinsBG);

        var itemCoin = group.create(50, 0, 'pak1', 'mincaB');
        itemCoin.position.x -= itemCoin.width * 0.1;
        itemCoin.anchor.setTo(0.5);
        itemCoin.scale.set(0.5);
        imgCoinsBG.addChild(itemCoin);

        var txtPrice = gameState.CreateText(10, -3, 'gamefont', '250', 38);
        txtPrice.anchor.setTo(1, 0.5);
        txtPrice.tint = 0xffffff;
        imgCoinsBG.addChild(txtPrice);

        imgCoinsBG.itemCoin = itemCoin;
        imgCoinsBG.txtPrice = txtPrice;

        return imgCoinsBG;
    },

    UpdateCoinHolderValue: function (coinHolder) {
        coinHolder.txtPrice.text = '' + GameData.profile.PlayerCoins;
        updateBitmapTextToWidth(imgCoinsBG.txtPrice, 38, imgCoinsBG.width * 0.4);
    },

    MoveSpriteBezier: function (sprite, destX, destY, duration, delay, sign, callbackOnComplete, callbackOnCompleteParams) {
        //if (callbackOnComplete === undefined) callbackOnComplete = null;

        var tween = null;

        tmpLine.start.x = sprite.position.x;
        tmpLine.start.y = sprite.position.y;
        tmpLine.end.x = destX;
        tmpLine.end.y = destY;

        var coords = tmpLine.coordinatesOnLine(Math.floor((tmpLine.length / 5) + 0.5));
        LOG('coords.lenght = ' + coords.length);
        if (coords.length < 5) {
            coords[4] = [];
            coords[4][0] = coords[3][0];
            coords[4][1] = coords[3][1];
        }
        var p = coords[0];
        //var sign = (getRandomUInt(1000) <= 500) ? 1 : -1;
        tmpLineNormal1.fromAngle(coords[1][0], coords[1][1], tmpLine.normalAngle, (Math.floor(tmpLine.length / 4) + getRandomInt(10)) * sign);
        tmpLineNormal2.fromAngle(coords[4][0], coords[4][1], tmpLine.normalAngle, (Math.floor(tmpLine.length / 8) + getRandomInt(20)) * sign);

        tmpCircle1.x = tmpLineNormal1.end.x;
        tmpCircle1.y = tmpLineNormal1.end.y;
        tmpCircle2.x = tmpLineNormal2.end.x;
        tmpCircle2.y = tmpLineNormal2.end.y;


        var tmp1 = Math.floor(tmpLine.length / 4);
        var tmp2 = Math.floor(tmpLine.length / 8);

        var pointsArray = [];
        pointsArray[0] = { x: sprite.position.x, y: sprite.position.y };
        pointsArray[1] = { x: tmpLineNormal1.end.x, y: tmpLineNormal1.end.y };
        pointsArray[2] = { x: tmpLineNormal2.end.x, y: tmpLineNormal2.end.y };
        pointsArray[3] = { x: destX, y: destY };

        tween = game.add.tween(sprite.position).to({
            x: [pointsArray[0].x, pointsArray[1].x, pointsArray[2].x, pointsArray[3].x],
            y: [pointsArray[0].y, pointsArray[1].y, pointsArray[2].y, pointsArray[3].y]
        }, duration, Phaser.Easing.Quadratic.InOut, true, delay, 0).interpolation(function (v, k) {
            return Phaser.Math.bezierInterpolation(v, k);
        });

        sprite.twnMove = tween;

        if (callbackOnComplete != null)
            tween.onComplete.add(callbackOnComplete, callbackOnCompleteParams);
    },

    CreateText: function (x, y, font, str, size) {
        return game.add.bitmapText(x, y, GAMEFONT, str, size);
        // return game.add.text(x, y+5, str, {font: size + 'px ' + font, fill: '#ffffff'});
        // return game.add.text(x, y+5, str, {font: size + 'px consola', fill: '#ffffff'});
        //return game.add.sprite(x, y, 'pak1', 'void');
    },

    CreateTextWithWordWrap: function (x, y, font, str, size, maxWidth) {
        // return game.add.bitmapText(x, y, 'gamefont_TA', str, size);
        return game.add.text(x, y + 5, str, { font: size + 'px ' + font, fill: '#ffffff', wordWrap: true, wordWrapWidth: maxWidth });
        //return game.add.sprite(x, y, 'pak1', 'void');
    }
};
