/**
 * Created by echovanec on 10. 12. 2014.
 */

/** @constructor */
var Splash = function(game){};


Splash.prototype = {
    preload: function(){
        game = this.game;

        this.game.load.crossOrigin="Anonymous";

        game.canvas.id = 'gameCanvas';
        var gameCanvas = document.getElementById('gameCanvas');
        gameCanvas.style.position = 'fixed';

        loadSplash(this.game);

        //PPS_DELETE-DISABLE_ORIENTATION_CHECK
        if(!game.device.desktop)
            window.addEventListener("resize", function () {
                checkOrientation();
            });
        //PPS_DELETE-DISABLE_ORIENTATION_CHECK

        setCorrectResolution();

        //PPS_USE-CLOUDGAMES
        /*
        game.stage.disableVisibilityChange = true;
        //PPS_USE-CLOUDGAMES
        */

        window.addEventListener("resize", function () {
            game.scale.fullScreenScaleMode = Phaser.ScaleManager.SHOW_ALL;
            game.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
            game.scale.pageAlignHorizontally = true;
            game.scale.pageAlignVertically = true;
            game.scale.refresh();
        });

        //-RPLC:SPLASHSTATE_PRELOAD-//
    },

    create: function()
    {
        this.game.stage.backgroundColor = 0x000000;
        this.game.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
        this.game.stage.scaleMode = Phaser.ScaleManager.SHOW_ALL;
        this.game.scale.setShowAll();
        this.game.scale.pageAlignHorizontally = true;
        this.game.scale.pageAlignVertically = true;

        var logoImg = "inlogic_logo";

        //PPS_USE-CLOUDGAMES
        /*
        logoImg = "cloudApiImg";
        //PPS_USE-CLOUDGAMES
        */

        this.logo = this.game.add.sprite(this.game.world.centerX, this.game.world.centerY, logoImg);
        //PPS_USE-REMOVE_INIT_INLLOGO
        /*
        this.logo.loadTexture('sol_logo');
        this.logo.scale.set(0.7);
        //PPS_USE-REMOVE_INIT_INLLOGO
        */

        this.logo.anchor.setTo(0.5, 0.5);
        this.logo.alpha = 1;
        //PPS_USE-CLOUDGAMES
        /*
        this.logo.scale.set(0.65);
        this.logo.inputEnabled = true;
        this.logo.events.onInputDown.add(cloudGames_logo_link);
        //PPS_USE-CLOUDGAMES
        */
        // this.loadContinue();

        checkOrientation();
        this.startPreloadDelayed(Phaser.Timer.SECOND * 2);
    },

    startPreloadDelayed: function (time) {
        this.game.time.events.add(time, this.startPreload, this);
    },

    startPreload: function(){
        if (!game.device.desktop) {
            if (checkOrientation() == false) {
                this.startPreloadDelayed(Phaser.Timer.SECOND);
                return;
            }
        }
        setCorrectResolution();
        this.game.state.start("PreloadState");
    }

    // loadContinue: function ()
    // {
    //     this.logo.inputEnabled = true;
    //     this.logo.events.onInputDown.add(this.startPreload, this);
    //     this.startPreload();
    // },
    //
    // hideLogo: function () {
    //     game.add.tween(this.logo).to( { alpha : 0 }, ScenesTransitions.TRANSITION_LENGTH * 3, ANIMATION_CUBIC_IO, true, 0, 0, false);
    // },
    // startPreload: function()
    // {
    //     this.game.state.start("PreloadState");
    // }

};


function enterIncorrectOrientation()
{
    showDiv("wrongRotation");
    hideDiv("gameCanvas");
    game.onPause.dispatch();
}

function leaveIncorrectOrientation()
{
    hideDiv("wrongRotation");
    showDiv("gameCanvas");
    game.onResume.dispatch();
}

function checkOrientation() {

    if(game.device.desktop) return true;

    var correctOrientation = true;
    //PPS_DELETE-DISABLE_ORIENTATION_CHECK
    if (RUNNING_ON_IOS){
        if (document.documentElement.clientWidth > document.documentElement.clientHeight) {
            enterIncorrectOrientation();
            correctOrientation = false;
        } else {
            leaveIncorrectOrientation();
        }
    } else {
        if (window.innerWidth > window.innerHeight) {
            enterIncorrectOrientation();
            correctOrientation = false;
        } else {
            leaveIncorrectOrientation();
        }
    }
    //PPS_DELETE-DISABLE_ORIENTATION_CHECK

    return correctOrientation;
}


function setCorrectResolution() {
    var aspect = window.innerHeight / window.innerWidth;
    resolutionY = Math.floor(resolutionX * aspect);
    if(resolutionY > resolutionY_max) resolutionY = resolutionY_max;
    if(resolutionY < resolutionY_min) resolutionY = resolutionY_min;
    game.scale.setGameSize(resolutionX, resolutionY);
    game.scale.refresh();
}

//-RPLC:SPLASHSTATE_FILE_END-//
